using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath interface reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']"
	[Register ("com/skp/Tmap/TMapLayer", "", "Com.Skp.Tmap.ITMapLayerInvoker")]
	public partial interface ITMapLayer : IJavaObject {

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']/method[@name='destroyTMapLayer' and count(parameter)=0]"
		[Register ("destroyTMapLayer", "()V", "GetDestroyTMapLayerHandler:Com.Skp.Tmap.ITMapLayerInvoker, TmapBindTest")]
		void DestroyTMapLayer ();

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']/method[@name='draw' and count(parameter)=3 and parameter[1][@type='android.graphics.Canvas'] and parameter[2][@type='android.graphics.RectF'] and parameter[3][@type='boolean']]"
		[Register ("draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V", "GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler:Com.Skp.Tmap.ITMapLayerInvoker, TmapBindTest")]
		void Draw (global::Android.Graphics.Canvas p0, global::Android.Graphics.RectF p1, bool p2);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']/method[@name='drawInScreenPixels' and count(parameter)=0]"
		[Register ("drawInScreenPixels", "()Z", "GetDrawInScreenPixelsHandler:Com.Skp.Tmap.ITMapLayerInvoker, TmapBindTest")]
		bool DrawInScreenPixels ();

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']/method[@name='initLayer' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapView']]"
		[Register ("initLayer", "(Lcom/skp/Tmap/TMapView;)V", "GetInitLayer_Lcom_skp_Tmap_TMapView_Handler:Com.Skp.Tmap.ITMapLayerInvoker, TmapBindTest")]
		void InitLayer (global::Com.Skp.Tmap.TMapView p0);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']/method[@name='onLongPressEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onLongPressEvent", "(Landroid/graphics/PointF;)Z", "GetOnLongPressEvent_Landroid_graphics_PointF_Handler:Com.Skp.Tmap.ITMapLayerInvoker, TmapBindTest")]
		bool OnLongPressEvent (global::Android.Graphics.PointF p0);

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapLayer']/method[@name='onTouchEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onTouchEvent", "(Landroid/graphics/PointF;)Z", "GetOnTouchEvent_Landroid_graphics_PointF_Handler:Com.Skp.Tmap.ITMapLayerInvoker, TmapBindTest")]
		bool OnTouchEvent (global::Android.Graphics.PointF p0);

	}

	[global::Android.Runtime.Register ("com/skp/Tmap/TMapLayer", DoNotGenerateAcw=true)]
	internal class ITMapLayerInvoker : global::Java.Lang.Object, ITMapLayer {

		static IntPtr java_class_ref = JNIEnv.FindClass ("com/skp/Tmap/TMapLayer");

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (ITMapLayerInvoker); }
		}

		IntPtr class_ref;

		public static ITMapLayer GetObject (IntPtr handle, JniHandleOwnership transfer)
		{
			return global::Java.Lang.Object.GetObject<ITMapLayer> (handle, transfer);
		}

		static IntPtr Validate (IntPtr handle)
		{
			if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
				throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
							JNIEnv.GetClassNameFromInstance (handle), "com.skp.Tmap.TMapLayer"));
			return handle;
		}

		protected override void Dispose (bool disposing)
		{
			if (this.class_ref != IntPtr.Zero)
				JNIEnv.DeleteGlobalRef (this.class_ref);
			this.class_ref = IntPtr.Zero;
			base.Dispose (disposing);
		}

		public ITMapLayerInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
		{
			IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
			this.class_ref = JNIEnv.NewGlobalRef (local_ref);
			JNIEnv.DeleteLocalRef (local_ref);
		}

		static Delegate cb_destroyTMapLayer;
#pragma warning disable 0169
		static Delegate GetDestroyTMapLayerHandler ()
		{
			if (cb_destroyTMapLayer == null)
				cb_destroyTMapLayer = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_DestroyTMapLayer);
			return cb_destroyTMapLayer;
		}

		static void n_DestroyTMapLayer (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITMapLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITMapLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.DestroyTMapLayer ();
		}
#pragma warning restore 0169

		IntPtr id_destroyTMapLayer;
		public unsafe void DestroyTMapLayer ()
		{
			if (id_destroyTMapLayer == IntPtr.Zero)
				id_destroyTMapLayer = JNIEnv.GetMethodID (class_ref, "destroyTMapLayer", "()V");
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_destroyTMapLayer);
		}

		static Delegate cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
#pragma warning disable 0169
		static Delegate GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler ()
		{
			if (cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == null)
				cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr, bool>) n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z);
			return cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		}

		static void n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1, bool p2)
		{
			global::Com.Skp.Tmap.ITMapLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITMapLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Canvas p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Canvas> (native_p0, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.RectF p1 = global::Java.Lang.Object.GetObject<global::Android.Graphics.RectF> (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.Draw (p0, p1, p2);
		}
#pragma warning restore 0169

		IntPtr id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		public unsafe void Draw (global::Android.Graphics.Canvas p0, global::Android.Graphics.RectF p1, bool p2)
		{
			if (id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == IntPtr.Zero)
				id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNIEnv.GetMethodID (class_ref, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V");
			JValue* __args = stackalloc JValue [3];
			__args [0] = new JValue (p0);
			__args [1] = new JValue (p1);
			__args [2] = new JValue (p2);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z, __args);
		}

		static Delegate cb_drawInScreenPixels;
#pragma warning disable 0169
		static Delegate GetDrawInScreenPixelsHandler ()
		{
			if (cb_drawInScreenPixels == null)
				cb_drawInScreenPixels = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_DrawInScreenPixels);
			return cb_drawInScreenPixels;
		}

		static bool n_DrawInScreenPixels (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITMapLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITMapLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.DrawInScreenPixels ();
		}
#pragma warning restore 0169

		IntPtr id_drawInScreenPixels;
		public unsafe bool DrawInScreenPixels ()
		{
			if (id_drawInScreenPixels == IntPtr.Zero)
				id_drawInScreenPixels = JNIEnv.GetMethodID (class_ref, "drawInScreenPixels", "()Z");
			return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_drawInScreenPixels);
		}

		static Delegate cb_initLayer_Lcom_skp_Tmap_TMapView_;
#pragma warning disable 0169
		static Delegate GetInitLayer_Lcom_skp_Tmap_TMapView_Handler ()
		{
			if (cb_initLayer_Lcom_skp_Tmap_TMapView_ == null)
				cb_initLayer_Lcom_skp_Tmap_TMapView_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_InitLayer_Lcom_skp_Tmap_TMapView_);
			return cb_initLayer_Lcom_skp_Tmap_TMapView_;
		}

		static void n_InitLayer_Lcom_skp_Tmap_TMapView_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.ITMapLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITMapLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.TMapView p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapView> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.InitLayer (p0);
		}
#pragma warning restore 0169

		IntPtr id_initLayer_Lcom_skp_Tmap_TMapView_;
		public unsafe void InitLayer (global::Com.Skp.Tmap.TMapView p0)
		{
			if (id_initLayer_Lcom_skp_Tmap_TMapView_ == IntPtr.Zero)
				id_initLayer_Lcom_skp_Tmap_TMapView_ = JNIEnv.GetMethodID (class_ref, "initLayer", "(Lcom/skp/Tmap/TMapView;)V");
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (p0);
			JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_initLayer_Lcom_skp_Tmap_TMapView_, __args);
		}

		static Delegate cb_onLongPressEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnLongPressEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onLongPressEvent_Landroid_graphics_PointF_ == null)
				cb_onLongPressEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnLongPressEvent_Landroid_graphics_PointF_);
			return cb_onLongPressEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnLongPressEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.ITMapLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITMapLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnLongPressEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		IntPtr id_onLongPressEvent_Landroid_graphics_PointF_;
		public unsafe bool OnLongPressEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onLongPressEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onLongPressEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onLongPressEvent", "(Landroid/graphics/PointF;)Z");
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (p0);
			bool __ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onLongPressEvent_Landroid_graphics_PointF_, __args);
			return __ret;
		}

		static Delegate cb_onTouchEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnTouchEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onTouchEvent_Landroid_graphics_PointF_ == null)
				cb_onTouchEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnTouchEvent_Landroid_graphics_PointF_);
			return cb_onTouchEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnTouchEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.ITMapLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITMapLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnTouchEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		IntPtr id_onTouchEvent_Landroid_graphics_PointF_;
		public unsafe bool OnTouchEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onTouchEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onTouchEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onTouchEvent", "(Landroid/graphics/PointF;)Z");
			JValue* __args = stackalloc JValue [1];
			__args [0] = new JValue (p0);
			bool __ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onTouchEvent_Landroid_graphics_PointF_, __args);
			return __ret;
		}

	}

}
