using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath interface reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']"
	[Register ("com/skp/Tmap/ITileOrigin", "", "Com.Skp.Tmap.ITileOriginInvoker")]
	public partial interface ITileOrigin : IJavaObject {

		int BitDensityData {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getBitDensityData' and count(parameter)=0]"
			[Register ("getBitDensityData", "()I", "GetGetBitDensityDataHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		string FileName {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getFileName' and count(parameter)=0]"
			[Register ("getFileName", "()Ljava/lang/String;", "GetGetFileNameHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		bool IsTileDownLoad {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='isTileDownLoad' and count(parameter)=0]"
			[Register ("isTileDownLoad", "()Z", "GetIsTileDownLoadHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		global::Com.Skp.Tmap.MapUtils MapUtils {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getMapUtils' and count(parameter)=0]"
			[Register ("getMapUtils", "()Lcom/skp/Tmap/MapUtils;", "GetGetMapUtilsHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		int MaximumZoom {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getMaximumZoom' and count(parameter)=0]"
			[Register ("getMaximumZoom", "()I", "GetGetMaximumZoomHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		int MinimumZoom {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getMinimumZoom' and count(parameter)=0]"
			[Register ("getMinimumZoom", "()I", "GetGetMinimumZoomHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='setMinimumZoom' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("setMinimumZoom", "(I)V", "GetSetMinimumZoom_IHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] set;
		}

		string TileFormatData {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getTileFormatData' and count(parameter)=0]"
			[Register ("getTileFormatData", "()Ljava/lang/String;", "GetGetTileFormatDataHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		int TileSizeValue {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getTileSizeValue' and count(parameter)=0]"
			[Register ("getTileSizeValue", "()I", "GetGetTileSizeValueHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		int VIndexOrder {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getVIndexOrder' and count(parameter)=0]"
			[Register ("getVIndexOrder", "()I", "GetGetVIndexOrderHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")] get;
		}

		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='ITileOrigin']/method[@name='getUrlLoadData' and count(parameter)=3 and parameter[1][@type='int'] and parameter[2][@type='int'] and parameter[3][@type='int']]"
		[Register ("getUrlLoadData", "(III)Ljava/lang/String;", "GetGetUrlLoadData_IIIHandler:Com.Skp.Tmap.ITileOriginInvoker, TmapBindTest")]
		string GetUrlLoadData (int p0, int p1, int p2);

	}

	[global::Android.Runtime.Register ("com/skp/Tmap/ITileOrigin", DoNotGenerateAcw=true)]
	internal class ITileOriginInvoker : global::Java.Lang.Object, ITileOrigin {

		static IntPtr java_class_ref = JNIEnv.FindClass ("com/skp/Tmap/ITileOrigin");

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (ITileOriginInvoker); }
		}

		IntPtr class_ref;

		public static ITileOrigin GetObject (IntPtr handle, JniHandleOwnership transfer)
		{
			return global::Java.Lang.Object.GetObject<ITileOrigin> (handle, transfer);
		}

		static IntPtr Validate (IntPtr handle)
		{
			if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
				throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
							JNIEnv.GetClassNameFromInstance (handle), "com.skp.Tmap.ITileOrigin"));
			return handle;
		}

		protected override void Dispose (bool disposing)
		{
			if (this.class_ref != IntPtr.Zero)
				JNIEnv.DeleteGlobalRef (this.class_ref);
			this.class_ref = IntPtr.Zero;
			base.Dispose (disposing);
		}

		public ITileOriginInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
		{
			IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
			this.class_ref = JNIEnv.NewGlobalRef (local_ref);
			JNIEnv.DeleteLocalRef (local_ref);
		}

		static Delegate cb_getBitDensityData;
#pragma warning disable 0169
		static Delegate GetGetBitDensityDataHandler ()
		{
			if (cb_getBitDensityData == null)
				cb_getBitDensityData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetBitDensityData);
			return cb_getBitDensityData;
		}

		static int n_GetBitDensityData (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.BitDensityData;
		}
#pragma warning restore 0169

		IntPtr id_getBitDensityData;
		public unsafe int BitDensityData {
			get {
				if (id_getBitDensityData == IntPtr.Zero)
					id_getBitDensityData = JNIEnv.GetMethodID (class_ref, "getBitDensityData", "()I");
				return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getBitDensityData);
			}
		}

		static Delegate cb_getFileName;
#pragma warning disable 0169
		static Delegate GetGetFileNameHandler ()
		{
			if (cb_getFileName == null)
				cb_getFileName = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetFileName);
			return cb_getFileName;
		}

		static IntPtr n_GetFileName (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.FileName);
		}
#pragma warning restore 0169

		IntPtr id_getFileName;
		public unsafe string FileName {
			get {
				if (id_getFileName == IntPtr.Zero)
					id_getFileName = JNIEnv.GetMethodID (class_ref, "getFileName", "()Ljava/lang/String;");
				return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getFileName), JniHandleOwnership.TransferLocalRef);
			}
		}

		static Delegate cb_isTileDownLoad;
#pragma warning disable 0169
		static Delegate GetIsTileDownLoadHandler ()
		{
			if (cb_isTileDownLoad == null)
				cb_isTileDownLoad = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_IsTileDownLoad);
			return cb_isTileDownLoad;
		}

		static bool n_IsTileDownLoad (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.IsTileDownLoad;
		}
#pragma warning restore 0169

		IntPtr id_isTileDownLoad;
		public unsafe bool IsTileDownLoad {
			get {
				if (id_isTileDownLoad == IntPtr.Zero)
					id_isTileDownLoad = JNIEnv.GetMethodID (class_ref, "isTileDownLoad", "()Z");
				return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_isTileDownLoad);
			}
		}

		static Delegate cb_getMapUtils;
#pragma warning disable 0169
		static Delegate GetGetMapUtilsHandler ()
		{
			if (cb_getMapUtils == null)
				cb_getMapUtils = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetMapUtils);
			return cb_getMapUtils;
		}

		static IntPtr n_GetMapUtils (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.MapUtils);
		}
#pragma warning restore 0169

		IntPtr id_getMapUtils;
		public unsafe global::Com.Skp.Tmap.MapUtils MapUtils {
			get {
				if (id_getMapUtils == IntPtr.Zero)
					id_getMapUtils = JNIEnv.GetMethodID (class_ref, "getMapUtils", "()Lcom/skp/Tmap/MapUtils;");
				return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapUtils> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getMapUtils), JniHandleOwnership.TransferLocalRef);
			}
		}

		static Delegate cb_getMaximumZoom;
#pragma warning disable 0169
		static Delegate GetGetMaximumZoomHandler ()
		{
			if (cb_getMaximumZoom == null)
				cb_getMaximumZoom = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetMaximumZoom);
			return cb_getMaximumZoom;
		}

		static int n_GetMaximumZoom (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.MaximumZoom;
		}
#pragma warning restore 0169

		IntPtr id_getMaximumZoom;
		public unsafe int MaximumZoom {
			get {
				if (id_getMaximumZoom == IntPtr.Zero)
					id_getMaximumZoom = JNIEnv.GetMethodID (class_ref, "getMaximumZoom", "()I");
				return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getMaximumZoom);
			}
		}

		static Delegate cb_getMinimumZoom;
#pragma warning disable 0169
		static Delegate GetGetMinimumZoomHandler ()
		{
			if (cb_getMinimumZoom == null)
				cb_getMinimumZoom = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetMinimumZoom);
			return cb_getMinimumZoom;
		}

		static int n_GetMinimumZoom (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.MinimumZoom;
		}
#pragma warning restore 0169

		static Delegate cb_setMinimumZoom_I;
#pragma warning disable 0169
		static Delegate GetSetMinimumZoom_IHandler ()
		{
			if (cb_setMinimumZoom_I == null)
				cb_setMinimumZoom_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetMinimumZoom_I);
			return cb_setMinimumZoom_I;
		}

		static void n_SetMinimumZoom_I (IntPtr jnienv, IntPtr native__this, int p0)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.MinimumZoom = p0;
		}
#pragma warning restore 0169

		IntPtr id_getMinimumZoom;
		IntPtr id_setMinimumZoom_I;
		public unsafe int MinimumZoom {
			get {
				if (id_getMinimumZoom == IntPtr.Zero)
					id_getMinimumZoom = JNIEnv.GetMethodID (class_ref, "getMinimumZoom", "()I");
				return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getMinimumZoom);
			}
			set {
				if (id_setMinimumZoom_I == IntPtr.Zero)
					id_setMinimumZoom_I = JNIEnv.GetMethodID (class_ref, "setMinimumZoom", "(I)V");
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (value);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setMinimumZoom_I, __args);
			}
		}

		static Delegate cb_getTileFormatData;
#pragma warning disable 0169
		static Delegate GetGetTileFormatDataHandler ()
		{
			if (cb_getTileFormatData == null)
				cb_getTileFormatData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetTileFormatData);
			return cb_getTileFormatData;
		}

		static IntPtr n_GetTileFormatData (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.TileFormatData);
		}
#pragma warning restore 0169

		IntPtr id_getTileFormatData;
		public unsafe string TileFormatData {
			get {
				if (id_getTileFormatData == IntPtr.Zero)
					id_getTileFormatData = JNIEnv.GetMethodID (class_ref, "getTileFormatData", "()Ljava/lang/String;");
				return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getTileFormatData), JniHandleOwnership.TransferLocalRef);
			}
		}

		static Delegate cb_getTileSizeValue;
#pragma warning disable 0169
		static Delegate GetGetTileSizeValueHandler ()
		{
			if (cb_getTileSizeValue == null)
				cb_getTileSizeValue = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetTileSizeValue);
			return cb_getTileSizeValue;
		}

		static int n_GetTileSizeValue (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.TileSizeValue;
		}
#pragma warning restore 0169

		IntPtr id_getTileSizeValue;
		public unsafe int TileSizeValue {
			get {
				if (id_getTileSizeValue == IntPtr.Zero)
					id_getTileSizeValue = JNIEnv.GetMethodID (class_ref, "getTileSizeValue", "()I");
				return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getTileSizeValue);
			}
		}

		static Delegate cb_getVIndexOrder;
#pragma warning disable 0169
		static Delegate GetGetVIndexOrderHandler ()
		{
			if (cb_getVIndexOrder == null)
				cb_getVIndexOrder = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetVIndexOrder);
			return cb_getVIndexOrder;
		}

		static int n_GetVIndexOrder (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.VIndexOrder;
		}
#pragma warning restore 0169

		IntPtr id_getVIndexOrder;
		public unsafe int VIndexOrder {
			get {
				if (id_getVIndexOrder == IntPtr.Zero)
					id_getVIndexOrder = JNIEnv.GetMethodID (class_ref, "getVIndexOrder", "()I");
				return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getVIndexOrder);
			}
		}

		static Delegate cb_getUrlLoadData_III;
#pragma warning disable 0169
		static Delegate GetGetUrlLoadData_IIIHandler ()
		{
			if (cb_getUrlLoadData_III == null)
				cb_getUrlLoadData_III = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, int, int, IntPtr>) n_GetUrlLoadData_III);
			return cb_getUrlLoadData_III;
		}

		static IntPtr n_GetUrlLoadData_III (IntPtr jnienv, IntPtr native__this, int p0, int p1, int p2)
		{
			global::Com.Skp.Tmap.ITileOrigin __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.GetUrlLoadData (p0, p1, p2));
		}
#pragma warning restore 0169

		IntPtr id_getUrlLoadData_III;
		public unsafe string GetUrlLoadData (int p0, int p1, int p2)
		{
			if (id_getUrlLoadData_III == IntPtr.Zero)
				id_getUrlLoadData_III = JNIEnv.GetMethodID (class_ref, "getUrlLoadData", "(III)Ljava/lang/String;");
			JValue* __args = stackalloc JValue [3];
			__args [0] = new JValue (p0);
			__args [1] = new JValue (p1);
			__args [2] = new JValue (p2);
			return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getUrlLoadData_III, __args), JniHandleOwnership.TransferLocalRef);
		}

	}

}
