using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']"
	[global::Android.Runtime.Register ("com/skp/Tmap/MapTileDownloader", DoNotGenerateAcw=true)]
	public partial class MapTileDownloader : global::Java.Lang.Object {


		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/field[@name='TILE_DOWNLOAD_SECONDS_TO_WORK']"
		[Register ("TILE_DOWNLOAD_SECONDS_TO_WORK")]
		public const int TileDownloadSecondsToWork = (int) 25;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/field[@name='TILE_DOWNLOAD_THREADS']"
		[Register ("TILE_DOWNLOAD_THREADS")]
		public const int TileDownloadThreads = (int) 18;
		// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadFileWorker']"
		[global::Android.Runtime.Register ("com/skp/Tmap/MapTileDownloader$DownloadFileWorker", DoNotGenerateAcw=true)]
		public partial class DownloadFileWorker : global::Java.Lang.Object, global::Java.Lang.IComparable, global::Java.Lang.IRunnable {

			internal static new IntPtr java_class_handle;
			internal static new IntPtr class_ref {
				get {
					return JNIEnv.FindClass ("com/skp/Tmap/MapTileDownloader$DownloadFileWorker", ref java_class_handle);
				}
			}

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (DownloadFileWorker); }
			}

			protected DownloadFileWorker (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

			static Delegate cb_compareTo_Ljava_lang_Object_;
#pragma warning disable 0169
			static Delegate GetCompareTo_Ljava_lang_Object_Handler ()
			{
				if (cb_compareTo_Ljava_lang_Object_ == null)
					cb_compareTo_Ljava_lang_Object_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, int>) n_CompareTo_Ljava_lang_Object_);
				return cb_compareTo_Ljava_lang_Object_;
			}

			static int n_CompareTo_Ljava_lang_Object_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
			{
				global::Com.Skp.Tmap.MapTileDownloader.DownloadFileWorker __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.DownloadFileWorker> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				global::Java.Lang.Object p0 = global::Java.Lang.Object.GetObject<global::Java.Lang.Object> (native_p0, JniHandleOwnership.DoNotTransfer);
				int __ret = __this.CompareTo (p0);
				return __ret;
			}
#pragma warning restore 0169

			static IntPtr id_compareTo_Ljava_lang_Object_;
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadFileWorker']/method[@name='compareTo' and count(parameter)=1 and parameter[1][@type='java.lang.Object']]"
			[Register ("compareTo", "(Ljava/lang/Object;)I", "GetCompareTo_Ljava_lang_Object_Handler")]
			public virtual unsafe int CompareTo (global::Java.Lang.Object p0)
			{
				if (id_compareTo_Ljava_lang_Object_ == IntPtr.Zero)
					id_compareTo_Ljava_lang_Object_ = JNIEnv.GetMethodID (class_ref, "compareTo", "(Ljava/lang/Object;)I");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (p0);

					int __ret;
					if (((object) this).GetType () == ThresholdType)
						__ret = JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_compareTo_Ljava_lang_Object_, __args);
					else
						__ret = JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "compareTo", "(Ljava/lang/Object;)I"), __args);
					return __ret;
				} finally {
				}
			}

			static Delegate cb_run;
#pragma warning disable 0169
			static Delegate GetRunHandler ()
			{
				if (cb_run == null)
					cb_run = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Run);
				return cb_run;
			}

			static void n_Run (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.MapTileDownloader.DownloadFileWorker __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.DownloadFileWorker> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.Run ();
			}
#pragma warning restore 0169

			static IntPtr id_run;
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadFileWorker']/method[@name='run' and count(parameter)=0]"
			[Register ("run", "()V", "GetRunHandler")]
			public virtual unsafe void Run ()
			{
				if (id_run == IntPtr.Zero)
					id_run = JNIEnv.GetMethodID (class_ref, "run", "()V");
				try {

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_run);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "run", "()V"));
				} finally {
				}
			}

		}

		// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']"
		[global::Android.Runtime.Register ("com/skp/Tmap/MapTileDownloader$DownloadRequest", DoNotGenerateAcw=true)]
		public partial class DownloadRequest : global::Java.Lang.Object {


			static IntPtr error_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='error']"
			[Register ("error")]
			public bool Error {
				get {
					if (error_jfieldId == IntPtr.Zero)
						error_jfieldId = JNIEnv.GetFieldID (class_ref, "error", "Z");
					return JNIEnv.GetBooleanField (((global::Java.Lang.Object) this).Handle, error_jfieldId);
				}
				set {
					if (error_jfieldId == IntPtr.Zero)
						error_jfieldId = JNIEnv.GetFieldID (class_ref, "error", "Z");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, error_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr fileToSave_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='fileToSave']"
			[Register ("fileToSave")]
			public global::Android.Graphics.Bitmap FileToSave {
				get {
					if (fileToSave_jfieldId == IntPtr.Zero)
						fileToSave_jfieldId = JNIEnv.GetFieldID (class_ref, "fileToSave", "Landroid/graphics/Bitmap;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, fileToSave_jfieldId);
					return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (fileToSave_jfieldId == IntPtr.Zero)
						fileToSave_jfieldId = JNIEnv.GetFieldID (class_ref, "fileToSave", "Landroid/graphics/Bitmap;");
					IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, fileToSave_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr filepath_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='filepath']"
			[Register ("filepath")]
			public string Filepath {
				get {
					if (filepath_jfieldId == IntPtr.Zero)
						filepath_jfieldId = JNIEnv.GetFieldID (class_ref, "filepath", "Ljava/lang/String;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, filepath_jfieldId);
					return JNIEnv.GetString (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (filepath_jfieldId == IntPtr.Zero)
						filepath_jfieldId = JNIEnv.GetFieldID (class_ref, "filepath", "Ljava/lang/String;");
					IntPtr native_value = JNIEnv.NewString (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, filepath_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr matchzoom_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='matchzoom']"
			[Register ("matchzoom")]
			public bool Matchzoom {
				get {
					if (matchzoom_jfieldId == IntPtr.Zero)
						matchzoom_jfieldId = JNIEnv.GetFieldID (class_ref, "matchzoom", "Z");
					return JNIEnv.GetBooleanField (((global::Java.Lang.Object) this).Handle, matchzoom_jfieldId);
				}
				set {
					if (matchzoom_jfieldId == IntPtr.Zero)
						matchzoom_jfieldId = JNIEnv.GetFieldID (class_ref, "matchzoom", "Z");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, matchzoom_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr memoryErr_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='memoryErr']"
			[Register ("memoryErr")]
			public bool MemoryErr {
				get {
					if (memoryErr_jfieldId == IntPtr.Zero)
						memoryErr_jfieldId = JNIEnv.GetFieldID (class_ref, "memoryErr", "Z");
					return JNIEnv.GetBooleanField (((global::Java.Lang.Object) this).Handle, memoryErr_jfieldId);
				}
				set {
					if (memoryErr_jfieldId == IntPtr.Zero)
						memoryErr_jfieldId = JNIEnv.GetFieldID (class_ref, "memoryErr", "Z");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, memoryErr_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr retry_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='retry']"
			[Register ("retry")]
			public int Retry {
				get {
					if (retry_jfieldId == IntPtr.Zero)
						retry_jfieldId = JNIEnv.GetFieldID (class_ref, "retry", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, retry_jfieldId);
				}
				set {
					if (retry_jfieldId == IntPtr.Zero)
						retry_jfieldId = JNIEnv.GetFieldID (class_ref, "retry", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, retry_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr tileSource_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='tileSource']"
			[Register ("tileSource")]
			public global::Com.Skp.Tmap.ITileOrigin TileSource {
				get {
					if (tileSource_jfieldId == IntPtr.Zero)
						tileSource_jfieldId = JNIEnv.GetFieldID (class_ref, "tileSource", "Lcom/skp/Tmap/ITileOrigin;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, tileSource_jfieldId);
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (tileSource_jfieldId == IntPtr.Zero)
						tileSource_jfieldId = JNIEnv.GetFieldID (class_ref, "tileSource", "Lcom/skp/Tmap/ITileOrigin;");
					IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, tileSource_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr type_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='type']"
			[Register ("type")]
			public int Type {
				get {
					if (type_jfieldId == IntPtr.Zero)
						type_jfieldId = JNIEnv.GetFieldID (class_ref, "type", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, type_jfieldId);
				}
				set {
					if (type_jfieldId == IntPtr.Zero)
						type_jfieldId = JNIEnv.GetFieldID (class_ref, "type", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, type_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr url_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='url']"
			[Register ("url")]
			public string Url {
				get {
					if (url_jfieldId == IntPtr.Zero)
						url_jfieldId = JNIEnv.GetFieldID (class_ref, "url", "Ljava/lang/String;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, url_jfieldId);
					return JNIEnv.GetString (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (url_jfieldId == IntPtr.Zero)
						url_jfieldId = JNIEnv.GetFieldID (class_ref, "url", "Ljava/lang/String;");
					IntPtr native_value = JNIEnv.NewString (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, url_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr xTile_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='xTile']"
			[Register ("xTile")]
			public int XTile {
				get {
					if (xTile_jfieldId == IntPtr.Zero)
						xTile_jfieldId = JNIEnv.GetFieldID (class_ref, "xTile", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, xTile_jfieldId);
				}
				set {
					if (xTile_jfieldId == IntPtr.Zero)
						xTile_jfieldId = JNIEnv.GetFieldID (class_ref, "xTile", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, xTile_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr yTile_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='yTile']"
			[Register ("yTile")]
			public int YTile {
				get {
					if (yTile_jfieldId == IntPtr.Zero)
						yTile_jfieldId = JNIEnv.GetFieldID (class_ref, "yTile", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, yTile_jfieldId);
				}
				set {
					if (yTile_jfieldId == IntPtr.Zero)
						yTile_jfieldId = JNIEnv.GetFieldID (class_ref, "yTile", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, yTile_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr zoom_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/field[@name='zoom']"
			[Register ("zoom")]
			public int Zoom {
				get {
					if (zoom_jfieldId == IntPtr.Zero)
						zoom_jfieldId = JNIEnv.GetFieldID (class_ref, "zoom", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, zoom_jfieldId);
				}
				set {
					if (zoom_jfieldId == IntPtr.Zero)
						zoom_jfieldId = JNIEnv.GetFieldID (class_ref, "zoom", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, zoom_jfieldId, value);
					} finally {
					}
				}
			}
			internal static new IntPtr java_class_handle;
			internal static new IntPtr class_ref {
				get {
					return JNIEnv.FindClass ("com/skp/Tmap/MapTileDownloader$DownloadRequest", ref java_class_handle);
				}
			}

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (DownloadRequest); }
			}

			protected DownloadRequest (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

			static IntPtr id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_IIILcom_skp_Tmap_ITileOrigin_I;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/constructor[@name='MapTileDownloader.DownloadRequest' and count(parameter)=8 and parameter[1][@type='com.skp.Tmap.MapTileDownloader'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='android.graphics.Bitmap'] and parameter[4][@type='int'] and parameter[5][@type='int'] and parameter[6][@type='int'] and parameter[7][@type='com.skp.Tmap.ITileOrigin'] and parameter[8][@type='int']]"
			[Register (".ctor", "(Lcom/skp/Tmap/MapTileDownloader;Ljava/lang/String;Landroid/graphics/Bitmap;IIILcom/skp/Tmap/ITileOrigin;I)V", "")]
			public unsafe DownloadRequest (global::Com.Skp.Tmap.MapTileDownloader __self, string p1, global::Android.Graphics.Bitmap p2, int p3, int p4, int p5, global::Com.Skp.Tmap.ITileOrigin p6, int p7)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p1 = JNIEnv.NewString (p1);
				try {
					JValue* __args = stackalloc JValue [8];
					__args [0] = new JValue (__self);
					__args [1] = new JValue (native_p1);
					__args [2] = new JValue (p2);
					__args [3] = new JValue (p3);
					__args [4] = new JValue (p4);
					__args [5] = new JValue (p5);
					__args [6] = new JValue (p6);
					__args [7] = new JValue (p7);
					if (((object) this).GetType () != typeof (DownloadRequest)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(L" + global::Android.Runtime.JNIEnv.GetJniName (GetType ().DeclaringType) + ";Ljava/lang/String;Landroid/graphics/Bitmap;IIILcom/skp/Tmap/ITileOrigin;I)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(L" + global::Android.Runtime.JNIEnv.GetJniName (GetType ().DeclaringType) + ";Ljava/lang/String;Landroid/graphics/Bitmap;IIILcom/skp/Tmap/ITileOrigin;I)V", __args);
						return;
					}

					if (id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_IIILcom_skp_Tmap_ITileOrigin_I == IntPtr.Zero)
						id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_IIILcom_skp_Tmap_ITileOrigin_I = JNIEnv.GetMethodID (class_ref, "<init>", "(Lcom/skp/Tmap/MapTileDownloader;Ljava/lang/String;Landroid/graphics/Bitmap;IIILcom/skp/Tmap/ITileOrigin;I)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_IIILcom_skp_Tmap_ITileOrigin_I, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_IIILcom_skp_Tmap_ITileOrigin_I, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p1);
				}
			}

			static IntPtr id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_Lcom_skp_Tmap_ITileOrigin_I;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/constructor[@name='MapTileDownloader.DownloadRequest' and count(parameter)=5 and parameter[1][@type='com.skp.Tmap.MapTileDownloader'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='android.graphics.Bitmap'] and parameter[4][@type='com.skp.Tmap.ITileOrigin'] and parameter[5][@type='int']]"
			[Register (".ctor", "(Lcom/skp/Tmap/MapTileDownloader;Ljava/lang/String;Landroid/graphics/Bitmap;Lcom/skp/Tmap/ITileOrigin;I)V", "")]
			public unsafe DownloadRequest (global::Com.Skp.Tmap.MapTileDownloader __self, string p1, global::Android.Graphics.Bitmap p2, global::Com.Skp.Tmap.ITileOrigin p3, int p4)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p1 = JNIEnv.NewString (p1);
				try {
					JValue* __args = stackalloc JValue [5];
					__args [0] = new JValue (__self);
					__args [1] = new JValue (native_p1);
					__args [2] = new JValue (p2);
					__args [3] = new JValue (p3);
					__args [4] = new JValue (p4);
					if (((object) this).GetType () != typeof (DownloadRequest)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(L" + global::Android.Runtime.JNIEnv.GetJniName (GetType ().DeclaringType) + ";Ljava/lang/String;Landroid/graphics/Bitmap;Lcom/skp/Tmap/ITileOrigin;I)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(L" + global::Android.Runtime.JNIEnv.GetJniName (GetType ().DeclaringType) + ";Ljava/lang/String;Landroid/graphics/Bitmap;Lcom/skp/Tmap/ITileOrigin;I)V", __args);
						return;
					}

					if (id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_Lcom_skp_Tmap_ITileOrigin_I == IntPtr.Zero)
						id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_Lcom_skp_Tmap_ITileOrigin_I = JNIEnv.GetMethodID (class_ref, "<init>", "(Lcom/skp/Tmap/MapTileDownloader;Ljava/lang/String;Landroid/graphics/Bitmap;Lcom/skp/Tmap/ITileOrigin;I)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_Lcom_skp_Tmap_ITileOrigin_I, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_lang_String_Landroid_graphics_Bitmap_Lcom_skp_Tmap_ITileOrigin_I, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p1);
				}
			}

			static Delegate cb_setError_Z;
#pragma warning disable 0169
			static Delegate GetSetError_ZHandler ()
			{
				if (cb_setError_Z == null)
					cb_setError_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool>) n_SetError_Z);
				return cb_setError_Z;
			}

			static void n_SetError_Z (IntPtr jnienv, IntPtr native__this, bool p0)
			{
				global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.SetError (p0);
			}
#pragma warning restore 0169

			static IntPtr id_setError_Z;
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.DownloadRequest']/method[@name='setError' and count(parameter)=1 and parameter[1][@type='boolean']]"
			[Register ("setError", "(Z)V", "GetSetError_ZHandler")]
			public virtual unsafe void SetError (bool p0)
			{
				if (id_setError_Z == IntPtr.Zero)
					id_setError_Z = JNIEnv.GetMethodID (class_ref, "setError", "(Z)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (p0);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setError_Z, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setError", "(Z)V"), __args);
				} finally {
				}
			}

		}

		// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.FlushedInputStream']"
		[global::Android.Runtime.Register ("com/skp/Tmap/MapTileDownloader$FlushedInputStream", DoNotGenerateAcw=true)]
		public partial class FlushedInputStream : global::Java.IO.FilterInputStream {

			internal static new IntPtr java_class_handle;
			internal static new IntPtr class_ref {
				get {
					return JNIEnv.FindClass ("com/skp/Tmap/MapTileDownloader$FlushedInputStream", ref java_class_handle);
				}
			}

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (FlushedInputStream); }
			}

			protected FlushedInputStream (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

			static IntPtr id_ctor_Ljava_io_InputStream_;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.FlushedInputStream']/constructor[@name='MapTileDownloader.FlushedInputStream' and count(parameter)=1 and parameter[1][@type='java.io.InputStream']]"
			[Register (".ctor", "(Ljava/io/InputStream;)V", "")]
			public unsafe FlushedInputStream (global::System.IO.Stream p0)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p0 = global::Android.Runtime.InputStreamAdapter.ToLocalJniHandle (p0);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_p0);
					if (((object) this).GetType () != typeof (FlushedInputStream)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Ljava/io/InputStream;)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Ljava/io/InputStream;)V", __args);
						return;
					}

					if (id_ctor_Ljava_io_InputStream_ == IntPtr.Zero)
						id_ctor_Ljava_io_InputStream_ = JNIEnv.GetMethodID (class_ref, "<init>", "(Ljava/io/InputStream;)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Ljava_io_InputStream_, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Ljava_io_InputStream_, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p0);
				}
			}

		}

		// Metadata.xml XPath interface reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='MapTileDownloader.IMapDownloaderCallback']"
		[Register ("com/skp/Tmap/MapTileDownloader$IMapDownloaderCallback", "", "Com.Skp.Tmap.MapTileDownloader/IMapDownloaderCallbackInvoker")]
		public partial interface IMapDownloaderCallback : IJavaObject {

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='MapTileDownloader.IMapDownloaderCallback']/method[@name='tileDownloaded' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.MapTileDownloader.DownloadRequest']]"
			[Register ("tileDownloaded", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V", "GetTileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_Handler:Com.Skp.Tmap.MapTileDownloader/IMapDownloaderCallbackInvoker, TmapBindTest")]
			void TileDownloaded (global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0);

		}

		[global::Android.Runtime.Register ("com/skp/Tmap/MapTileDownloader$IMapDownloaderCallback", DoNotGenerateAcw=true)]
		internal class IMapDownloaderCallbackInvoker : global::Java.Lang.Object, IMapDownloaderCallback {

			static IntPtr java_class_ref = JNIEnv.FindClass ("com/skp/Tmap/MapTileDownloader$IMapDownloaderCallback");

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (IMapDownloaderCallbackInvoker); }
			}

			IntPtr class_ref;

			public static IMapDownloaderCallback GetObject (IntPtr handle, JniHandleOwnership transfer)
			{
				return global::Java.Lang.Object.GetObject<IMapDownloaderCallback> (handle, transfer);
			}

			static IntPtr Validate (IntPtr handle)
			{
				if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
					throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
								JNIEnv.GetClassNameFromInstance (handle), "com.skp.Tmap.MapTileDownloader.IMapDownloaderCallback"));
				return handle;
			}

			protected override void Dispose (bool disposing)
			{
				if (this.class_ref != IntPtr.Zero)
					JNIEnv.DeleteGlobalRef (this.class_ref);
				this.class_ref = IntPtr.Zero;
				base.Dispose (disposing);
			}

			public IMapDownloaderCallbackInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
			{
				IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
				this.class_ref = JNIEnv.NewGlobalRef (local_ref);
				JNIEnv.DeleteLocalRef (local_ref);
			}

			static Delegate cb_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
#pragma warning disable 0169
			static Delegate GetTileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_Handler ()
			{
				if (cb_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ == null)
					cb_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_TileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_);
				return cb_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
			}

			static void n_TileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
			{
				global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest> (native_p0, JniHandleOwnership.DoNotTransfer);
				__this.TileDownloaded (p0);
			}
#pragma warning restore 0169

			IntPtr id_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
			public unsafe void TileDownloaded (global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0)
			{
				if (id_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ == IntPtr.Zero)
					id_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ = JNIEnv.GetMethodID (class_ref, "tileDownloaded", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V");
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_tileDownloaded_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_, __args);
			}

		}


		// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.TileLoadDownloadRequest']"
		[global::Android.Runtime.Register ("com/skp/Tmap/MapTileDownloader$TileLoadDownloadRequest", DoNotGenerateAcw=true)]
		public partial class TileLoadDownloadRequest : global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest {


			static IntPtr dirWithTiles_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.TileLoadDownloadRequest']/field[@name='dirWithTiles']"
			[Register ("dirWithTiles")]
			public global::Java.IO.File DirWithTiles {
				get {
					if (dirWithTiles_jfieldId == IntPtr.Zero)
						dirWithTiles_jfieldId = JNIEnv.GetFieldID (class_ref, "dirWithTiles", "Ljava/io/File;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, dirWithTiles_jfieldId);
					return global::Java.Lang.Object.GetObject<global::Java.IO.File> (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (dirWithTiles_jfieldId == IntPtr.Zero)
						dirWithTiles_jfieldId = JNIEnv.GetFieldID (class_ref, "dirWithTiles", "Ljava/io/File;");
					IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, dirWithTiles_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr tileId_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.TileLoadDownloadRequest']/field[@name='tileId']"
			[Register ("tileId")]
			public string TileId {
				get {
					if (tileId_jfieldId == IntPtr.Zero)
						tileId_jfieldId = JNIEnv.GetFieldID (class_ref, "tileId", "Ljava/lang/String;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, tileId_jfieldId);
					return JNIEnv.GetString (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (tileId_jfieldId == IntPtr.Zero)
						tileId_jfieldId = JNIEnv.GetFieldID (class_ref, "tileId", "Ljava/lang/String;");
					IntPtr native_value = JNIEnv.NewString (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, tileId_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr tileSource_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.TileLoadDownloadRequest']/field[@name='tileSource']"
			[Register ("tileSource")]
			public global::Com.Skp.Tmap.ITileOrigin TileSource {
				get {
					if (tileSource_jfieldId == IntPtr.Zero)
						tileSource_jfieldId = JNIEnv.GetFieldID (class_ref, "tileSource", "Lcom/skp/Tmap/ITileOrigin;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, tileSource_jfieldId);
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.ITileOrigin> (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (tileSource_jfieldId == IntPtr.Zero)
						tileSource_jfieldId = JNIEnv.GetFieldID (class_ref, "tileSource", "Lcom/skp/Tmap/ITileOrigin;");
					IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, tileSource_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr type_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.TileLoadDownloadRequest']/field[@name='type']"
			[Register ("type")]
			public int Type {
				get {
					if (type_jfieldId == IntPtr.Zero)
						type_jfieldId = JNIEnv.GetFieldID (class_ref, "type", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, type_jfieldId);
				}
				set {
					if (type_jfieldId == IntPtr.Zero)
						type_jfieldId = JNIEnv.GetFieldID (class_ref, "type", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, type_jfieldId, value);
					} finally {
					}
				}
			}
			internal static new IntPtr java_class_handle;
			internal static new IntPtr class_ref {
				get {
					return JNIEnv.FindClass ("com/skp/Tmap/MapTileDownloader$TileLoadDownloadRequest", ref java_class_handle);
				}
			}

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (TileLoadDownloadRequest); }
			}

			protected TileLoadDownloadRequest (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

			static IntPtr id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_io_File_Ljava_lang_String_Landroid_graphics_Bitmap_Ljava_lang_String_Lcom_skp_Tmap_ITileOrigin_IIII;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader.TileLoadDownloadRequest']/constructor[@name='MapTileDownloader.TileLoadDownloadRequest' and count(parameter)=10 and parameter[1][@type='com.skp.Tmap.MapTileDownloader'] and parameter[2][@type='java.io.File'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='android.graphics.Bitmap'] and parameter[5][@type='java.lang.String'] and parameter[6][@type='com.skp.Tmap.ITileOrigin'] and parameter[7][@type='int'] and parameter[8][@type='int'] and parameter[9][@type='int'] and parameter[10][@type='int']]"
			[Register (".ctor", "(Lcom/skp/Tmap/MapTileDownloader;Ljava/io/File;Ljava/lang/String;Landroid/graphics/Bitmap;Ljava/lang/String;Lcom/skp/Tmap/ITileOrigin;IIII)V", "")]
			public unsafe TileLoadDownloadRequest (global::Com.Skp.Tmap.MapTileDownloader __self, global::Java.IO.File p1, string p2, global::Android.Graphics.Bitmap p3, string p4, global::Com.Skp.Tmap.ITileOrigin p5, int p6, int p7, int p8, int p9)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p2 = JNIEnv.NewString (p2);
				IntPtr native_p4 = JNIEnv.NewString (p4);
				try {
					JValue* __args = stackalloc JValue [10];
					__args [0] = new JValue (__self);
					__args [1] = new JValue (p1);
					__args [2] = new JValue (native_p2);
					__args [3] = new JValue (p3);
					__args [4] = new JValue (native_p4);
					__args [5] = new JValue (p5);
					__args [6] = new JValue (p6);
					__args [7] = new JValue (p7);
					__args [8] = new JValue (p8);
					__args [9] = new JValue (p9);
					if (((object) this).GetType () != typeof (TileLoadDownloadRequest)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(L" + global::Android.Runtime.JNIEnv.GetJniName (GetType ().DeclaringType) + ";Ljava/io/File;Ljava/lang/String;Landroid/graphics/Bitmap;Ljava/lang/String;Lcom/skp/Tmap/ITileOrigin;IIII)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(L" + global::Android.Runtime.JNIEnv.GetJniName (GetType ().DeclaringType) + ";Ljava/io/File;Ljava/lang/String;Landroid/graphics/Bitmap;Ljava/lang/String;Lcom/skp/Tmap/ITileOrigin;IIII)V", __args);
						return;
					}

					if (id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_io_File_Ljava_lang_String_Landroid_graphics_Bitmap_Ljava_lang_String_Lcom_skp_Tmap_ITileOrigin_IIII == IntPtr.Zero)
						id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_io_File_Ljava_lang_String_Landroid_graphics_Bitmap_Ljava_lang_String_Lcom_skp_Tmap_ITileOrigin_IIII = JNIEnv.GetMethodID (class_ref, "<init>", "(Lcom/skp/Tmap/MapTileDownloader;Ljava/io/File;Ljava/lang/String;Landroid/graphics/Bitmap;Ljava/lang/String;Lcom/skp/Tmap/ITileOrigin;IIII)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_io_File_Ljava_lang_String_Landroid_graphics_Bitmap_Ljava_lang_String_Lcom_skp_Tmap_ITileOrigin_IIII, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Lcom_skp_Tmap_MapTileDownloader_Ljava_io_File_Ljava_lang_String_Landroid_graphics_Bitmap_Ljava_lang_String_Lcom_skp_Tmap_ITileOrigin_IIII, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p2);
					JNIEnv.DeleteLocalRef (native_p4);
				}
			}

		}

		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/MapTileDownloader", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (MapTileDownloader); }
		}

		protected MapTileDownloader (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/constructor[@name='MapTileDownloader' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe MapTileDownloader ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				if (((object) this).GetType () != typeof (MapTileDownloader)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "()V"),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
					return;
				}

				if (id_ctor == IntPtr.Zero)
					id_ctor = JNIEnv.GetMethodID (class_ref, "<init>", "()V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor);
			} finally {
			}
		}

		static IntPtr id_ctor_I;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/constructor[@name='MapTileDownloader' and count(parameter)=1 and parameter[1][@type='int']]"
		[Register (".ctor", "(I)V", "")]
		public unsafe MapTileDownloader (int p0)
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				if (((object) this).GetType () != typeof (MapTileDownloader)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(I)V", __args),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(I)V", __args);
					return;
				}

				if (id_ctor_I == IntPtr.Zero)
					id_ctor_I = JNIEnv.GetMethodID (class_ref, "<init>", "(I)V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_I, __args),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_I, __args);
			} finally {
			}
		}

		static Delegate cb_getDownloaderMapCallback;
#pragma warning disable 0169
		static Delegate GetGetDownloaderMapCallbackHandler ()
		{
			if (cb_getDownloaderMapCallback == null)
				cb_getDownloaderMapCallback = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetDownloaderMapCallback);
			return cb_getDownloaderMapCallback;
		}

		static IntPtr n_GetDownloaderMapCallback (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return global::Android.Runtime.JavaList<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback>.ToLocalJniHandle (__this.DownloaderMapCallback);
		}
#pragma warning restore 0169

		static IntPtr id_getDownloaderMapCallback;
		public virtual unsafe global::System.Collections.Generic.IList<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback> DownloaderMapCallback {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='getDownloaderMapCallback' and count(parameter)=0]"
			[Register ("getDownloaderMapCallback", "()Ljava/util/List;", "GetGetDownloaderMapCallbackHandler")]
			get {
				if (id_getDownloaderMapCallback == IntPtr.Zero)
					id_getDownloaderMapCallback = JNIEnv.GetMethodID (class_ref, "getDownloaderMapCallback", "()Ljava/util/List;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Android.Runtime.JavaList<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback>.FromJniHandle (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getDownloaderMapCallback), JniHandleOwnership.TransferLocalRef);
					else
						return global::Android.Runtime.JavaList<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback>.FromJniHandle (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getDownloaderMapCallback", "()Ljava/util/List;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_isDownLoding;
#pragma warning disable 0169
		static Delegate GetIsDownLodingHandler ()
		{
			if (cb_isDownLoding == null)
				cb_isDownLoding = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_IsDownLoding);
			return cb_isDownLoding;
		}

		static bool n_IsDownLoding (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.IsDownLoding;
		}
#pragma warning restore 0169

		static IntPtr id_isDownLoding;
		public virtual unsafe bool IsDownLoding {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='isDownLoding' and count(parameter)=0]"
			[Register ("isDownLoding", "()Z", "GetIsDownLodingHandler")]
			get {
				if (id_isDownLoding == IntPtr.Zero)
					id_isDownLoding = JNIEnv.GetMethodID (class_ref, "isDownLoding", "()Z");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_isDownLoding);
					else
						return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "isDownLoding", "()Z"));
				} finally {
				}
			}
		}

		static Delegate cb_getRemainingCount;
#pragma warning disable 0169
		static Delegate GetGetRemainingCountHandler ()
		{
			if (cb_getRemainingCount == null)
				cb_getRemainingCount = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetRemainingCount);
			return cb_getRemainingCount;
		}

		static int n_GetRemainingCount (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.RemainingCount;
		}
#pragma warning restore 0169

		static IntPtr id_getRemainingCount;
		public virtual unsafe int RemainingCount {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='getRemainingCount' and count(parameter)=0]"
			[Register ("getRemainingCount", "()I", "GetGetRemainingCountHandler")]
			get {
				if (id_getRemainingCount == IntPtr.Zero)
					id_getRemainingCount = JNIEnv.GetMethodID (class_ref, "getRemainingCount", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getRemainingCount);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getRemainingCount", "()I"));
				} finally {
				}
			}
		}

		static Delegate cb_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_;
#pragma warning disable 0169
		static Delegate GetAddDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_Handler ()
		{
			if (cb_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ == null)
				cb_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_AddDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_);
			return cb_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_;
		}

		static void n_AddDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback p0 = (global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback)global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.AddDownloaderMapCallback (p0);
		}
#pragma warning restore 0169

		static IntPtr id_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='addDownloaderMapCallback' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.MapTileDownloader.IMapDownloaderCallback']]"
		[Register ("addDownloaderMapCallback", "(Lcom/skp/Tmap/MapTileDownloader$IMapDownloaderCallback;)V", "GetAddDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_Handler")]
		public virtual unsafe void AddDownloaderMapCallback (global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback p0)
		{
			if (id_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ == IntPtr.Zero)
				id_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ = JNIEnv.GetMethodID (class_ref, "addDownloaderMapCallback", "(Lcom/skp/Tmap/MapTileDownloader$IMapDownloaderCallback;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_addDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "addDownloaderMapCallback", "(Lcom/skp/Tmap/MapTileDownloader$IMapDownloaderCallback;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
#pragma warning disable 0169
		static Delegate GetInvokeDownloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_Handler ()
		{
			if (cb_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ == null)
				cb_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_InvokeDownloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_);
			return cb_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
		}

		static void n_InvokeDownloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.InvokeDownloadRequest (p0);
		}
#pragma warning restore 0169

		static IntPtr id_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='downloadRequest' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.MapTileDownloader.DownloadRequest']]"
		[Register ("downloadRequest", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V", "GetInvokeDownloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_Handler")]
		public virtual unsafe void InvokeDownloadRequest (global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0)
		{
			if (id_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ == IntPtr.Zero)
				id_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ = JNIEnv.GetMethodID (class_ref, "downloadRequest", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_downloadRequest_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "downloadRequest", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_isFileCurrentDownload_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetIsFileCurrentDownload_Ljava_lang_String_Handler ()
		{
			if (cb_isFileCurrentDownload_Ljava_lang_String_ == null)
				cb_isFileCurrentDownload_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_IsFileCurrentDownload_Ljava_lang_String_);
			return cb_isFileCurrentDownload_Ljava_lang_String_;
		}

		static bool n_IsFileCurrentDownload_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.IsFileCurrentDownload (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_isFileCurrentDownload_Ljava_lang_String_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='isFileCurrentDownload' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("isFileCurrentDownload", "(Ljava/lang/String;)Z", "GetIsFileCurrentDownload_Ljava_lang_String_Handler")]
		public virtual unsafe bool IsFileCurrentDownload (string p0)
		{
			if (id_isFileCurrentDownload_Ljava_lang_String_ == IntPtr.Zero)
				id_isFileCurrentDownload_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "isFileCurrentDownload", "(Ljava/lang/String;)Z");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (native_p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_isFileCurrentDownload_Ljava_lang_String_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "isFileCurrentDownload", "(Ljava/lang/String;)Z"), __args);
				return __ret;
			} finally {
				JNIEnv.DeleteLocalRef (native_p0);
			}
		}

		static Delegate cb_refuseAllPreviousDataRequests;
#pragma warning disable 0169
		static Delegate GetRefuseAllPreviousDataRequestsHandler ()
		{
			if (cb_refuseAllPreviousDataRequests == null)
				cb_refuseAllPreviousDataRequests = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_RefuseAllPreviousDataRequests);
			return cb_refuseAllPreviousDataRequests;
		}

		static void n_RefuseAllPreviousDataRequests (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RefuseAllPreviousDataRequests ();
		}
#pragma warning restore 0169

		static IntPtr id_refuseAllPreviousDataRequests;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='refuseAllPreviousDataRequests' and count(parameter)=0]"
		[Register ("refuseAllPreviousDataRequests", "()V", "GetRefuseAllPreviousDataRequestsHandler")]
		public virtual unsafe void RefuseAllPreviousDataRequests ()
		{
			if (id_refuseAllPreviousDataRequests == IntPtr.Zero)
				id_refuseAllPreviousDataRequests = JNIEnv.GetMethodID (class_ref, "refuseAllPreviousDataRequests", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_refuseAllPreviousDataRequests);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "refuseAllPreviousDataRequests", "()V"));
			} finally {
			}
		}

		static Delegate cb_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_;
#pragma warning disable 0169
		static Delegate GetRemoveDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_Handler ()
		{
			if (cb_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ == null)
				cb_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_RemoveDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_);
			return cb_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_;
		}

		static void n_RemoveDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback p0 = (global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback)global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.RemoveDownloaderMapCallback (p0);
		}
#pragma warning restore 0169

		static IntPtr id_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='removeDownloaderMapCallback' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.MapTileDownloader.IMapDownloaderCallback']]"
		[Register ("removeDownloaderMapCallback", "(Lcom/skp/Tmap/MapTileDownloader$IMapDownloaderCallback;)V", "GetRemoveDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_Handler")]
		public virtual unsafe void RemoveDownloaderMapCallback (global::Com.Skp.Tmap.MapTileDownloader.IMapDownloaderCallback p0)
		{
			if (id_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ == IntPtr.Zero)
				id_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_ = JNIEnv.GetMethodID (class_ref, "removeDownloaderMapCallback", "(Lcom/skp/Tmap/MapTileDownloader$IMapDownloaderCallback;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_removeDownloaderMapCallback_Lcom_skp_Tmap_MapTileDownloader_IMapDownloaderCallback_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "removeDownloaderMapCallback", "(Lcom/skp/Tmap/MapTileDownloader$IMapDownloaderCallback;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
#pragma warning disable 0169
		static Delegate GetRequestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_Handler ()
		{
			if (cb_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ == null)
				cb_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_RequestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_);
			return cb_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
		}

		static void n_RequestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.RequestToFileDownload (p0);
		}
#pragma warning restore 0169

		static IntPtr id_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='requestToFileDownload' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.MapTileDownloader.DownloadRequest']]"
		[Register ("requestToFileDownload", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V", "GetRequestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_Handler")]
		public virtual unsafe void RequestToFileDownload (global::Com.Skp.Tmap.MapTileDownloader.DownloadRequest p0)
		{
			if (id_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ == IntPtr.Zero)
				id_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_ = JNIEnv.GetMethodID (class_ref, "requestToFileDownload", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_requestToFileDownload_Lcom_skp_Tmap_MapTileDownloader_DownloadRequest_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "requestToFileDownload", "(Lcom/skp/Tmap/MapTileDownloader$DownloadRequest;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_threadPoolShutDown;
#pragma warning disable 0169
		static Delegate GetThreadPoolShutDownHandler ()
		{
			if (cb_threadPoolShutDown == null)
				cb_threadPoolShutDown = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_ThreadPoolShutDown);
			return cb_threadPoolShutDown;
		}

		static void n_ThreadPoolShutDown (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.MapTileDownloader __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapTileDownloader> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.ThreadPoolShutDown ();
		}
#pragma warning restore 0169

		static IntPtr id_threadPoolShutDown;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='MapTileDownloader']/method[@name='threadPoolShutDown' and count(parameter)=0]"
		[Register ("threadPoolShutDown", "()V", "GetThreadPoolShutDownHandler")]
		public virtual unsafe void ThreadPoolShutDown ()
		{
			if (id_threadPoolShutDown == IntPtr.Zero)
				id_threadPoolShutDown = JNIEnv.GetMethodID (class_ref, "threadPoolShutDown", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_threadPoolShutDown);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "threadPoolShutDown", "()V"));
			} finally {
			}
		}

	}
}
