using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']"
	[global::Android.Runtime.Register ("com/skp/Tmap/PointLocationLayer", DoNotGenerateAcw=true)]
	public partial class PointLocationLayer : global::Java.Lang.Object, global::Com.Skp.Tmap.ITMapLayer {


		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/field[@name='HEADING_ANGLE']"
		[Register ("HEADING_ANGLE")]
		protected const float HeadingAngle = (float) 60.000000;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/field[@name='HEADING_RADIUS']"
		[Register ("HEADING_RADIUS")]
		protected const int HeadingRadius = (int) 60;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/field[@name='RADIUS']"
		[Register ("RADIUS")]
		protected const int Radius = (int) 9;

		static IntPtr mLastKnownLocation_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/field[@name='mLastKnownLocation']"
		[Register ("mLastKnownLocation")]
		protected global::Android.Locations.Location MLastKnownLocation {
			get {
				if (mLastKnownLocation_jfieldId == IntPtr.Zero)
					mLastKnownLocation_jfieldId = JNIEnv.GetFieldID (class_ref, "mLastKnownLocation", "Landroid/location/Location;");
				IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, mLastKnownLocation_jfieldId);
				return global::Java.Lang.Object.GetObject<global::Android.Locations.Location> (__ret, JniHandleOwnership.TransferLocalRef);
			}
			set {
				if (mLastKnownLocation_jfieldId == IntPtr.Zero)
					mLastKnownLocation_jfieldId = JNIEnv.GetFieldID (class_ref, "mLastKnownLocation", "Landroid/location/Location;");
				IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mLastKnownLocation_jfieldId, native_value);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static IntPtr showIcon_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/field[@name='showIcon']"
		[Register ("showIcon")]
		public bool ShowIcon {
			get {
				if (showIcon_jfieldId == IntPtr.Zero)
					showIcon_jfieldId = JNIEnv.GetFieldID (class_ref, "showIcon", "Z");
				return JNIEnv.GetBooleanField (((global::Java.Lang.Object) this).Handle, showIcon_jfieldId);
			}
			set {
				if (showIcon_jfieldId == IntPtr.Zero)
					showIcon_jfieldId = JNIEnv.GetFieldID (class_ref, "showIcon", "Z");
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, showIcon_jfieldId, value);
				} finally {
				}
			}
		}

		static IntPtr showSight_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/field[@name='showSight']"
		[Register ("showSight")]
		public bool ShowSight {
			get {
				if (showSight_jfieldId == IntPtr.Zero)
					showSight_jfieldId = JNIEnv.GetFieldID (class_ref, "showSight", "Z");
				return JNIEnv.GetBooleanField (((global::Java.Lang.Object) this).Handle, showSight_jfieldId);
			}
			set {
				if (showSight_jfieldId == IntPtr.Zero)
					showSight_jfieldId = JNIEnv.GetFieldID (class_ref, "showSight", "Z");
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, showSight_jfieldId, value);
				} finally {
				}
			}
		}
		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/PointLocationLayer", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (PointLocationLayer); }
		}

		protected PointLocationLayer (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/constructor[@name='PointLocationLayer' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe PointLocationLayer ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				if (((object) this).GetType () != typeof (PointLocationLayer)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "()V"),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
					return;
				}

				if (id_ctor == IntPtr.Zero)
					id_ctor = JNIEnv.GetMethodID (class_ref, "<init>", "()V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor);
			} finally {
			}
		}

		static Delegate cb_getHeadingData;
#pragma warning disable 0169
		static Delegate GetGetHeadingDataHandler ()
		{
			if (cb_getHeadingData == null)
				cb_getHeadingData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetHeadingData);
			return cb_getHeadingData;
		}

		static IntPtr n_GetHeadingData (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.HeadingData);
		}
#pragma warning restore 0169

		static Delegate cb_setHeadingData_Ljava_lang_Float_;
#pragma warning disable 0169
		static Delegate GetSetHeadingData_Ljava_lang_Float_Handler ()
		{
			if (cb_setHeadingData_Ljava_lang_Float_ == null)
				cb_setHeadingData_Ljava_lang_Float_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetHeadingData_Ljava_lang_Float_);
			return cb_setHeadingData_Ljava_lang_Float_;
		}

		static void n_SetHeadingData_Ljava_lang_Float_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Java.Lang.Float p0 = global::Java.Lang.Object.GetObject<global::Java.Lang.Float> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.HeadingData = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getHeadingData;
		static IntPtr id_setHeadingData_Ljava_lang_Float_;
		public virtual unsafe global::Java.Lang.Float HeadingData {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='getHeadingData' and count(parameter)=0]"
			[Register ("getHeadingData", "()Ljava/lang/Float;", "GetGetHeadingDataHandler")]
			get {
				if (id_getHeadingData == IntPtr.Zero)
					id_getHeadingData = JNIEnv.GetMethodID (class_ref, "getHeadingData", "()Ljava/lang/Float;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Java.Lang.Float> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getHeadingData), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Java.Lang.Float> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getHeadingData", "()Ljava/lang/Float;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='setHeadingData' and count(parameter)=1 and parameter[1][@type='java.lang.Float']]"
			[Register ("setHeadingData", "(Ljava/lang/Float;)V", "GetSetHeadingData_Ljava_lang_Float_Handler")]
			set {
				if (id_setHeadingData_Ljava_lang_Float_ == IntPtr.Zero)
					id_setHeadingData_Ljava_lang_Float_ = JNIEnv.GetMethodID (class_ref, "setHeadingData", "(Ljava/lang/Float;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setHeadingData_Ljava_lang_Float_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setHeadingData", "(Ljava/lang/Float;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getLastLocation;
#pragma warning disable 0169
		static Delegate GetGetLastLocationHandler ()
		{
			if (cb_getLastLocation == null)
				cb_getLastLocation = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetLastLocation);
			return cb_getLastLocation;
		}

		static IntPtr n_GetLastLocation (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.LastLocation);
		}
#pragma warning restore 0169

		static Delegate cb_setLastLocation_Landroid_location_Location_;
#pragma warning disable 0169
		static Delegate GetSetLastLocation_Landroid_location_Location_Handler ()
		{
			if (cb_setLastLocation_Landroid_location_Location_ == null)
				cb_setLastLocation_Landroid_location_Location_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetLastLocation_Landroid_location_Location_);
			return cb_setLastLocation_Landroid_location_Location_;
		}

		static void n_SetLastLocation_Landroid_location_Location_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Locations.Location p0 = global::Java.Lang.Object.GetObject<global::Android.Locations.Location> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.LastLocation = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getLastLocation;
		static IntPtr id_setLastLocation_Landroid_location_Location_;
		public virtual unsafe global::Android.Locations.Location LastLocation {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='getLastLocation' and count(parameter)=0]"
			[Register ("getLastLocation", "()Landroid/location/Location;", "GetGetLastLocationHandler")]
			get {
				if (id_getLastLocation == IntPtr.Zero)
					id_getLastLocation = JNIEnv.GetMethodID (class_ref, "getLastLocation", "()Landroid/location/Location;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Locations.Location> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getLastLocation), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Locations.Location> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getLastLocation", "()Landroid/location/Location;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='setLastLocation' and count(parameter)=1 and parameter[1][@type='android.location.Location']]"
			[Register ("setLastLocation", "(Landroid/location/Location;)V", "GetSetLastLocation_Landroid_location_Location_Handler")]
			set {
				if (id_setLastLocation_Landroid_location_Location_ == IntPtr.Zero)
					id_setLastLocation_Landroid_location_Location_ = JNIEnv.GetMethodID (class_ref, "setLastLocation", "(Landroid/location/Location;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setLastLocation_Landroid_location_Location_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setLastLocation", "(Landroid/location/Location;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_destroyTMapLayer;
#pragma warning disable 0169
		static Delegate GetDestroyTMapLayerHandler ()
		{
			if (cb_destroyTMapLayer == null)
				cb_destroyTMapLayer = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_DestroyTMapLayer);
			return cb_destroyTMapLayer;
		}

		static void n_DestroyTMapLayer (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.DestroyTMapLayer ();
		}
#pragma warning restore 0169

		static IntPtr id_destroyTMapLayer;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='destroyTMapLayer' and count(parameter)=0]"
		[Register ("destroyTMapLayer", "()V", "GetDestroyTMapLayerHandler")]
		public virtual unsafe void DestroyTMapLayer ()
		{
			if (id_destroyTMapLayer == IntPtr.Zero)
				id_destroyTMapLayer = JNIEnv.GetMethodID (class_ref, "destroyTMapLayer", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_destroyTMapLayer);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "destroyTMapLayer", "()V"));
			} finally {
			}
		}

		static Delegate cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
#pragma warning disable 0169
		static Delegate GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler ()
		{
			if (cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == null)
				cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr, bool>) n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z);
			return cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		}

		static void n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1, bool p2)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Canvas p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Canvas> (native_p0, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.RectF p1 = global::Java.Lang.Object.GetObject<global::Android.Graphics.RectF> (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.Draw (p0, p1, p2);
		}
#pragma warning restore 0169

		static IntPtr id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='draw' and count(parameter)=3 and parameter[1][@type='android.graphics.Canvas'] and parameter[2][@type='android.graphics.RectF'] and parameter[3][@type='boolean']]"
		[Register ("draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V", "GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler")]
		public virtual unsafe void Draw (global::Android.Graphics.Canvas p0, global::Android.Graphics.RectF p1, bool p2)
		{
			if (id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == IntPtr.Zero)
				id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNIEnv.GetMethodID (class_ref, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V");
			try {
				JValue* __args = stackalloc JValue [3];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V"), __args);
			} finally {
			}
		}

		static Delegate cb_drawInScreenPixels;
#pragma warning disable 0169
		static Delegate GetDrawInScreenPixelsHandler ()
		{
			if (cb_drawInScreenPixels == null)
				cb_drawInScreenPixels = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_DrawInScreenPixels);
			return cb_drawInScreenPixels;
		}

		static bool n_DrawInScreenPixels (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.DrawInScreenPixels ();
		}
#pragma warning restore 0169

		static IntPtr id_drawInScreenPixels;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='drawInScreenPixels' and count(parameter)=0]"
		[Register ("drawInScreenPixels", "()Z", "GetDrawInScreenPixelsHandler")]
		public virtual unsafe bool DrawInScreenPixels ()
		{
			if (id_drawInScreenPixels == IntPtr.Zero)
				id_drawInScreenPixels = JNIEnv.GetMethodID (class_ref, "drawInScreenPixels", "()Z");
			try {

				if (((object) this).GetType () == ThresholdType)
					return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_drawInScreenPixels);
				else
					return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "drawInScreenPixels", "()Z"));
			} finally {
			}
		}

		static Delegate cb_initLayer_Lcom_skp_Tmap_TMapView_;
#pragma warning disable 0169
		static Delegate GetInitLayer_Lcom_skp_Tmap_TMapView_Handler ()
		{
			if (cb_initLayer_Lcom_skp_Tmap_TMapView_ == null)
				cb_initLayer_Lcom_skp_Tmap_TMapView_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_InitLayer_Lcom_skp_Tmap_TMapView_);
			return cb_initLayer_Lcom_skp_Tmap_TMapView_;
		}

		static void n_InitLayer_Lcom_skp_Tmap_TMapView_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.TMapView p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapView> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.InitLayer (p0);
		}
#pragma warning restore 0169

		static IntPtr id_initLayer_Lcom_skp_Tmap_TMapView_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='initLayer' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapView']]"
		[Register ("initLayer", "(Lcom/skp/Tmap/TMapView;)V", "GetInitLayer_Lcom_skp_Tmap_TMapView_Handler")]
		public virtual unsafe void InitLayer (global::Com.Skp.Tmap.TMapView p0)
		{
			if (id_initLayer_Lcom_skp_Tmap_TMapView_ == IntPtr.Zero)
				id_initLayer_Lcom_skp_Tmap_TMapView_ = JNIEnv.GetMethodID (class_ref, "initLayer", "(Lcom/skp/Tmap/TMapView;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_initLayer_Lcom_skp_Tmap_TMapView_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "initLayer", "(Lcom/skp/Tmap/TMapView;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_isLocationVisibleCheck_Landroid_location_Location_;
#pragma warning disable 0169
		static Delegate GetIsLocationVisibleCheck_Landroid_location_Location_Handler ()
		{
			if (cb_isLocationVisibleCheck_Landroid_location_Location_ == null)
				cb_isLocationVisibleCheck_Landroid_location_Location_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_IsLocationVisibleCheck_Landroid_location_Location_);
			return cb_isLocationVisibleCheck_Landroid_location_Location_;
		}

		static bool n_IsLocationVisibleCheck_Landroid_location_Location_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Locations.Location p0 = global::Java.Lang.Object.GetObject<global::Android.Locations.Location> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.IsLocationVisibleCheck (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_isLocationVisibleCheck_Landroid_location_Location_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='isLocationVisibleCheck' and count(parameter)=1 and parameter[1][@type='android.location.Location']]"
		[Register ("isLocationVisibleCheck", "(Landroid/location/Location;)Z", "GetIsLocationVisibleCheck_Landroid_location_Location_Handler")]
		public virtual unsafe bool IsLocationVisibleCheck (global::Android.Locations.Location p0)
		{
			if (id_isLocationVisibleCheck_Landroid_location_Location_ == IntPtr.Zero)
				id_isLocationVisibleCheck_Landroid_location_Location_ = JNIEnv.GetMethodID (class_ref, "isLocationVisibleCheck", "(Landroid/location/Location;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_isLocationVisibleCheck_Landroid_location_Location_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "isLocationVisibleCheck", "(Landroid/location/Location;)Z"), __args);
				return __ret;
			} finally {
			}
		}

		static Delegate cb_onLongPressEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnLongPressEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onLongPressEvent_Landroid_graphics_PointF_ == null)
				cb_onLongPressEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnLongPressEvent_Landroid_graphics_PointF_);
			return cb_onLongPressEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnLongPressEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnLongPressEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_onLongPressEvent_Landroid_graphics_PointF_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='onLongPressEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onLongPressEvent", "(Landroid/graphics/PointF;)Z", "GetOnLongPressEvent_Landroid_graphics_PointF_Handler")]
		public virtual unsafe bool OnLongPressEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onLongPressEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onLongPressEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onLongPressEvent", "(Landroid/graphics/PointF;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onLongPressEvent_Landroid_graphics_PointF_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "onLongPressEvent", "(Landroid/graphics/PointF;)Z"), __args);
				return __ret;
			} finally {
			}
		}

		static Delegate cb_onTouchEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnTouchEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onTouchEvent_Landroid_graphics_PointF_ == null)
				cb_onTouchEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnTouchEvent_Landroid_graphics_PointF_);
			return cb_onTouchEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnTouchEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnTouchEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_onTouchEvent_Landroid_graphics_PointF_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='onTouchEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onTouchEvent", "(Landroid/graphics/PointF;)Z", "GetOnTouchEvent_Landroid_graphics_PointF_Handler")]
		public virtual unsafe bool OnTouchEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onTouchEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onTouchEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onTouchEvent", "(Landroid/graphics/PointF;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onTouchEvent_Landroid_graphics_PointF_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "onTouchEvent", "(Landroid/graphics/PointF;)Z"), __args);
				return __ret;
			} finally {
			}
		}

		static Delegate cb_setIcon_Landroid_graphics_Bitmap_;
#pragma warning disable 0169
		static Delegate GetSetIcon_Landroid_graphics_Bitmap_Handler ()
		{
			if (cb_setIcon_Landroid_graphics_Bitmap_ == null)
				cb_setIcon_Landroid_graphics_Bitmap_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetIcon_Landroid_graphics_Bitmap_);
			return cb_setIcon_Landroid_graphics_Bitmap_;
		}

		static void n_SetIcon_Landroid_graphics_Bitmap_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.PointLocationLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.PointLocationLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.SetIcon (p0);
		}
#pragma warning restore 0169

		static IntPtr id_setIcon_Landroid_graphics_Bitmap_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='PointLocationLayer']/method[@name='setIcon' and count(parameter)=1 and parameter[1][@type='android.graphics.Bitmap']]"
		[Register ("setIcon", "(Landroid/graphics/Bitmap;)V", "GetSetIcon_Landroid_graphics_Bitmap_Handler")]
		public virtual unsafe void SetIcon (global::Android.Graphics.Bitmap p0)
		{
			if (id_setIcon_Landroid_graphics_Bitmap_ == IntPtr.Zero)
				id_setIcon_Landroid_graphics_Bitmap_ = JNIEnv.GetMethodID (class_ref, "setIcon", "(Landroid/graphics/Bitmap;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setIcon_Landroid_graphics_Bitmap_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setIcon", "(Landroid/graphics/Bitmap;)V"), __args);
			} finally {
			}
		}

	}
}
