using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']"
	[global::Android.Runtime.Register ("com/skp/Tmap/TMapCircle", DoNotGenerateAcw=true)]
	public partial class TMapCircle : global::Java.Lang.Object {


		static IntPtr latitude_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/field[@name='latitude']"
		[Register ("latitude")]
		public double Latitude {
			get {
				if (latitude_jfieldId == IntPtr.Zero)
					latitude_jfieldId = JNIEnv.GetFieldID (class_ref, "latitude", "D");
				return JNIEnv.GetDoubleField (((global::Java.Lang.Object) this).Handle, latitude_jfieldId);
			}
			set {
				if (latitude_jfieldId == IntPtr.Zero)
					latitude_jfieldId = JNIEnv.GetFieldID (class_ref, "latitude", "D");
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, latitude_jfieldId, value);
				} finally {
				}
			}
		}

		static IntPtr longitude_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/field[@name='longitude']"
		[Register ("longitude")]
		public double Longitude {
			get {
				if (longitude_jfieldId == IntPtr.Zero)
					longitude_jfieldId = JNIEnv.GetFieldID (class_ref, "longitude", "D");
				return JNIEnv.GetDoubleField (((global::Java.Lang.Object) this).Handle, longitude_jfieldId);
			}
			set {
				if (longitude_jfieldId == IntPtr.Zero)
					longitude_jfieldId = JNIEnv.GetFieldID (class_ref, "longitude", "D");
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, longitude_jfieldId, value);
				} finally {
				}
			}
		}
		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/TMapCircle", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (TMapCircle); }
		}

		protected TMapCircle (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/constructor[@name='TMapCircle' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe TMapCircle ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				if (((object) this).GetType () != typeof (TMapCircle)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "()V"),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
					return;
				}

				if (id_ctor == IntPtr.Zero)
					id_ctor = JNIEnv.GetMethodID (class_ref, "<init>", "()V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor);
			} finally {
			}
		}

		static Delegate cb_getAreaAlpha;
#pragma warning disable 0169
		static Delegate GetGetAreaAlphaHandler ()
		{
			if (cb_getAreaAlpha == null)
				cb_getAreaAlpha = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetAreaAlpha);
			return cb_getAreaAlpha;
		}

		static int n_GetAreaAlpha (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.AreaAlpha;
		}
#pragma warning restore 0169

		static Delegate cb_setAreaAlpha_I;
#pragma warning disable 0169
		static Delegate GetSetAreaAlpha_IHandler ()
		{
			if (cb_setAreaAlpha_I == null)
				cb_setAreaAlpha_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetAreaAlpha_I);
			return cb_setAreaAlpha_I;
		}

		static void n_SetAreaAlpha_I (IntPtr jnienv, IntPtr native__this, int p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.AreaAlpha = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getAreaAlpha;
		static IntPtr id_setAreaAlpha_I;
		public virtual unsafe int AreaAlpha {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getAreaAlpha' and count(parameter)=0]"
			[Register ("getAreaAlpha", "()I", "GetGetAreaAlphaHandler")]
			get {
				if (id_getAreaAlpha == IntPtr.Zero)
					id_getAreaAlpha = JNIEnv.GetMethodID (class_ref, "getAreaAlpha", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getAreaAlpha);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getAreaAlpha", "()I"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setAreaAlpha' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("setAreaAlpha", "(I)V", "GetSetAreaAlpha_IHandler")]
			set {
				if (id_setAreaAlpha_I == IntPtr.Zero)
					id_setAreaAlpha_I = JNIEnv.GetMethodID (class_ref, "setAreaAlpha", "(I)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setAreaAlpha_I, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setAreaAlpha", "(I)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getAreaColor;
#pragma warning disable 0169
		static Delegate GetGetAreaColorHandler ()
		{
			if (cb_getAreaColor == null)
				cb_getAreaColor = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetAreaColor);
			return cb_getAreaColor;
		}

		static int n_GetAreaColor (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.AreaColor;
		}
#pragma warning restore 0169

		static Delegate cb_setAreaColor_I;
#pragma warning disable 0169
		static Delegate GetSetAreaColor_IHandler ()
		{
			if (cb_setAreaColor_I == null)
				cb_setAreaColor_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetAreaColor_I);
			return cb_setAreaColor_I;
		}

		static void n_SetAreaColor_I (IntPtr jnienv, IntPtr native__this, int p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.AreaColor = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getAreaColor;
		static IntPtr id_setAreaColor_I;
		public virtual unsafe int AreaColor {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getAreaColor' and count(parameter)=0]"
			[Register ("getAreaColor", "()I", "GetGetAreaColorHandler")]
			get {
				if (id_getAreaColor == IntPtr.Zero)
					id_getAreaColor = JNIEnv.GetMethodID (class_ref, "getAreaColor", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getAreaColor);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getAreaColor", "()I"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setAreaColor' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("setAreaColor", "(I)V", "GetSetAreaColor_IHandler")]
			set {
				if (id_setAreaColor_I == IntPtr.Zero)
					id_setAreaColor_I = JNIEnv.GetMethodID (class_ref, "setAreaColor", "(I)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setAreaColor_I, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setAreaColor", "(I)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCenterPoint;
#pragma warning disable 0169
		static Delegate GetGetCenterPointHandler ()
		{
			if (cb_getCenterPoint == null)
				cb_getCenterPoint = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCenterPoint);
			return cb_getCenterPoint;
		}

		static IntPtr n_GetCenterPoint (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CenterPoint);
		}
#pragma warning restore 0169

		static Delegate cb_setCenterPoint_Lcom_skp_Tmap_TMapPoint_;
#pragma warning disable 0169
		static Delegate GetSetCenterPoint_Lcom_skp_Tmap_TMapPoint_Handler ()
		{
			if (cb_setCenterPoint_Lcom_skp_Tmap_TMapPoint_ == null)
				cb_setCenterPoint_Lcom_skp_Tmap_TMapPoint_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCenterPoint_Lcom_skp_Tmap_TMapPoint_);
			return cb_setCenterPoint_Lcom_skp_Tmap_TMapPoint_;
		}

		static void n_SetCenterPoint_Lcom_skp_Tmap_TMapPoint_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.TMapPoint p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CenterPoint = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCenterPoint;
		static IntPtr id_setCenterPoint_Lcom_skp_Tmap_TMapPoint_;
		public virtual unsafe global::Com.Skp.Tmap.TMapPoint CenterPoint {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getCenterPoint' and count(parameter)=0]"
			[Register ("getCenterPoint", "()Lcom/skp/Tmap/TMapPoint;", "GetGetCenterPointHandler")]
			get {
				if (id_getCenterPoint == IntPtr.Zero)
					id_getCenterPoint = JNIEnv.GetMethodID (class_ref, "getCenterPoint", "()Lcom/skp/Tmap/TMapPoint;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCenterPoint), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCenterPoint", "()Lcom/skp/Tmap/TMapPoint;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setCenterPoint' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapPoint']]"
			[Register ("setCenterPoint", "(Lcom/skp/Tmap/TMapPoint;)V", "GetSetCenterPoint_Lcom_skp_Tmap_TMapPoint_Handler")]
			set {
				if (id_setCenterPoint_Lcom_skp_Tmap_TMapPoint_ == IntPtr.Zero)
					id_setCenterPoint_Lcom_skp_Tmap_TMapPoint_ = JNIEnv.GetMethodID (class_ref, "setCenterPoint", "(Lcom/skp/Tmap/TMapPoint;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCenterPoint_Lcom_skp_Tmap_TMapPoint_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCenterPoint", "(Lcom/skp/Tmap/TMapPoint;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCircleWidth;
#pragma warning disable 0169
		static Delegate GetGetCircleWidthHandler ()
		{
			if (cb_getCircleWidth == null)
				cb_getCircleWidth = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, float>) n_GetCircleWidth);
			return cb_getCircleWidth;
		}

		static float n_GetCircleWidth (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.CircleWidth;
		}
#pragma warning restore 0169

		static Delegate cb_setCircleWidth_F;
#pragma warning disable 0169
		static Delegate GetSetCircleWidth_FHandler ()
		{
			if (cb_setCircleWidth_F == null)
				cb_setCircleWidth_F = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float>) n_SetCircleWidth_F);
			return cb_setCircleWidth_F;
		}

		static void n_SetCircleWidth_F (IntPtr jnienv, IntPtr native__this, float p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.CircleWidth = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCircleWidth;
		static IntPtr id_setCircleWidth_F;
		public virtual unsafe float CircleWidth {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getCircleWidth' and count(parameter)=0]"
			[Register ("getCircleWidth", "()F", "GetGetCircleWidthHandler")]
			get {
				if (id_getCircleWidth == IntPtr.Zero)
					id_getCircleWidth = JNIEnv.GetMethodID (class_ref, "getCircleWidth", "()F");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallFloatMethod (((global::Java.Lang.Object) this).Handle, id_getCircleWidth);
					else
						return JNIEnv.CallNonvirtualFloatMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCircleWidth", "()F"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setCircleWidth' and count(parameter)=1 and parameter[1][@type='float']]"
			[Register ("setCircleWidth", "(F)V", "GetSetCircleWidth_FHandler")]
			set {
				if (id_setCircleWidth_F == IntPtr.Zero)
					id_setCircleWidth_F = JNIEnv.GetMethodID (class_ref, "setCircleWidth", "(F)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCircleWidth_F, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCircleWidth", "(F)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getID;
#pragma warning disable 0169
		static Delegate GetGetIDHandler ()
		{
			if (cb_getID == null)
				cb_getID = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetID);
			return cb_getID;
		}

		static IntPtr n_GetID (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.ID);
		}
#pragma warning restore 0169

		static Delegate cb_setID_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetID_Ljava_lang_String_Handler ()
		{
			if (cb_setID_Ljava_lang_String_ == null)
				cb_setID_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetID_Ljava_lang_String_);
			return cb_setID_Ljava_lang_String_;
		}

		static void n_SetID_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.ID = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getID;
		static IntPtr id_setID_Ljava_lang_String_;
		public virtual unsafe string ID {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getID' and count(parameter)=0]"
			[Register ("getID", "()Ljava/lang/String;", "GetGetIDHandler")]
			get {
				if (id_getID == IntPtr.Zero)
					id_getID = JNIEnv.GetMethodID (class_ref, "getID", "()Ljava/lang/String;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getID), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getID", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setID' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setID", "(Ljava/lang/String;)V", "GetSetID_Ljava_lang_String_Handler")]
			set {
				if (id_setID_Ljava_lang_String_ == IntPtr.Zero)
					id_setID_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "setID", "(Ljava/lang/String;)V");
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setID_Ljava_lang_String_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setID", "(Ljava/lang/String;)V"), __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static Delegate cb_getLineAlpha;
#pragma warning disable 0169
		static Delegate GetGetLineAlphaHandler ()
		{
			if (cb_getLineAlpha == null)
				cb_getLineAlpha = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetLineAlpha);
			return cb_getLineAlpha;
		}

		static int n_GetLineAlpha (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.LineAlpha;
		}
#pragma warning restore 0169

		static Delegate cb_setLineAlpha_I;
#pragma warning disable 0169
		static Delegate GetSetLineAlpha_IHandler ()
		{
			if (cb_setLineAlpha_I == null)
				cb_setLineAlpha_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetLineAlpha_I);
			return cb_setLineAlpha_I;
		}

		static void n_SetLineAlpha_I (IntPtr jnienv, IntPtr native__this, int p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.LineAlpha = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getLineAlpha;
		static IntPtr id_setLineAlpha_I;
		public virtual unsafe int LineAlpha {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getLineAlpha' and count(parameter)=0]"
			[Register ("getLineAlpha", "()I", "GetGetLineAlphaHandler")]
			get {
				if (id_getLineAlpha == IntPtr.Zero)
					id_getLineAlpha = JNIEnv.GetMethodID (class_ref, "getLineAlpha", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getLineAlpha);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getLineAlpha", "()I"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setLineAlpha' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("setLineAlpha", "(I)V", "GetSetLineAlpha_IHandler")]
			set {
				if (id_setLineAlpha_I == IntPtr.Zero)
					id_setLineAlpha_I = JNIEnv.GetMethodID (class_ref, "setLineAlpha", "(I)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setLineAlpha_I, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setLineAlpha", "(I)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getLineColor;
#pragma warning disable 0169
		static Delegate GetGetLineColorHandler ()
		{
			if (cb_getLineColor == null)
				cb_getLineColor = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetLineColor);
			return cb_getLineColor;
		}

		static int n_GetLineColor (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.LineColor;
		}
#pragma warning restore 0169

		static Delegate cb_setLineColor_I;
#pragma warning disable 0169
		static Delegate GetSetLineColor_IHandler ()
		{
			if (cb_setLineColor_I == null)
				cb_setLineColor_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetLineColor_I);
			return cb_setLineColor_I;
		}

		static void n_SetLineColor_I (IntPtr jnienv, IntPtr native__this, int p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.LineColor = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getLineColor;
		static IntPtr id_setLineColor_I;
		public virtual unsafe int LineColor {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getLineColor' and count(parameter)=0]"
			[Register ("getLineColor", "()I", "GetGetLineColorHandler")]
			get {
				if (id_getLineColor == IntPtr.Zero)
					id_getLineColor = JNIEnv.GetMethodID (class_ref, "getLineColor", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getLineColor);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getLineColor", "()I"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setLineColor' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("setLineColor", "(I)V", "GetSetLineColor_IHandler")]
			set {
				if (id_setLineColor_I == IntPtr.Zero)
					id_setLineColor_I = JNIEnv.GetMethodID (class_ref, "setLineColor", "(I)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setLineColor_I, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setLineColor", "(I)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getRadius;
#pragma warning disable 0169
		static Delegate GetGetRadiusHandler ()
		{
			if (cb_getRadius == null)
				cb_getRadius = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetRadius);
			return cb_getRadius;
		}

		static double n_GetRadius (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Radius;
		}
#pragma warning restore 0169

		static Delegate cb_setRadius_D;
#pragma warning disable 0169
		static Delegate GetSetRadius_DHandler ()
		{
			if (cb_setRadius_D == null)
				cb_setRadius_D = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, double>) n_SetRadius_D);
			return cb_setRadius_D;
		}

		static void n_SetRadius_D (IntPtr jnienv, IntPtr native__this, double p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Radius = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getRadius;
		static IntPtr id_setRadius_D;
		public virtual unsafe double Radius {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getRadius' and count(parameter)=0]"
			[Register ("getRadius", "()D", "GetGetRadiusHandler")]
			get {
				if (id_getRadius == IntPtr.Zero)
					id_getRadius = JNIEnv.GetMethodID (class_ref, "getRadius", "()D");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallDoubleMethod (((global::Java.Lang.Object) this).Handle, id_getRadius);
					else
						return JNIEnv.CallNonvirtualDoubleMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getRadius", "()D"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setRadius' and count(parameter)=1 and parameter[1][@type='double']]"
			[Register ("setRadius", "(D)V", "GetSetRadius_DHandler")]
			set {
				if (id_setRadius_D == IntPtr.Zero)
					id_setRadius_D = JNIEnv.GetMethodID (class_ref, "setRadius", "(D)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setRadius_D, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setRadius", "(D)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getRadiusVisible;
#pragma warning disable 0169
		static Delegate GetGetRadiusVisibleHandler ()
		{
			if (cb_getRadiusVisible == null)
				cb_getRadiusVisible = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_GetRadiusVisible);
			return cb_getRadiusVisible;
		}

		static bool n_GetRadiusVisible (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.RadiusVisible;
		}
#pragma warning restore 0169

		static Delegate cb_setRadiusVisible_Z;
#pragma warning disable 0169
		static Delegate GetSetRadiusVisible_ZHandler ()
		{
			if (cb_setRadiusVisible_Z == null)
				cb_setRadiusVisible_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool>) n_SetRadiusVisible_Z);
			return cb_setRadiusVisible_Z;
		}

		static void n_SetRadiusVisible_Z (IntPtr jnienv, IntPtr native__this, bool p0)
		{
			global::Com.Skp.Tmap.TMapCircle __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapCircle> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RadiusVisible = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getRadiusVisible;
		static IntPtr id_setRadiusVisible_Z;
		public virtual unsafe bool RadiusVisible {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='getRadiusVisible' and count(parameter)=0]"
			[Register ("getRadiusVisible", "()Z", "GetGetRadiusVisibleHandler")]
			get {
				if (id_getRadiusVisible == IntPtr.Zero)
					id_getRadiusVisible = JNIEnv.GetMethodID (class_ref, "getRadiusVisible", "()Z");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_getRadiusVisible);
					else
						return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getRadiusVisible", "()Z"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapCircle']/method[@name='setRadiusVisible' and count(parameter)=1 and parameter[1][@type='boolean']]"
			[Register ("setRadiusVisible", "(Z)V", "GetSetRadiusVisible_ZHandler")]
			set {
				if (id_setRadiusVisible_Z == IntPtr.Zero)
					id_setRadiusVisible_Z = JNIEnv.GetMethodID (class_ref, "setRadiusVisible", "(Z)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setRadiusVisible_Z, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setRadiusVisible", "(Z)V"), __args);
				} finally {
				}
			}
		}

	}
}
