using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']"
	[global::Android.Runtime.Register ("com/skp/Tmap/TMapGpsManager", DoNotGenerateAcw=true)]
	public partial class TMapGpsManager : global::Java.Lang.Object {


		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/field[@name='GPS_PROVIDER']"
		[Register ("GPS_PROVIDER")]
		public const string GpsProvider = (string) "gps";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/field[@name='LOCATION_SERVICE']"
		[Register ("LOCATION_SERVICE")]
		public const string LocationService = (string) "location";

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/field[@name='NETWORK_PROVIDER']"
		[Register ("NETWORK_PROVIDER")]
		public const string NetworkProvider = (string) "network";
		// Metadata.xml XPath interface reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapGpsManager.onLocationChangedCallback']"
		[Register ("com/skp/Tmap/TMapGpsManager$onLocationChangedCallback", "", "Com.Skp.Tmap.TMapGpsManager/IOnLocationChangedCallbackInvoker")]
		public partial interface IOnLocationChangedCallback : IJavaObject {

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='TMapGpsManager.onLocationChangedCallback']/method[@name='onLocationChange' and count(parameter)=1 and parameter[1][@type='android.location.Location']]"
			[Register ("onLocationChange", "(Landroid/location/Location;)V", "GetOnLocationChange_Landroid_location_Location_Handler:Com.Skp.Tmap.TMapGpsManager/IOnLocationChangedCallbackInvoker, TmapBindTest")]
			void OnLocationChange (global::Android.Locations.Location p0);

		}

		[global::Android.Runtime.Register ("com/skp/Tmap/TMapGpsManager$onLocationChangedCallback", DoNotGenerateAcw=true)]
		internal class IOnLocationChangedCallbackInvoker : global::Java.Lang.Object, IOnLocationChangedCallback {

			static IntPtr java_class_ref = JNIEnv.FindClass ("com/skp/Tmap/TMapGpsManager$onLocationChangedCallback");

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (IOnLocationChangedCallbackInvoker); }
			}

			IntPtr class_ref;

			public static IOnLocationChangedCallback GetObject (IntPtr handle, JniHandleOwnership transfer)
			{
				return global::Java.Lang.Object.GetObject<IOnLocationChangedCallback> (handle, transfer);
			}

			static IntPtr Validate (IntPtr handle)
			{
				if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
					throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
								JNIEnv.GetClassNameFromInstance (handle), "com.skp.Tmap.TMapGpsManager.onLocationChangedCallback"));
				return handle;
			}

			protected override void Dispose (bool disposing)
			{
				if (this.class_ref != IntPtr.Zero)
					JNIEnv.DeleteGlobalRef (this.class_ref);
				this.class_ref = IntPtr.Zero;
				base.Dispose (disposing);
			}

			public IOnLocationChangedCallbackInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
			{
				IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
				this.class_ref = JNIEnv.NewGlobalRef (local_ref);
				JNIEnv.DeleteLocalRef (local_ref);
			}

			static Delegate cb_onLocationChange_Landroid_location_Location_;
#pragma warning disable 0169
			static Delegate GetOnLocationChange_Landroid_location_Location_Handler ()
			{
				if (cb_onLocationChange_Landroid_location_Location_ == null)
					cb_onLocationChange_Landroid_location_Location_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_OnLocationChange_Landroid_location_Location_);
				return cb_onLocationChange_Landroid_location_Location_;
			}

			static void n_OnLocationChange_Landroid_location_Location_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
			{
				global::Com.Skp.Tmap.TMapGpsManager.IOnLocationChangedCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager.IOnLocationChangedCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				global::Android.Locations.Location p0 = global::Java.Lang.Object.GetObject<global::Android.Locations.Location> (native_p0, JniHandleOwnership.DoNotTransfer);
				__this.OnLocationChange (p0);
			}
#pragma warning restore 0169

			IntPtr id_onLocationChange_Landroid_location_Location_;
			public unsafe void OnLocationChange (global::Android.Locations.Location p0)
			{
				if (id_onLocationChange_Landroid_location_Location_ == IntPtr.Zero)
					id_onLocationChange_Landroid_location_Location_ = JNIEnv.GetMethodID (class_ref, "onLocationChange", "(Landroid/location/Location;)V");
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_onLocationChange_Landroid_location_Location_, __args);
			}

		}


		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/TMapGpsManager", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (TMapGpsManager); }
		}

		protected TMapGpsManager (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor_Landroid_content_Context_;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/constructor[@name='TMapGpsManager' and count(parameter)=1 and parameter[1][@type='android.content.Context']]"
		[Register (".ctor", "(Landroid/content/Context;)V", "")]
		public unsafe TMapGpsManager (global::Android.Content.Context p0)
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				if (((object) this).GetType () != typeof (TMapGpsManager)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Landroid/content/Context;)V", __args),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Landroid/content/Context;)V", __args);
					return;
				}

				if (id_ctor_Landroid_content_Context_ == IntPtr.Zero)
					id_ctor_Landroid_content_Context_ = JNIEnv.GetMethodID (class_ref, "<init>", "(Landroid/content/Context;)V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Landroid_content_Context_, __args),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Landroid_content_Context_, __args);
			} finally {
			}
		}

		static Delegate cb_getLocation;
#pragma warning disable 0169
		static Delegate GetGetLocationHandler ()
		{
			if (cb_getLocation == null)
				cb_getLocation = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetLocation);
			return cb_getLocation;
		}

		static IntPtr n_GetLocation (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Location);
		}
#pragma warning restore 0169

		static IntPtr id_getLocation;
		public virtual unsafe global::Com.Skp.Tmap.TMapPoint Location {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='getLocation' and count(parameter)=0]"
			[Register ("getLocation", "()Lcom/skp/Tmap/TMapPoint;", "GetGetLocationHandler")]
			get {
				if (id_getLocation == IntPtr.Zero)
					id_getLocation = JNIEnv.GetMethodID (class_ref, "getLocation", "()Lcom/skp/Tmap/TMapPoint;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getLocation), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getLocation", "()Lcom/skp/Tmap/TMapPoint;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_getMinDistance;
#pragma warning disable 0169
		static Delegate GetGetMinDistanceHandler ()
		{
			if (cb_getMinDistance == null)
				cb_getMinDistance = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, float>) n_GetMinDistance);
			return cb_getMinDistance;
		}

		static float n_GetMinDistance (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.MinDistance;
		}
#pragma warning restore 0169

		static Delegate cb_setMinDistance_F;
#pragma warning disable 0169
		static Delegate GetSetMinDistance_FHandler ()
		{
			if (cb_setMinDistance_F == null)
				cb_setMinDistance_F = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float>) n_SetMinDistance_F);
			return cb_setMinDistance_F;
		}

		static void n_SetMinDistance_F (IntPtr jnienv, IntPtr native__this, float p0)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.MinDistance = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getMinDistance;
		static IntPtr id_setMinDistance_F;
		public virtual unsafe float MinDistance {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='getMinDistance' and count(parameter)=0]"
			[Register ("getMinDistance", "()F", "GetGetMinDistanceHandler")]
			get {
				if (id_getMinDistance == IntPtr.Zero)
					id_getMinDistance = JNIEnv.GetMethodID (class_ref, "getMinDistance", "()F");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallFloatMethod (((global::Java.Lang.Object) this).Handle, id_getMinDistance);
					else
						return JNIEnv.CallNonvirtualFloatMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getMinDistance", "()F"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='setMinDistance' and count(parameter)=1 and parameter[1][@type='float']]"
			[Register ("setMinDistance", "(F)V", "GetSetMinDistance_FHandler")]
			set {
				if (id_setMinDistance_F == IntPtr.Zero)
					id_setMinDistance_F = JNIEnv.GetMethodID (class_ref, "setMinDistance", "(F)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setMinDistance_F, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setMinDistance", "(F)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getMinTime;
#pragma warning disable 0169
		static Delegate GetGetMinTimeHandler ()
		{
			if (cb_getMinTime == null)
				cb_getMinTime = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, long>) n_GetMinTime);
			return cb_getMinTime;
		}

		static long n_GetMinTime (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.MinTime;
		}
#pragma warning restore 0169

		static Delegate cb_setMinTime_J;
#pragma warning disable 0169
		static Delegate GetSetMinTime_JHandler ()
		{
			if (cb_setMinTime_J == null)
				cb_setMinTime_J = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, long>) n_SetMinTime_J);
			return cb_setMinTime_J;
		}

		static void n_SetMinTime_J (IntPtr jnienv, IntPtr native__this, long p0)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.MinTime = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getMinTime;
		static IntPtr id_setMinTime_J;
		public virtual unsafe long MinTime {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='getMinTime' and count(parameter)=0]"
			[Register ("getMinTime", "()J", "GetGetMinTimeHandler")]
			get {
				if (id_getMinTime == IntPtr.Zero)
					id_getMinTime = JNIEnv.GetMethodID (class_ref, "getMinTime", "()J");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallLongMethod (((global::Java.Lang.Object) this).Handle, id_getMinTime);
					else
						return JNIEnv.CallNonvirtualLongMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getMinTime", "()J"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='setMinTime' and count(parameter)=1 and parameter[1][@type='long']]"
			[Register ("setMinTime", "(J)V", "GetSetMinTime_JHandler")]
			set {
				if (id_setMinTime_J == IntPtr.Zero)
					id_setMinTime_J = JNIEnv.GetMethodID (class_ref, "setMinTime", "(J)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setMinTime_J, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setMinTime", "(J)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getProvider;
#pragma warning disable 0169
		static Delegate GetGetProviderHandler ()
		{
			if (cb_getProvider == null)
				cb_getProvider = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetProvider);
			return cb_getProvider;
		}

		static IntPtr n_GetProvider (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Provider);
		}
#pragma warning restore 0169

		static Delegate cb_setProvider_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetProvider_Ljava_lang_String_Handler ()
		{
			if (cb_setProvider_Ljava_lang_String_ == null)
				cb_setProvider_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetProvider_Ljava_lang_String_);
			return cb_setProvider_Ljava_lang_String_;
		}

		static void n_SetProvider_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.Provider = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getProvider;
		static IntPtr id_setProvider_Ljava_lang_String_;
		public virtual unsafe string Provider {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='getProvider' and count(parameter)=0]"
			[Register ("getProvider", "()Ljava/lang/String;", "GetGetProviderHandler")]
			get {
				if (id_getProvider == IntPtr.Zero)
					id_getProvider = JNIEnv.GetMethodID (class_ref, "getProvider", "()Ljava/lang/String;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getProvider), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getProvider", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='setProvider' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setProvider", "(Ljava/lang/String;)V", "GetSetProvider_Ljava_lang_String_Handler")]
			set {
				if (id_setProvider_Ljava_lang_String_ == IntPtr.Zero)
					id_setProvider_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "setProvider", "(Ljava/lang/String;)V");
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setProvider_Ljava_lang_String_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setProvider", "(Ljava/lang/String;)V"), __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static Delegate cb_getSatellite;
#pragma warning disable 0169
		static Delegate GetGetSatelliteHandler ()
		{
			if (cb_getSatellite == null)
				cb_getSatellite = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetSatellite);
			return cb_getSatellite;
		}

		static int n_GetSatellite (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Satellite;
		}
#pragma warning restore 0169

		static IntPtr id_getSatellite;
		public virtual unsafe int Satellite {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='getSatellite' and count(parameter)=0]"
			[Register ("getSatellite", "()I", "GetGetSatelliteHandler")]
			get {
				if (id_getSatellite == IntPtr.Zero)
					id_getSatellite = JNIEnv.GetMethodID (class_ref, "getSatellite", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getSatellite);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getSatellite", "()I"));
				} finally {
				}
			}
		}

		static Delegate cb_CloseGps;
#pragma warning disable 0169
		static Delegate GetCloseGpsHandler ()
		{
			if (cb_CloseGps == null)
				cb_CloseGps = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_CloseGps);
			return cb_CloseGps;
		}

		static void n_CloseGps (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.CloseGps ();
		}
#pragma warning restore 0169

		static IntPtr id_CloseGps;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='CloseGps' and count(parameter)=0]"
		[Register ("CloseGps", "()V", "GetCloseGpsHandler")]
		public virtual unsafe void CloseGps ()
		{
			if (id_CloseGps == IntPtr.Zero)
				id_CloseGps = JNIEnv.GetMethodID (class_ref, "CloseGps", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_CloseGps);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "CloseGps", "()V"));
			} finally {
			}
		}

		static Delegate cb_OpenGps;
#pragma warning disable 0169
		static Delegate GetOpenGpsHandler ()
		{
			if (cb_OpenGps == null)
				cb_OpenGps = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_OpenGps);
			return cb_OpenGps;
		}

		static void n_OpenGps (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.OpenGps ();
		}
#pragma warning restore 0169

		static IntPtr id_OpenGps;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='OpenGps' and count(parameter)=0]"
		[Register ("OpenGps", "()V", "GetOpenGpsHandler")]
		public virtual unsafe void OpenGps ()
		{
			if (id_OpenGps == IntPtr.Zero)
				id_OpenGps = JNIEnv.GetMethodID (class_ref, "OpenGps", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_OpenGps);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "OpenGps", "()V"));
			} finally {
			}
		}

		static Delegate cb_setLocationCallback;
#pragma warning disable 0169
		static Delegate GetSetLocationCallbackHandler ()
		{
			if (cb_setLocationCallback == null)
				cb_setLocationCallback = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_SetLocationCallback);
			return cb_setLocationCallback;
		}

		static bool n_SetLocationCallback (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapGpsManager __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapGpsManager> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.SetLocationCallback ();
		}
#pragma warning restore 0169

		static IntPtr id_setLocationCallback;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapGpsManager']/method[@name='setLocationCallback' and count(parameter)=0]"
		[Register ("setLocationCallback", "()Z", "GetSetLocationCallbackHandler")]
		public virtual unsafe bool SetLocationCallback ()
		{
			if (id_setLocationCallback == IntPtr.Zero)
				id_setLocationCallback = JNIEnv.GetMethodID (class_ref, "setLocationCallback", "()Z");
			try {

				if (((object) this).GetType () == ThresholdType)
					return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_setLocationCallback);
				else
					return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setLocationCallback", "()Z"));
			} finally {
			}
		}

	}
}
