using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']"
	[global::Android.Runtime.Register ("com/skp/Tmap/TMapMarkerItem", DoNotGenerateAcw=true)]
	public partial class TMapMarkerItem : global::Java.Lang.Object {


		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/field[@name='GONE']"
		[Register ("GONE")]
		public const int Gone = (int) 0;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/field[@name='HIDDEN']"
		[Register ("HIDDEN")]
		public const int Hidden = (int) 1;

		static IntPtr latitude_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/field[@name='latitude']"
		[Register ("latitude")]
		public double Latitude {
			get {
				if (latitude_jfieldId == IntPtr.Zero)
					latitude_jfieldId = JNIEnv.GetFieldID (class_ref, "latitude", "D");
				return JNIEnv.GetDoubleField (((global::Java.Lang.Object) this).Handle, latitude_jfieldId);
			}
			set {
				if (latitude_jfieldId == IntPtr.Zero)
					latitude_jfieldId = JNIEnv.GetFieldID (class_ref, "latitude", "D");
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, latitude_jfieldId, value);
				} finally {
				}
			}
		}

		static IntPtr longitude_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/field[@name='longitude']"
		[Register ("longitude")]
		public double Longitude {
			get {
				if (longitude_jfieldId == IntPtr.Zero)
					longitude_jfieldId = JNIEnv.GetFieldID (class_ref, "longitude", "D");
				return JNIEnv.GetDoubleField (((global::Java.Lang.Object) this).Handle, longitude_jfieldId);
			}
			set {
				if (longitude_jfieldId == IntPtr.Zero)
					longitude_jfieldId = JNIEnv.GetFieldID (class_ref, "longitude", "D");
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, longitude_jfieldId, value);
				} finally {
				}
			}
		}
		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/TMapMarkerItem", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (TMapMarkerItem); }
		}

		protected TMapMarkerItem (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/constructor[@name='TMapMarkerItem' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe TMapMarkerItem ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				if (((object) this).GetType () != typeof (TMapMarkerItem)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "()V"),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
					return;
				}

				if (id_ctor == IntPtr.Zero)
					id_ctor = JNIEnv.GetMethodID (class_ref, "<init>", "()V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor);
			} finally {
			}
		}

		static Delegate cb_getAutoCalloutVisible;
#pragma warning disable 0169
		static Delegate GetGetAutoCalloutVisibleHandler ()
		{
			if (cb_getAutoCalloutVisible == null)
				cb_getAutoCalloutVisible = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_GetAutoCalloutVisible);
			return cb_getAutoCalloutVisible;
		}

		static bool n_GetAutoCalloutVisible (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.AutoCalloutVisible;
		}
#pragma warning restore 0169

		static Delegate cb_setAutoCalloutVisible_Z;
#pragma warning disable 0169
		static Delegate GetSetAutoCalloutVisible_ZHandler ()
		{
			if (cb_setAutoCalloutVisible_Z == null)
				cb_setAutoCalloutVisible_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool>) n_SetAutoCalloutVisible_Z);
			return cb_setAutoCalloutVisible_Z;
		}

		static void n_SetAutoCalloutVisible_Z (IntPtr jnienv, IntPtr native__this, bool p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.AutoCalloutVisible = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getAutoCalloutVisible;
		static IntPtr id_setAutoCalloutVisible_Z;
		public virtual unsafe bool AutoCalloutVisible {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getAutoCalloutVisible' and count(parameter)=0]"
			[Register ("getAutoCalloutVisible", "()Z", "GetGetAutoCalloutVisibleHandler")]
			get {
				if (id_getAutoCalloutVisible == IntPtr.Zero)
					id_getAutoCalloutVisible = JNIEnv.GetMethodID (class_ref, "getAutoCalloutVisible", "()Z");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_getAutoCalloutVisible);
					else
						return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getAutoCalloutVisible", "()Z"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setAutoCalloutVisible' and count(parameter)=1 and parameter[1][@type='boolean']]"
			[Register ("setAutoCalloutVisible", "(Z)V", "GetSetAutoCalloutVisible_ZHandler")]
			set {
				if (id_setAutoCalloutVisible_Z == IntPtr.Zero)
					id_setAutoCalloutVisible_Z = JNIEnv.GetMethodID (class_ref, "setAutoCalloutVisible", "(Z)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setAutoCalloutVisible_Z, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setAutoCalloutVisible", "(Z)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCalloutLeftImage;
#pragma warning disable 0169
		static Delegate GetGetCalloutLeftImageHandler ()
		{
			if (cb_getCalloutLeftImage == null)
				cb_getCalloutLeftImage = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCalloutLeftImage);
			return cb_getCalloutLeftImage;
		}

		static IntPtr n_GetCalloutLeftImage (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CalloutLeftImage);
		}
#pragma warning restore 0169

		static Delegate cb_setCalloutLeftImage_Landroid_graphics_Bitmap_;
#pragma warning disable 0169
		static Delegate GetSetCalloutLeftImage_Landroid_graphics_Bitmap_Handler ()
		{
			if (cb_setCalloutLeftImage_Landroid_graphics_Bitmap_ == null)
				cb_setCalloutLeftImage_Landroid_graphics_Bitmap_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCalloutLeftImage_Landroid_graphics_Bitmap_);
			return cb_setCalloutLeftImage_Landroid_graphics_Bitmap_;
		}

		static void n_SetCalloutLeftImage_Landroid_graphics_Bitmap_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CalloutLeftImage = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCalloutLeftImage;
		static IntPtr id_setCalloutLeftImage_Landroid_graphics_Bitmap_;
		public virtual unsafe global::Android.Graphics.Bitmap CalloutLeftImage {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCalloutLeftImage' and count(parameter)=0]"
			[Register ("getCalloutLeftImage", "()Landroid/graphics/Bitmap;", "GetGetCalloutLeftImageHandler")]
			get {
				if (id_getCalloutLeftImage == IntPtr.Zero)
					id_getCalloutLeftImage = JNIEnv.GetMethodID (class_ref, "getCalloutLeftImage", "()Landroid/graphics/Bitmap;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCalloutLeftImage), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCalloutLeftImage", "()Landroid/graphics/Bitmap;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCalloutLeftImage' and count(parameter)=1 and parameter[1][@type='android.graphics.Bitmap']]"
			[Register ("setCalloutLeftImage", "(Landroid/graphics/Bitmap;)V", "GetSetCalloutLeftImage_Landroid_graphics_Bitmap_Handler")]
			set {
				if (id_setCalloutLeftImage_Landroid_graphics_Bitmap_ == IntPtr.Zero)
					id_setCalloutLeftImage_Landroid_graphics_Bitmap_ = JNIEnv.GetMethodID (class_ref, "setCalloutLeftImage", "(Landroid/graphics/Bitmap;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCalloutLeftImage_Landroid_graphics_Bitmap_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCalloutLeftImage", "(Landroid/graphics/Bitmap;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCalloutRect;
#pragma warning disable 0169
		static Delegate GetGetCalloutRectHandler ()
		{
			if (cb_getCalloutRect == null)
				cb_getCalloutRect = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCalloutRect);
			return cb_getCalloutRect;
		}

		static IntPtr n_GetCalloutRect (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CalloutRect);
		}
#pragma warning restore 0169

		static Delegate cb_setCalloutRect_Landroid_graphics_Rect_;
#pragma warning disable 0169
		static Delegate GetSetCalloutRect_Landroid_graphics_Rect_Handler ()
		{
			if (cb_setCalloutRect_Landroid_graphics_Rect_ == null)
				cb_setCalloutRect_Landroid_graphics_Rect_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCalloutRect_Landroid_graphics_Rect_);
			return cb_setCalloutRect_Landroid_graphics_Rect_;
		}

		static void n_SetCalloutRect_Landroid_graphics_Rect_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Rect p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CalloutRect = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCalloutRect;
		static IntPtr id_setCalloutRect_Landroid_graphics_Rect_;
		public virtual unsafe global::Android.Graphics.Rect CalloutRect {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCalloutRect' and count(parameter)=0]"
			[Register ("getCalloutRect", "()Landroid/graphics/Rect;", "GetGetCalloutRectHandler")]
			get {
				if (id_getCalloutRect == IntPtr.Zero)
					id_getCalloutRect = JNIEnv.GetMethodID (class_ref, "getCalloutRect", "()Landroid/graphics/Rect;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCalloutRect), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCalloutRect", "()Landroid/graphics/Rect;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCalloutRect' and count(parameter)=1 and parameter[1][@type='android.graphics.Rect']]"
			[Register ("setCalloutRect", "(Landroid/graphics/Rect;)V", "GetSetCalloutRect_Landroid_graphics_Rect_Handler")]
			set {
				if (id_setCalloutRect_Landroid_graphics_Rect_ == IntPtr.Zero)
					id_setCalloutRect_Landroid_graphics_Rect_ = JNIEnv.GetMethodID (class_ref, "setCalloutRect", "(Landroid/graphics/Rect;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCalloutRect_Landroid_graphics_Rect_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCalloutRect", "(Landroid/graphics/Rect;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCalloutRightButtonImage;
#pragma warning disable 0169
		static Delegate GetGetCalloutRightButtonImageHandler ()
		{
			if (cb_getCalloutRightButtonImage == null)
				cb_getCalloutRightButtonImage = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCalloutRightButtonImage);
			return cb_getCalloutRightButtonImage;
		}

		static IntPtr n_GetCalloutRightButtonImage (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CalloutRightButtonImage);
		}
#pragma warning restore 0169

		static Delegate cb_setCalloutRightButtonImage_Landroid_graphics_Bitmap_;
#pragma warning disable 0169
		static Delegate GetSetCalloutRightButtonImage_Landroid_graphics_Bitmap_Handler ()
		{
			if (cb_setCalloutRightButtonImage_Landroid_graphics_Bitmap_ == null)
				cb_setCalloutRightButtonImage_Landroid_graphics_Bitmap_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCalloutRightButtonImage_Landroid_graphics_Bitmap_);
			return cb_setCalloutRightButtonImage_Landroid_graphics_Bitmap_;
		}

		static void n_SetCalloutRightButtonImage_Landroid_graphics_Bitmap_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CalloutRightButtonImage = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCalloutRightButtonImage;
		static IntPtr id_setCalloutRightButtonImage_Landroid_graphics_Bitmap_;
		public virtual unsafe global::Android.Graphics.Bitmap CalloutRightButtonImage {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCalloutRightButtonImage' and count(parameter)=0]"
			[Register ("getCalloutRightButtonImage", "()Landroid/graphics/Bitmap;", "GetGetCalloutRightButtonImageHandler")]
			get {
				if (id_getCalloutRightButtonImage == IntPtr.Zero)
					id_getCalloutRightButtonImage = JNIEnv.GetMethodID (class_ref, "getCalloutRightButtonImage", "()Landroid/graphics/Bitmap;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCalloutRightButtonImage), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCalloutRightButtonImage", "()Landroid/graphics/Bitmap;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCalloutRightButtonImage' and count(parameter)=1 and parameter[1][@type='android.graphics.Bitmap']]"
			[Register ("setCalloutRightButtonImage", "(Landroid/graphics/Bitmap;)V", "GetSetCalloutRightButtonImage_Landroid_graphics_Bitmap_Handler")]
			set {
				if (id_setCalloutRightButtonImage_Landroid_graphics_Bitmap_ == IntPtr.Zero)
					id_setCalloutRightButtonImage_Landroid_graphics_Bitmap_ = JNIEnv.GetMethodID (class_ref, "setCalloutRightButtonImage", "(Landroid/graphics/Bitmap;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCalloutRightButtonImage_Landroid_graphics_Bitmap_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCalloutRightButtonImage", "(Landroid/graphics/Bitmap;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCalloutRightRect;
#pragma warning disable 0169
		static Delegate GetGetCalloutRightRectHandler ()
		{
			if (cb_getCalloutRightRect == null)
				cb_getCalloutRightRect = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCalloutRightRect);
			return cb_getCalloutRightRect;
		}

		static IntPtr n_GetCalloutRightRect (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.CalloutRightRect);
		}
#pragma warning restore 0169

		static Delegate cb_setCalloutRightRect_Landroid_graphics_Rect_;
#pragma warning disable 0169
		static Delegate GetSetCalloutRightRect_Landroid_graphics_Rect_Handler ()
		{
			if (cb_setCalloutRightRect_Landroid_graphics_Rect_ == null)
				cb_setCalloutRightRect_Landroid_graphics_Rect_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCalloutRightRect_Landroid_graphics_Rect_);
			return cb_setCalloutRightRect_Landroid_graphics_Rect_;
		}

		static void n_SetCalloutRightRect_Landroid_graphics_Rect_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Rect p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CalloutRightRect = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCalloutRightRect;
		static IntPtr id_setCalloutRightRect_Landroid_graphics_Rect_;
		public virtual unsafe global::Android.Graphics.Rect CalloutRightRect {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCalloutRightRect' and count(parameter)=0]"
			[Register ("getCalloutRightRect", "()Landroid/graphics/Rect;", "GetGetCalloutRightRectHandler")]
			get {
				if (id_getCalloutRightRect == IntPtr.Zero)
					id_getCalloutRightRect = JNIEnv.GetMethodID (class_ref, "getCalloutRightRect", "()Landroid/graphics/Rect;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCalloutRightRect), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCalloutRightRect", "()Landroid/graphics/Rect;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCalloutRightRect' and count(parameter)=1 and parameter[1][@type='android.graphics.Rect']]"
			[Register ("setCalloutRightRect", "(Landroid/graphics/Rect;)V", "GetSetCalloutRightRect_Landroid_graphics_Rect_Handler")]
			set {
				if (id_setCalloutRightRect_Landroid_graphics_Rect_ == IntPtr.Zero)
					id_setCalloutRightRect_Landroid_graphics_Rect_ = JNIEnv.GetMethodID (class_ref, "setCalloutRightRect", "(Landroid/graphics/Rect;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCalloutRightRect_Landroid_graphics_Rect_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCalloutRightRect", "(Landroid/graphics/Rect;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getCalloutSubTitle;
#pragma warning disable 0169
		static Delegate GetGetCalloutSubTitleHandler ()
		{
			if (cb_getCalloutSubTitle == null)
				cb_getCalloutSubTitle = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCalloutSubTitle);
			return cb_getCalloutSubTitle;
		}

		static IntPtr n_GetCalloutSubTitle (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.CalloutSubTitle);
		}
#pragma warning restore 0169

		static Delegate cb_setCalloutSubTitle_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCalloutSubTitle_Ljava_lang_String_Handler ()
		{
			if (cb_setCalloutSubTitle_Ljava_lang_String_ == null)
				cb_setCalloutSubTitle_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCalloutSubTitle_Ljava_lang_String_);
			return cb_setCalloutSubTitle_Ljava_lang_String_;
		}

		static void n_SetCalloutSubTitle_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CalloutSubTitle = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCalloutSubTitle;
		static IntPtr id_setCalloutSubTitle_Ljava_lang_String_;
		public virtual unsafe string CalloutSubTitle {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCalloutSubTitle' and count(parameter)=0]"
			[Register ("getCalloutSubTitle", "()Ljava/lang/String;", "GetGetCalloutSubTitleHandler")]
			get {
				if (id_getCalloutSubTitle == IntPtr.Zero)
					id_getCalloutSubTitle = JNIEnv.GetMethodID (class_ref, "getCalloutSubTitle", "()Ljava/lang/String;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCalloutSubTitle), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCalloutSubTitle", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCalloutSubTitle' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setCalloutSubTitle", "(Ljava/lang/String;)V", "GetSetCalloutSubTitle_Ljava_lang_String_Handler")]
			set {
				if (id_setCalloutSubTitle_Ljava_lang_String_ == IntPtr.Zero)
					id_setCalloutSubTitle_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "setCalloutSubTitle", "(Ljava/lang/String;)V");
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCalloutSubTitle_Ljava_lang_String_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCalloutSubTitle", "(Ljava/lang/String;)V"), __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static Delegate cb_getCalloutTitle;
#pragma warning disable 0169
		static Delegate GetGetCalloutTitleHandler ()
		{
			if (cb_getCalloutTitle == null)
				cb_getCalloutTitle = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCalloutTitle);
			return cb_getCalloutTitle;
		}

		static IntPtr n_GetCalloutTitle (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.CalloutTitle);
		}
#pragma warning restore 0169

		static Delegate cb_setCalloutTitle_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetCalloutTitle_Ljava_lang_String_Handler ()
		{
			if (cb_setCalloutTitle_Ljava_lang_String_ == null)
				cb_setCalloutTitle_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetCalloutTitle_Ljava_lang_String_);
			return cb_setCalloutTitle_Ljava_lang_String_;
		}

		static void n_SetCalloutTitle_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.CalloutTitle = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCalloutTitle;
		static IntPtr id_setCalloutTitle_Ljava_lang_String_;
		public virtual unsafe string CalloutTitle {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCalloutTitle' and count(parameter)=0]"
			[Register ("getCalloutTitle", "()Ljava/lang/String;", "GetGetCalloutTitleHandler")]
			get {
				if (id_getCalloutTitle == IntPtr.Zero)
					id_getCalloutTitle = JNIEnv.GetMethodID (class_ref, "getCalloutTitle", "()Ljava/lang/String;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCalloutTitle), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCalloutTitle", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCalloutTitle' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setCalloutTitle", "(Ljava/lang/String;)V", "GetSetCalloutTitle_Ljava_lang_String_Handler")]
			set {
				if (id_setCalloutTitle_Ljava_lang_String_ == IntPtr.Zero)
					id_setCalloutTitle_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "setCalloutTitle", "(Ljava/lang/String;)V");
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCalloutTitle_Ljava_lang_String_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCalloutTitle", "(Ljava/lang/String;)V"), __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static Delegate cb_getCanShowCallout;
#pragma warning disable 0169
		static Delegate GetGetCanShowCalloutHandler ()
		{
			if (cb_getCanShowCallout == null)
				cb_getCanShowCallout = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_GetCanShowCallout);
			return cb_getCanShowCallout;
		}

		static bool n_GetCanShowCallout (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.CanShowCallout;
		}
#pragma warning restore 0169

		static Delegate cb_setCanShowCallout_Z;
#pragma warning disable 0169
		static Delegate GetSetCanShowCallout_ZHandler ()
		{
			if (cb_setCanShowCallout_Z == null)
				cb_setCanShowCallout_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool>) n_SetCanShowCallout_Z);
			return cb_setCanShowCallout_Z;
		}

		static void n_SetCanShowCallout_Z (IntPtr jnienv, IntPtr native__this, bool p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.CanShowCallout = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getCanShowCallout;
		static IntPtr id_setCanShowCallout_Z;
		public virtual unsafe bool CanShowCallout {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getCanShowCallout' and count(parameter)=0]"
			[Register ("getCanShowCallout", "()Z", "GetGetCanShowCalloutHandler")]
			get {
				if (id_getCanShowCallout == IntPtr.Zero)
					id_getCanShowCallout = JNIEnv.GetMethodID (class_ref, "getCanShowCallout", "()Z");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_getCanShowCallout);
					else
						return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCanShowCallout", "()Z"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setCanShowCallout' and count(parameter)=1 and parameter[1][@type='boolean']]"
			[Register ("setCanShowCallout", "(Z)V", "GetSetCanShowCallout_ZHandler")]
			set {
				if (id_setCanShowCallout_Z == IntPtr.Zero)
					id_setCanShowCallout_Z = JNIEnv.GetMethodID (class_ref, "setCanShowCallout", "(Z)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setCanShowCallout_Z, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setCanShowCallout", "(Z)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getEnableClustering;
#pragma warning disable 0169
		static Delegate GetGetEnableClusteringHandler ()
		{
			if (cb_getEnableClustering == null)
				cb_getEnableClustering = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_GetEnableClustering);
			return cb_getEnableClustering;
		}

		static bool n_GetEnableClustering (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.EnableClustering;
		}
#pragma warning restore 0169

		static Delegate cb_setEnableClustering_Z;
#pragma warning disable 0169
		static Delegate GetSetEnableClustering_ZHandler ()
		{
			if (cb_setEnableClustering_Z == null)
				cb_setEnableClustering_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool>) n_SetEnableClustering_Z);
			return cb_setEnableClustering_Z;
		}

		static void n_SetEnableClustering_Z (IntPtr jnienv, IntPtr native__this, bool p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.EnableClustering = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getEnableClustering;
		static IntPtr id_setEnableClustering_Z;
		public virtual unsafe bool EnableClustering {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getEnableClustering' and count(parameter)=0]"
			[Register ("getEnableClustering", "()Z", "GetGetEnableClusteringHandler")]
			get {
				if (id_getEnableClustering == IntPtr.Zero)
					id_getEnableClustering = JNIEnv.GetMethodID (class_ref, "getEnableClustering", "()Z");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_getEnableClustering);
					else
						return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getEnableClustering", "()Z"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setEnableClustering' and count(parameter)=1 and parameter[1][@type='boolean']]"
			[Register ("setEnableClustering", "(Z)V", "GetSetEnableClustering_ZHandler")]
			set {
				if (id_setEnableClustering_Z == IntPtr.Zero)
					id_setEnableClustering_Z = JNIEnv.GetMethodID (class_ref, "setEnableClustering", "(Z)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setEnableClustering_Z, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setEnableClustering", "(Z)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getID;
#pragma warning disable 0169
		static Delegate GetGetIDHandler ()
		{
			if (cb_getID == null)
				cb_getID = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetID);
			return cb_getID;
		}

		static IntPtr n_GetID (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.ID);
		}
#pragma warning restore 0169

		static Delegate cb_setID_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetID_Ljava_lang_String_Handler ()
		{
			if (cb_setID_Ljava_lang_String_ == null)
				cb_setID_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetID_Ljava_lang_String_);
			return cb_setID_Ljava_lang_String_;
		}

		static void n_SetID_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.ID = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getID;
		static IntPtr id_setID_Ljava_lang_String_;
		public virtual unsafe string ID {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getID' and count(parameter)=0]"
			[Register ("getID", "()Ljava/lang/String;", "GetGetIDHandler")]
			get {
				if (id_getID == IntPtr.Zero)
					id_getID = JNIEnv.GetMethodID (class_ref, "getID", "()Ljava/lang/String;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getID), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getID", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setID' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setID", "(Ljava/lang/String;)V", "GetSetID_Ljava_lang_String_Handler")]
			set {
				if (id_setID_Ljava_lang_String_ == IntPtr.Zero)
					id_setID_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "setID", "(Ljava/lang/String;)V");
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setID_Ljava_lang_String_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setID", "(Ljava/lang/String;)V"), __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static Delegate cb_getIcon;
#pragma warning disable 0169
		static Delegate GetGetIconHandler ()
		{
			if (cb_getIcon == null)
				cb_getIcon = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetIcon);
			return cb_getIcon;
		}

		static IntPtr n_GetIcon (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Icon);
		}
#pragma warning restore 0169

		static Delegate cb_setIcon_Landroid_graphics_Bitmap_;
#pragma warning disable 0169
		static Delegate GetSetIcon_Landroid_graphics_Bitmap_Handler ()
		{
			if (cb_setIcon_Landroid_graphics_Bitmap_ == null)
				cb_setIcon_Landroid_graphics_Bitmap_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetIcon_Landroid_graphics_Bitmap_);
			return cb_setIcon_Landroid_graphics_Bitmap_;
		}

		static void n_SetIcon_Landroid_graphics_Bitmap_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.Icon = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getIcon;
		static IntPtr id_setIcon_Landroid_graphics_Bitmap_;
		public virtual unsafe global::Android.Graphics.Bitmap Icon {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getIcon' and count(parameter)=0]"
			[Register ("getIcon", "()Landroid/graphics/Bitmap;", "GetGetIconHandler")]
			get {
				if (id_getIcon == IntPtr.Zero)
					id_getIcon = JNIEnv.GetMethodID (class_ref, "getIcon", "()Landroid/graphics/Bitmap;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getIcon), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getIcon", "()Landroid/graphics/Bitmap;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setIcon' and count(parameter)=1 and parameter[1][@type='android.graphics.Bitmap']]"
			[Register ("setIcon", "(Landroid/graphics/Bitmap;)V", "GetSetIcon_Landroid_graphics_Bitmap_Handler")]
			set {
				if (id_setIcon_Landroid_graphics_Bitmap_ == IntPtr.Zero)
					id_setIcon_Landroid_graphics_Bitmap_ = JNIEnv.GetMethodID (class_ref, "setIcon", "(Landroid/graphics/Bitmap;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setIcon_Landroid_graphics_Bitmap_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setIcon", "(Landroid/graphics/Bitmap;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getName;
#pragma warning disable 0169
		static Delegate GetGetNameHandler ()
		{
			if (cb_getName == null)
				cb_getName = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetName);
			return cb_getName;
		}

		static IntPtr n_GetName (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.NewString (__this.Name);
		}
#pragma warning restore 0169

		static Delegate cb_setName_Ljava_lang_String_;
#pragma warning disable 0169
		static Delegate GetSetName_Ljava_lang_String_Handler ()
		{
			if (cb_setName_Ljava_lang_String_ == null)
				cb_setName_Ljava_lang_String_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetName_Ljava_lang_String_);
			return cb_setName_Ljava_lang_String_;
		}

		static void n_SetName_Ljava_lang_String_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			string p0 = JNIEnv.GetString (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.Name = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getName;
		static IntPtr id_setName_Ljava_lang_String_;
		public virtual unsafe string Name {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getName' and count(parameter)=0]"
			[Register ("getName", "()Ljava/lang/String;", "GetGetNameHandler")]
			get {
				if (id_getName == IntPtr.Zero)
					id_getName = JNIEnv.GetMethodID (class_ref, "getName", "()Ljava/lang/String;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getName), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getName", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setName' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
			[Register ("setName", "(Ljava/lang/String;)V", "GetSetName_Ljava_lang_String_Handler")]
			set {
				if (id_setName_Ljava_lang_String_ == IntPtr.Zero)
					id_setName_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "setName", "(Ljava/lang/String;)V");
				IntPtr native_value = JNIEnv.NewString (value);
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (native_value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setName_Ljava_lang_String_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setName", "(Ljava/lang/String;)V"), __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}

		static Delegate cb_getPositionX;
#pragma warning disable 0169
		static Delegate GetGetPositionXHandler ()
		{
			if (cb_getPositionX == null)
				cb_getPositionX = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, float>) n_GetPositionX);
			return cb_getPositionX;
		}

		static float n_GetPositionX (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.PositionX;
		}
#pragma warning restore 0169

		static IntPtr id_getPositionX;
		public virtual unsafe float PositionX {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getPositionX' and count(parameter)=0]"
			[Register ("getPositionX", "()F", "GetGetPositionXHandler")]
			get {
				if (id_getPositionX == IntPtr.Zero)
					id_getPositionX = JNIEnv.GetMethodID (class_ref, "getPositionX", "()F");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallFloatMethod (((global::Java.Lang.Object) this).Handle, id_getPositionX);
					else
						return JNIEnv.CallNonvirtualFloatMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getPositionX", "()F"));
				} finally {
				}
			}
		}

		static Delegate cb_getPositionY;
#pragma warning disable 0169
		static Delegate GetGetPositionYHandler ()
		{
			if (cb_getPositionY == null)
				cb_getPositionY = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, float>) n_GetPositionY);
			return cb_getPositionY;
		}

		static float n_GetPositionY (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.PositionY;
		}
#pragma warning restore 0169

		static IntPtr id_getPositionY;
		public virtual unsafe float PositionY {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getPositionY' and count(parameter)=0]"
			[Register ("getPositionY", "()F", "GetGetPositionYHandler")]
			get {
				if (id_getPositionY == IntPtr.Zero)
					id_getPositionY = JNIEnv.GetMethodID (class_ref, "getPositionY", "()F");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallFloatMethod (((global::Java.Lang.Object) this).Handle, id_getPositionY);
					else
						return JNIEnv.CallNonvirtualFloatMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getPositionY", "()F"));
				} finally {
				}
			}
		}

		static Delegate cb_getRect;
#pragma warning disable 0169
		static Delegate GetGetRectHandler ()
		{
			if (cb_getRect == null)
				cb_getRect = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetRect);
			return cb_getRect;
		}

		static IntPtr n_GetRect (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Rect);
		}
#pragma warning restore 0169

		static Delegate cb_setRect_Landroid_graphics_Rect_;
#pragma warning disable 0169
		static Delegate GetSetRect_Landroid_graphics_Rect_Handler ()
		{
			if (cb_setRect_Landroid_graphics_Rect_ == null)
				cb_setRect_Landroid_graphics_Rect_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetRect_Landroid_graphics_Rect_);
			return cb_setRect_Landroid_graphics_Rect_;
		}

		static void n_SetRect_Landroid_graphics_Rect_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Rect p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.Rect = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getRect;
		static IntPtr id_setRect_Landroid_graphics_Rect_;
		public virtual unsafe global::Android.Graphics.Rect Rect {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getRect' and count(parameter)=0]"
			[Register ("getRect", "()Landroid/graphics/Rect;", "GetGetRectHandler")]
			get {
				if (id_getRect == IntPtr.Zero)
					id_getRect = JNIEnv.GetMethodID (class_ref, "getRect", "()Landroid/graphics/Rect;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getRect), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Android.Graphics.Rect> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getRect", "()Landroid/graphics/Rect;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setRect' and count(parameter)=1 and parameter[1][@type='android.graphics.Rect']]"
			[Register ("setRect", "(Landroid/graphics/Rect;)V", "GetSetRect_Landroid_graphics_Rect_Handler")]
			set {
				if (id_setRect_Landroid_graphics_Rect_ == IntPtr.Zero)
					id_setRect_Landroid_graphics_Rect_ = JNIEnv.GetMethodID (class_ref, "setRect", "(Landroid/graphics/Rect;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setRect_Landroid_graphics_Rect_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setRect", "(Landroid/graphics/Rect;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getTMapPoint;
#pragma warning disable 0169
		static Delegate GetGetTMapPointHandler ()
		{
			if (cb_getTMapPoint == null)
				cb_getTMapPoint = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetTMapPoint);
			return cb_getTMapPoint;
		}

		static IntPtr n_GetTMapPoint (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.TMapPoint);
		}
#pragma warning restore 0169

		static Delegate cb_setTMapPoint_Lcom_skp_Tmap_TMapPoint_;
#pragma warning disable 0169
		static Delegate GetSetTMapPoint_Lcom_skp_Tmap_TMapPoint_Handler ()
		{
			if (cb_setTMapPoint_Lcom_skp_Tmap_TMapPoint_ == null)
				cb_setTMapPoint_Lcom_skp_Tmap_TMapPoint_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetTMapPoint_Lcom_skp_Tmap_TMapPoint_);
			return cb_setTMapPoint_Lcom_skp_Tmap_TMapPoint_;
		}

		static void n_SetTMapPoint_Lcom_skp_Tmap_TMapPoint_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.TMapPoint p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.TMapPoint = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getTMapPoint;
		static IntPtr id_setTMapPoint_Lcom_skp_Tmap_TMapPoint_;
		public virtual unsafe global::Com.Skp.Tmap.TMapPoint TMapPoint {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getTMapPoint' and count(parameter)=0]"
			[Register ("getTMapPoint", "()Lcom/skp/Tmap/TMapPoint;", "GetGetTMapPointHandler")]
			get {
				if (id_getTMapPoint == IntPtr.Zero)
					id_getTMapPoint = JNIEnv.GetMethodID (class_ref, "getTMapPoint", "()Lcom/skp/Tmap/TMapPoint;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getTMapPoint), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPoint> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getTMapPoint", "()Lcom/skp/Tmap/TMapPoint;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setTMapPoint' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapPoint']]"
			[Register ("setTMapPoint", "(Lcom/skp/Tmap/TMapPoint;)V", "GetSetTMapPoint_Lcom_skp_Tmap_TMapPoint_Handler")]
			set {
				if (id_setTMapPoint_Lcom_skp_Tmap_TMapPoint_ == IntPtr.Zero)
					id_setTMapPoint_Lcom_skp_Tmap_TMapPoint_ = JNIEnv.GetMethodID (class_ref, "setTMapPoint", "(Lcom/skp/Tmap/TMapPoint;)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setTMapPoint_Lcom_skp_Tmap_TMapPoint_, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setTMapPoint", "(Lcom/skp/Tmap/TMapPoint;)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_getVisible;
#pragma warning disable 0169
		static Delegate GetGetVisibleHandler ()
		{
			if (cb_getVisible == null)
				cb_getVisible = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetVisible);
			return cb_getVisible;
		}

		static int n_GetVisible (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.Visible;
		}
#pragma warning restore 0169

		static Delegate cb_setVisible_I;
#pragma warning disable 0169
		static Delegate GetSetVisible_IHandler ()
		{
			if (cb_setVisible_I == null)
				cb_setVisible_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetVisible_I);
			return cb_setVisible_I;
		}

		static void n_SetVisible_I (IntPtr jnienv, IntPtr native__this, int p0)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Visible = p0;
		}
#pragma warning restore 0169

		static IntPtr id_getVisible;
		static IntPtr id_setVisible_I;
		public virtual unsafe int Visible {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='getVisible' and count(parameter)=0]"
			[Register ("getVisible", "()I", "GetGetVisibleHandler")]
			get {
				if (id_getVisible == IntPtr.Zero)
					id_getVisible = JNIEnv.GetMethodID (class_ref, "getVisible", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getVisible);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getVisible", "()I"));
				} finally {
				}
			}
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setVisible' and count(parameter)=1 and parameter[1][@type='int']]"
			[Register ("setVisible", "(I)V", "GetSetVisible_IHandler")]
			set {
				if (id_setVisible_I == IntPtr.Zero)
					id_setVisible_I = JNIEnv.GetMethodID (class_ref, "setVisible", "(I)V");
				try {
					JValue* __args = stackalloc JValue [1];
					__args [0] = new JValue (value);

					if (((object) this).GetType () == ThresholdType)
						JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setVisible_I, __args);
					else
						JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setVisible", "(I)V"), __args);
				} finally {
				}
			}
		}

		static Delegate cb_setPosition_FF;
#pragma warning disable 0169
		static Delegate GetSetPosition_FFHandler ()
		{
			if (cb_setPosition_FF == null)
				cb_setPosition_FF = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float, float>) n_SetPosition_FF);
			return cb_setPosition_FF;
		}

		static void n_SetPosition_FF (IntPtr jnienv, IntPtr native__this, float p0, float p1)
		{
			global::Com.Skp.Tmap.TMapMarkerItem __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapMarkerItem> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.SetPosition (p0, p1);
		}
#pragma warning restore 0169

		static IntPtr id_setPosition_FF;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapMarkerItem']/method[@name='setPosition' and count(parameter)=2 and parameter[1][@type='float'] and parameter[2][@type='float']]"
		[Register ("setPosition", "(FF)V", "GetSetPosition_FFHandler")]
		public virtual unsafe void SetPosition (float p0, float p1)
		{
			if (id_setPosition_FF == IntPtr.Zero)
				id_setPosition_FF = JNIEnv.GetMethodID (class_ref, "setPosition", "(FF)V");
			try {
				JValue* __args = stackalloc JValue [2];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setPosition_FF, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setPosition", "(FF)V"), __args);
			} finally {
			}
		}

	}
}
