using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']"
	[global::Android.Runtime.Register ("com/skp/Tmap/TMapPathLayer", DoNotGenerateAcw=true)]
	public partial class TMapPathLayer : global::Java.Lang.Object, global::Com.Skp.Tmap.ITMapLayer {


		static IntPtr polyline_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/field[@name='polyline']"
		[Register ("polyline")]
		public global::Com.Skp.Tmap.TMapPolyLine Polyline {
			get {
				if (polyline_jfieldId == IntPtr.Zero)
					polyline_jfieldId = JNIEnv.GetFieldID (class_ref, "polyline", "Lcom/skp/Tmap/TMapPolyLine;");
				IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, polyline_jfieldId);
				return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLine> (__ret, JniHandleOwnership.TransferLocalRef);
			}
			set {
				if (polyline_jfieldId == IntPtr.Zero)
					polyline_jfieldId = JNIEnv.GetFieldID (class_ref, "polyline", "Lcom/skp/Tmap/TMapPolyLine;");
				IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, polyline_jfieldId, native_value);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}
		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/TMapPathLayer", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (TMapPathLayer); }
		}

		protected TMapPathLayer (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor_Landroid_content_Context_;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/constructor[@name='TMapPathLayer' and count(parameter)=1 and parameter[1][@type='android.content.Context']]"
		[Register (".ctor", "(Landroid/content/Context;)V", "")]
		public unsafe TMapPathLayer (global::Android.Content.Context p0)
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				if (((object) this).GetType () != typeof (TMapPathLayer)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Landroid/content/Context;)V", __args),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Landroid/content/Context;)V", __args);
					return;
				}

				if (id_ctor_Landroid_content_Context_ == IntPtr.Zero)
					id_ctor_Landroid_content_Context_ = JNIEnv.GetMethodID (class_ref, "<init>", "(Landroid/content/Context;)V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Landroid_content_Context_, __args),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Landroid_content_Context_, __args);
			} finally {
			}
		}

		static Delegate cb_destroyTMapLayer;
#pragma warning disable 0169
		static Delegate GetDestroyTMapLayerHandler ()
		{
			if (cb_destroyTMapLayer == null)
				cb_destroyTMapLayer = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_DestroyTMapLayer);
			return cb_destroyTMapLayer;
		}

		static void n_DestroyTMapLayer (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.DestroyTMapLayer ();
		}
#pragma warning restore 0169

		static IntPtr id_destroyTMapLayer;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='destroyTMapLayer' and count(parameter)=0]"
		[Register ("destroyTMapLayer", "()V", "GetDestroyTMapLayerHandler")]
		public virtual unsafe void DestroyTMapLayer ()
		{
			if (id_destroyTMapLayer == IntPtr.Zero)
				id_destroyTMapLayer = JNIEnv.GetMethodID (class_ref, "destroyTMapLayer", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_destroyTMapLayer);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "destroyTMapLayer", "()V"));
			} finally {
			}
		}

		static Delegate cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
#pragma warning disable 0169
		static Delegate GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler ()
		{
			if (cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == null)
				cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr, bool>) n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z);
			return cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		}

		static void n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1, bool p2)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Canvas p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Canvas> (native_p0, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.RectF p1 = global::Java.Lang.Object.GetObject<global::Android.Graphics.RectF> (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.Draw (p0, p1, p2);
		}
#pragma warning restore 0169

		static IntPtr id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='draw' and count(parameter)=3 and parameter[1][@type='android.graphics.Canvas'] and parameter[2][@type='android.graphics.RectF'] and parameter[3][@type='boolean']]"
		[Register ("draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V", "GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler")]
		public virtual unsafe void Draw (global::Android.Graphics.Canvas p0, global::Android.Graphics.RectF p1, bool p2)
		{
			if (id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == IntPtr.Zero)
				id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNIEnv.GetMethodID (class_ref, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V");
			try {
				JValue* __args = stackalloc JValue [3];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V"), __args);
			} finally {
			}
		}

		static Delegate cb_drawInScreenPixels;
#pragma warning disable 0169
		static Delegate GetDrawInScreenPixelsHandler ()
		{
			if (cb_drawInScreenPixels == null)
				cb_drawInScreenPixels = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_DrawInScreenPixels);
			return cb_drawInScreenPixels;
		}

		static bool n_DrawInScreenPixels (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.DrawInScreenPixels ();
		}
#pragma warning restore 0169

		static IntPtr id_drawInScreenPixels;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='drawInScreenPixels' and count(parameter)=0]"
		[Register ("drawInScreenPixels", "()Z", "GetDrawInScreenPixelsHandler")]
		public virtual unsafe bool DrawInScreenPixels ()
		{
			if (id_drawInScreenPixels == IntPtr.Zero)
				id_drawInScreenPixels = JNIEnv.GetMethodID (class_ref, "drawInScreenPixels", "()Z");
			try {

				if (((object) this).GetType () == ThresholdType)
					return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_drawInScreenPixels);
				else
					return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "drawInScreenPixels", "()Z"));
			} finally {
			}
		}

		static Delegate cb_initLayer_Lcom_skp_Tmap_TMapView_;
#pragma warning disable 0169
		static Delegate GetInitLayer_Lcom_skp_Tmap_TMapView_Handler ()
		{
			if (cb_initLayer_Lcom_skp_Tmap_TMapView_ == null)
				cb_initLayer_Lcom_skp_Tmap_TMapView_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_InitLayer_Lcom_skp_Tmap_TMapView_);
			return cb_initLayer_Lcom_skp_Tmap_TMapView_;
		}

		static void n_InitLayer_Lcom_skp_Tmap_TMapView_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.TMapView p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapView> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.InitLayer (p0);
		}
#pragma warning restore 0169

		static IntPtr id_initLayer_Lcom_skp_Tmap_TMapView_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='initLayer' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapView']]"
		[Register ("initLayer", "(Lcom/skp/Tmap/TMapView;)V", "GetInitLayer_Lcom_skp_Tmap_TMapView_Handler")]
		public virtual unsafe void InitLayer (global::Com.Skp.Tmap.TMapView p0)
		{
			if (id_initLayer_Lcom_skp_Tmap_TMapView_ == IntPtr.Zero)
				id_initLayer_Lcom_skp_Tmap_TMapView_ = JNIEnv.GetMethodID (class_ref, "initLayer", "(Lcom/skp/Tmap/TMapView;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_initLayer_Lcom_skp_Tmap_TMapView_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "initLayer", "(Lcom/skp/Tmap/TMapView;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_onLongPressEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnLongPressEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onLongPressEvent_Landroid_graphics_PointF_ == null)
				cb_onLongPressEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnLongPressEvent_Landroid_graphics_PointF_);
			return cb_onLongPressEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnLongPressEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnLongPressEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_onLongPressEvent_Landroid_graphics_PointF_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='onLongPressEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onLongPressEvent", "(Landroid/graphics/PointF;)Z", "GetOnLongPressEvent_Landroid_graphics_PointF_Handler")]
		public virtual unsafe bool OnLongPressEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onLongPressEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onLongPressEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onLongPressEvent", "(Landroid/graphics/PointF;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onLongPressEvent_Landroid_graphics_PointF_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "onLongPressEvent", "(Landroid/graphics/PointF;)Z"), __args);
				return __ret;
			} finally {
			}
		}

		static Delegate cb_onTouchEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnTouchEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onTouchEvent_Landroid_graphics_PointF_ == null)
				cb_onTouchEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnTouchEvent_Landroid_graphics_PointF_);
			return cb_onTouchEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnTouchEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnTouchEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_onTouchEvent_Landroid_graphics_PointF_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='onTouchEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onTouchEvent", "(Landroid/graphics/PointF;)Z", "GetOnTouchEvent_Landroid_graphics_PointF_Handler")]
		public virtual unsafe bool OnTouchEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onTouchEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onTouchEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onTouchEvent", "(Landroid/graphics/PointF;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onTouchEvent_Landroid_graphics_PointF_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "onTouchEvent", "(Landroid/graphics/PointF;)Z"), __args);
				return __ret;
			} finally {
			}
		}

		static Delegate cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_;
#pragma warning disable 0169
		static Delegate GetSetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Handler ()
		{
			if (cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ == null)
				cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr>) n_SetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_);
			return cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_;
		}

		static void n_SetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p0, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p1 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.SetIcon (p0, p1);
		}
#pragma warning restore 0169

		static IntPtr id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='setIcon' and count(parameter)=2 and parameter[1][@type='android.graphics.Bitmap'] and parameter[2][@type='android.graphics.Bitmap']]"
		[Register ("setIcon", "(Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;)V", "GetSetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Handler")]
		public virtual unsafe void SetIcon (global::Android.Graphics.Bitmap p0, global::Android.Graphics.Bitmap p1)
		{
			if (id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ == IntPtr.Zero)
				id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ = JNIEnv.GetMethodID (class_ref, "setIcon", "(Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;)V");
			try {
				JValue* __args = stackalloc JValue [2];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setIcon", "(Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_;
#pragma warning disable 0169
		static Delegate GetSetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Handler ()
		{
			if (cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ == null)
				cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr, IntPtr>) n_SetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_);
			return cb_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_;
		}

		static void n_SetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1, IntPtr native_p2)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p0, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p1 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p1, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Bitmap p2 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Bitmap> (native_p2, JniHandleOwnership.DoNotTransfer);
			__this.SetIcon (p0, p1, p2);
		}
#pragma warning restore 0169

		static IntPtr id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='setIcon' and count(parameter)=3 and parameter[1][@type='android.graphics.Bitmap'] and parameter[2][@type='android.graphics.Bitmap'] and parameter[3][@type='android.graphics.Bitmap']]"
		[Register ("setIcon", "(Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;)V", "GetSetIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Handler")]
		public virtual unsafe void SetIcon (global::Android.Graphics.Bitmap p0, global::Android.Graphics.Bitmap p1, global::Android.Graphics.Bitmap p2)
		{
			if (id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ == IntPtr.Zero)
				id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_ = JNIEnv.GetMethodID (class_ref, "setIcon", "(Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;)V");
			try {
				JValue* __args = stackalloc JValue [3];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setIcon_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_Landroid_graphics_Bitmap_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setIcon", "(Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;Landroid/graphics/Bitmap;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_setRotate_Z;
#pragma warning disable 0169
		static Delegate GetSetRotate_ZHandler ()
		{
			if (cb_setRotate_Z == null)
				cb_setRotate_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, bool>) n_SetRotate_Z);
			return cb_setRotate_Z;
		}

		static void n_SetRotate_Z (IntPtr jnienv, IntPtr native__this, bool p0)
		{
			global::Com.Skp.Tmap.TMapPathLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPathLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.SetRotate (p0);
		}
#pragma warning restore 0169

		static IntPtr id_setRotate_Z;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPathLayer']/method[@name='setRotate' and count(parameter)=1 and parameter[1][@type='boolean']]"
		[Register ("setRotate", "(Z)V", "GetSetRotate_ZHandler")]
		public virtual unsafe void SetRotate (bool p0)
		{
			if (id_setRotate_Z == IntPtr.Zero)
				id_setRotate_Z = JNIEnv.GetMethodID (class_ref, "setRotate", "(Z)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setRotate_Z, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setRotate", "(Z)V"), __args);
			} finally {
			}
		}

	}
}
