using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']"
	[global::Android.Runtime.Register ("com/skp/Tmap/TMapPolyLineLayer", DoNotGenerateAcw=true)]
	public partial class TMapPolyLineLayer : global::Java.Lang.Object, global::Com.Skp.Tmap.ITMapLayer {


		static IntPtr mPolyLines_jfieldId;

		// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/field[@name='mPolyLines']"
		[Register ("mPolyLines")]
		public global::System.Collections.IDictionary MPolyLines {
			get {
				if (mPolyLines_jfieldId == IntPtr.Zero)
					mPolyLines_jfieldId = JNIEnv.GetFieldID (class_ref, "mPolyLines", "Ljava/util/Map;");
				IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, mPolyLines_jfieldId);
				return global::Android.Runtime.JavaDictionary.FromJniHandle (__ret, JniHandleOwnership.TransferLocalRef);
			}
			set {
				if (mPolyLines_jfieldId == IntPtr.Zero)
					mPolyLines_jfieldId = JNIEnv.GetFieldID (class_ref, "mPolyLines", "Ljava/util/Map;");
				IntPtr native_value = global::Android.Runtime.JavaDictionary.ToLocalJniHandle (value);
				try {
					JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mPolyLines_jfieldId, native_value);
				} finally {
					JNIEnv.DeleteLocalRef (native_value);
				}
			}
		}
		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/TMapPolyLineLayer", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (TMapPolyLineLayer); }
		}

		protected TMapPolyLineLayer (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/constructor[@name='TMapPolyLineLayer' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe TMapPolyLineLayer ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				if (((object) this).GetType () != typeof (TMapPolyLineLayer)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "()V"),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
					return;
				}

				if (id_ctor == IntPtr.Zero)
					id_ctor = JNIEnv.GetMethodID (class_ref, "<init>", "()V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor);
			} finally {
			}
		}

		static Delegate cb_destroyTMapLayer;
#pragma warning disable 0169
		static Delegate GetDestroyTMapLayerHandler ()
		{
			if (cb_destroyTMapLayer == null)
				cb_destroyTMapLayer = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_DestroyTMapLayer);
			return cb_destroyTMapLayer;
		}

		static void n_DestroyTMapLayer (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapPolyLineLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLineLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.DestroyTMapLayer ();
		}
#pragma warning restore 0169

		static IntPtr id_destroyTMapLayer;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/method[@name='destroyTMapLayer' and count(parameter)=0]"
		[Register ("destroyTMapLayer", "()V", "GetDestroyTMapLayerHandler")]
		public virtual unsafe void DestroyTMapLayer ()
		{
			if (id_destroyTMapLayer == IntPtr.Zero)
				id_destroyTMapLayer = JNIEnv.GetMethodID (class_ref, "destroyTMapLayer", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_destroyTMapLayer);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "destroyTMapLayer", "()V"));
			} finally {
			}
		}

		static Delegate cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
#pragma warning disable 0169
		static Delegate GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler ()
		{
			if (cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == null)
				cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr, IntPtr, bool>) n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z);
			return cb_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		}

		static void n_Draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z (IntPtr jnienv, IntPtr native__this, IntPtr native_p0, IntPtr native_p1, bool p2)
		{
			global::Com.Skp.Tmap.TMapPolyLineLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLineLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.Canvas p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.Canvas> (native_p0, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.RectF p1 = global::Java.Lang.Object.GetObject<global::Android.Graphics.RectF> (native_p1, JniHandleOwnership.DoNotTransfer);
			__this.Draw (p0, p1, p2);
		}
#pragma warning restore 0169

		static IntPtr id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/method[@name='draw' and count(parameter)=3 and parameter[1][@type='android.graphics.Canvas'] and parameter[2][@type='android.graphics.RectF'] and parameter[3][@type='boolean']]"
		[Register ("draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V", "GetDraw_Landroid_graphics_Canvas_Landroid_graphics_RectF_ZHandler")]
		public virtual unsafe void Draw (global::Android.Graphics.Canvas p0, global::Android.Graphics.RectF p1, bool p2)
		{
			if (id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z == IntPtr.Zero)
				id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z = JNIEnv.GetMethodID (class_ref, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V");
			try {
				JValue* __args = stackalloc JValue [3];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_draw_Landroid_graphics_Canvas_Landroid_graphics_RectF_Z, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "draw", "(Landroid/graphics/Canvas;Landroid/graphics/RectF;Z)V"), __args);
			} finally {
			}
		}

		static Delegate cb_drawInScreenPixels;
#pragma warning disable 0169
		static Delegate GetDrawInScreenPixelsHandler ()
		{
			if (cb_drawInScreenPixels == null)
				cb_drawInScreenPixels = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_DrawInScreenPixels);
			return cb_drawInScreenPixels;
		}

		static bool n_DrawInScreenPixels (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.TMapPolyLineLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLineLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.DrawInScreenPixels ();
		}
#pragma warning restore 0169

		static IntPtr id_drawInScreenPixels;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/method[@name='drawInScreenPixels' and count(parameter)=0]"
		[Register ("drawInScreenPixels", "()Z", "GetDrawInScreenPixelsHandler")]
		public virtual unsafe bool DrawInScreenPixels ()
		{
			if (id_drawInScreenPixels == IntPtr.Zero)
				id_drawInScreenPixels = JNIEnv.GetMethodID (class_ref, "drawInScreenPixels", "()Z");
			try {

				if (((object) this).GetType () == ThresholdType)
					return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_drawInScreenPixels);
				else
					return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "drawInScreenPixels", "()Z"));
			} finally {
			}
		}

		static Delegate cb_initLayer_Lcom_skp_Tmap_TMapView_;
#pragma warning disable 0169
		static Delegate GetInitLayer_Lcom_skp_Tmap_TMapView_Handler ()
		{
			if (cb_initLayer_Lcom_skp_Tmap_TMapView_ == null)
				cb_initLayer_Lcom_skp_Tmap_TMapView_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_InitLayer_Lcom_skp_Tmap_TMapView_);
			return cb_initLayer_Lcom_skp_Tmap_TMapView_;
		}

		static void n_InitLayer_Lcom_skp_Tmap_TMapView_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapPolyLineLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLineLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.TMapView p0 = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapView> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.InitLayer (p0);
		}
#pragma warning restore 0169

		static IntPtr id_initLayer_Lcom_skp_Tmap_TMapView_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/method[@name='initLayer' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapView']]"
		[Register ("initLayer", "(Lcom/skp/Tmap/TMapView;)V", "GetInitLayer_Lcom_skp_Tmap_TMapView_Handler")]
		public virtual unsafe void InitLayer (global::Com.Skp.Tmap.TMapView p0)
		{
			if (id_initLayer_Lcom_skp_Tmap_TMapView_ == IntPtr.Zero)
				id_initLayer_Lcom_skp_Tmap_TMapView_ = JNIEnv.GetMethodID (class_ref, "initLayer", "(Lcom/skp/Tmap/TMapView;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_initLayer_Lcom_skp_Tmap_TMapView_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "initLayer", "(Lcom/skp/Tmap/TMapView;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_onLongPressEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnLongPressEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onLongPressEvent_Landroid_graphics_PointF_ == null)
				cb_onLongPressEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnLongPressEvent_Landroid_graphics_PointF_);
			return cb_onLongPressEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnLongPressEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapPolyLineLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLineLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnLongPressEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_onLongPressEvent_Landroid_graphics_PointF_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/method[@name='onLongPressEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onLongPressEvent", "(Landroid/graphics/PointF;)Z", "GetOnLongPressEvent_Landroid_graphics_PointF_Handler")]
		public virtual unsafe bool OnLongPressEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onLongPressEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onLongPressEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onLongPressEvent", "(Landroid/graphics/PointF;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onLongPressEvent_Landroid_graphics_PointF_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "onLongPressEvent", "(Landroid/graphics/PointF;)Z"), __args);
				return __ret;
			} finally {
			}
		}

		static Delegate cb_onTouchEvent_Landroid_graphics_PointF_;
#pragma warning disable 0169
		static Delegate GetOnTouchEvent_Landroid_graphics_PointF_Handler ()
		{
			if (cb_onTouchEvent_Landroid_graphics_PointF_ == null)
				cb_onTouchEvent_Landroid_graphics_PointF_ = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr, bool>) n_OnTouchEvent_Landroid_graphics_PointF_);
			return cb_onTouchEvent_Landroid_graphics_PointF_;
		}

		static bool n_OnTouchEvent_Landroid_graphics_PointF_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.TMapPolyLineLayer __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TMapPolyLineLayer> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Android.Graphics.PointF p0 = global::Java.Lang.Object.GetObject<global::Android.Graphics.PointF> (native_p0, JniHandleOwnership.DoNotTransfer);
			bool __ret = __this.OnTouchEvent (p0);
			return __ret;
		}
#pragma warning restore 0169

		static IntPtr id_onTouchEvent_Landroid_graphics_PointF_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TMapPolyLineLayer']/method[@name='onTouchEvent' and count(parameter)=1 and parameter[1][@type='android.graphics.PointF']]"
		[Register ("onTouchEvent", "(Landroid/graphics/PointF;)Z", "GetOnTouchEvent_Landroid_graphics_PointF_Handler")]
		public virtual unsafe bool OnTouchEvent (global::Android.Graphics.PointF p0)
		{
			if (id_onTouchEvent_Landroid_graphics_PointF_ == IntPtr.Zero)
				id_onTouchEvent_Landroid_graphics_PointF_ = JNIEnv.GetMethodID (class_ref, "onTouchEvent", "(Landroid/graphics/PointF;)Z");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				bool __ret;
				if (((object) this).GetType () == ThresholdType)
					__ret = JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_onTouchEvent_Landroid_graphics_PointF_, __args);
				else
					__ret = JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "onTouchEvent", "(Landroid/graphics/PointF;)Z"), __args);
				return __ret;
			} finally {
			}
		}

	}
}
