using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']"
	[global::Android.Runtime.Register ("com/skp/Tmap/DraggingAnimateThread", DoNotGenerateAcw=true)]
	public partial class DraggingAnimateThread : global::Java.Lang.Object, global::Java.Lang.IRunnable {

		// Metadata.xml XPath interface reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']"
		[Register ("com/skp/Tmap/DraggingAnimateThread$DraggingCallback", "", "Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker")]
		public partial interface IDraggingCallback : IJavaObject {

			float RotateData {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='getRotateData' and count(parameter)=0]"
				[Register ("getRotateData", "()F", "GetGetRotateDataHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")] get;
			}

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='drag' and count(parameter)=5 and parameter[1][@type='float'] and parameter[2][@type='float'] and parameter[3][@type='float'] and parameter[4][@type='float'] and parameter[5][@type='boolean']]"
			[Register ("drag", "(FFFFZ)V", "GetDrag_FFFFZHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")]
			void Drag (float p0, float p1, float p2, float p3, bool p4);

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='rotate' and count(parameter)=1 and parameter[1][@type='float']]"
			[Register ("rotate", "(F)V", "GetRotate_FHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")]
			void Rotate (float p0);

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='setTMapPoint' and count(parameter)=3 and parameter[1][@type='double'] and parameter[2][@type='double'] and parameter[3][@type='boolean']]"
			[Register ("setTMapPoint", "(DDZ)V", "GetSetTMapPoint_DDZHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")]
			void SetTMapPoint (double p0, double p1, bool p2);

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='zoom' and count(parameter)=2 and parameter[1][@type='float'] and parameter[2][@type='boolean']]"
			[Register ("zoom", "(FZ)V", "GetZoom_FZHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")]
			void Zoom (float p0, bool p1);

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='zoomEnd' and count(parameter)=1 and parameter[1][@type='float']]"
			[Register ("zoomEnd", "(F)V", "GetZoomEnd_FHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")]
			void ZoomEnd (float p0);

			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/interface[@name='DraggingAnimateThread.DraggingCallback']/method[@name='zoomStart' and count(parameter)=2 and parameter[1][@type='int'] and parameter[2][@type='int']]"
			[Register ("zoomStart", "(II)V", "GetZoomStart_IIHandler:Com.Skp.Tmap.DraggingAnimateThread/IDraggingCallbackInvoker, TmapBindTest")]
			void ZoomStart (int p0, int p1);

		}

		[global::Android.Runtime.Register ("com/skp/Tmap/DraggingAnimateThread$DraggingCallback", DoNotGenerateAcw=true)]
		internal class IDraggingCallbackInvoker : global::Java.Lang.Object, IDraggingCallback {

			static IntPtr java_class_ref = JNIEnv.FindClass ("com/skp/Tmap/DraggingAnimateThread$DraggingCallback");

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (IDraggingCallbackInvoker); }
			}

			IntPtr class_ref;

			public static IDraggingCallback GetObject (IntPtr handle, JniHandleOwnership transfer)
			{
				return global::Java.Lang.Object.GetObject<IDraggingCallback> (handle, transfer);
			}

			static IntPtr Validate (IntPtr handle)
			{
				if (!JNIEnv.IsInstanceOf (handle, java_class_ref))
					throw new InvalidCastException (string.Format ("Unable to convert instance of type '{0}' to type '{1}'.",
								JNIEnv.GetClassNameFromInstance (handle), "com.skp.Tmap.DraggingAnimateThread.DraggingCallback"));
				return handle;
			}

			protected override void Dispose (bool disposing)
			{
				if (this.class_ref != IntPtr.Zero)
					JNIEnv.DeleteGlobalRef (this.class_ref);
				this.class_ref = IntPtr.Zero;
				base.Dispose (disposing);
			}

			public IDraggingCallbackInvoker (IntPtr handle, JniHandleOwnership transfer) : base (Validate (handle), transfer)
			{
				IntPtr local_ref = JNIEnv.GetObjectClass (((global::Java.Lang.Object) this).Handle);
				this.class_ref = JNIEnv.NewGlobalRef (local_ref);
				JNIEnv.DeleteLocalRef (local_ref);
			}

			static Delegate cb_getRotateData;
#pragma warning disable 0169
			static Delegate GetGetRotateDataHandler ()
			{
				if (cb_getRotateData == null)
					cb_getRotateData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, float>) n_GetRotateData);
				return cb_getRotateData;
			}

			static float n_GetRotateData (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.RotateData;
			}
#pragma warning restore 0169

			IntPtr id_getRotateData;
			public unsafe float RotateData {
				get {
					if (id_getRotateData == IntPtr.Zero)
						id_getRotateData = JNIEnv.GetMethodID (class_ref, "getRotateData", "()F");
					return JNIEnv.CallFloatMethod (((global::Java.Lang.Object) this).Handle, id_getRotateData);
				}
			}

			static Delegate cb_drag_FFFFZ;
#pragma warning disable 0169
			static Delegate GetDrag_FFFFZHandler ()
			{
				if (cb_drag_FFFFZ == null)
					cb_drag_FFFFZ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float, float, float, float, bool>) n_Drag_FFFFZ);
				return cb_drag_FFFFZ;
			}

			static void n_Drag_FFFFZ (IntPtr jnienv, IntPtr native__this, float p0, float p1, float p2, float p3, bool p4)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.Drag (p0, p1, p2, p3, p4);
			}
#pragma warning restore 0169

			IntPtr id_drag_FFFFZ;
			public unsafe void Drag (float p0, float p1, float p2, float p3, bool p4)
			{
				if (id_drag_FFFFZ == IntPtr.Zero)
					id_drag_FFFFZ = JNIEnv.GetMethodID (class_ref, "drag", "(FFFFZ)V");
				JValue* __args = stackalloc JValue [5];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);
				__args [3] = new JValue (p3);
				__args [4] = new JValue (p4);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_drag_FFFFZ, __args);
			}

			static Delegate cb_rotate_F;
#pragma warning disable 0169
			static Delegate GetRotate_FHandler ()
			{
				if (cb_rotate_F == null)
					cb_rotate_F = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float>) n_Rotate_F);
				return cb_rotate_F;
			}

			static void n_Rotate_F (IntPtr jnienv, IntPtr native__this, float p0)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.Rotate (p0);
			}
#pragma warning restore 0169

			IntPtr id_rotate_F;
			public unsafe void Rotate (float p0)
			{
				if (id_rotate_F == IntPtr.Zero)
					id_rotate_F = JNIEnv.GetMethodID (class_ref, "rotate", "(F)V");
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_rotate_F, __args);
			}

			static Delegate cb_setTMapPoint_DDZ;
#pragma warning disable 0169
			static Delegate GetSetTMapPoint_DDZHandler ()
			{
				if (cb_setTMapPoint_DDZ == null)
					cb_setTMapPoint_DDZ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, double, double, bool>) n_SetTMapPoint_DDZ);
				return cb_setTMapPoint_DDZ;
			}

			static void n_SetTMapPoint_DDZ (IntPtr jnienv, IntPtr native__this, double p0, double p1, bool p2)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.SetTMapPoint (p0, p1, p2);
			}
#pragma warning restore 0169

			IntPtr id_setTMapPoint_DDZ;
			public unsafe void SetTMapPoint (double p0, double p1, bool p2)
			{
				if (id_setTMapPoint_DDZ == IntPtr.Zero)
					id_setTMapPoint_DDZ = JNIEnv.GetMethodID (class_ref, "setTMapPoint", "(DDZ)V");
				JValue* __args = stackalloc JValue [3];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setTMapPoint_DDZ, __args);
			}

			static Delegate cb_zoom_FZ;
#pragma warning disable 0169
			static Delegate GetZoom_FZHandler ()
			{
				if (cb_zoom_FZ == null)
					cb_zoom_FZ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float, bool>) n_Zoom_FZ);
				return cb_zoom_FZ;
			}

			static void n_Zoom_FZ (IntPtr jnienv, IntPtr native__this, float p0, bool p1)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.Zoom (p0, p1);
			}
#pragma warning restore 0169

			IntPtr id_zoom_FZ;
			public unsafe void Zoom (float p0, bool p1)
			{
				if (id_zoom_FZ == IntPtr.Zero)
					id_zoom_FZ = JNIEnv.GetMethodID (class_ref, "zoom", "(FZ)V");
				JValue* __args = stackalloc JValue [2];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_zoom_FZ, __args);
			}

			static Delegate cb_zoomEnd_F;
#pragma warning disable 0169
			static Delegate GetZoomEnd_FHandler ()
			{
				if (cb_zoomEnd_F == null)
					cb_zoomEnd_F = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float>) n_ZoomEnd_F);
				return cb_zoomEnd_F;
			}

			static void n_ZoomEnd_F (IntPtr jnienv, IntPtr native__this, float p0)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.ZoomEnd (p0);
			}
#pragma warning restore 0169

			IntPtr id_zoomEnd_F;
			public unsafe void ZoomEnd (float p0)
			{
				if (id_zoomEnd_F == IntPtr.Zero)
					id_zoomEnd_F = JNIEnv.GetMethodID (class_ref, "zoomEnd", "(F)V");
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_zoomEnd_F, __args);
			}

			static Delegate cb_zoomStart_II;
#pragma warning disable 0169
			static Delegate GetZoomStart_IIHandler ()
			{
				if (cb_zoomStart_II == null)
					cb_zoomStart_II = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int, int>) n_ZoomStart_II);
				return cb_zoomStart_II;
			}

			static void n_ZoomStart_II (IntPtr jnienv, IntPtr native__this, int p0, int p1)
			{
				global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.ZoomStart (p0, p1);
			}
#pragma warning restore 0169

			IntPtr id_zoomStart_II;
			public unsafe void ZoomStart (int p0, int p1)
			{
				if (id_zoomStart_II == IntPtr.Zero)
					id_zoomStart_II = JNIEnv.GetMethodID (class_ref, "zoomStart", "(II)V");
				JValue* __args = stackalloc JValue [2];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_zoomStart_II, __args);
			}

		}


		// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread.HasWork']"
		[global::Android.Runtime.Register ("com/skp/Tmap/DraggingAnimateThread$HasWork", DoNotGenerateAcw=true)]
		public partial class HasWork : global::Java.Lang.Thread {

			internal static new IntPtr java_class_handle;
			internal static new IntPtr class_ref {
				get {
					return JNIEnv.FindClass ("com/skp/Tmap/DraggingAnimateThread$HasWork", ref java_class_handle);
				}
			}

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (HasWork); }
			}

			protected HasWork (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		}

		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/DraggingAnimateThread", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (DraggingAnimateThread); }
		}

		protected DraggingAnimateThread (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor_Lcom_skp_Tmap_TMapView_;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/constructor[@name='DraggingAnimateThread' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.TMapView']]"
		[Register (".ctor", "(Lcom/skp/Tmap/TMapView;)V", "")]
		public unsafe DraggingAnimateThread (global::Com.Skp.Tmap.TMapView p0)
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);
				if (((object) this).GetType () != typeof (DraggingAnimateThread)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Lcom/skp/Tmap/TMapView;)V", __args),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Lcom/skp/Tmap/TMapView;)V", __args);
					return;
				}

				if (id_ctor_Lcom_skp_Tmap_TMapView_ == IntPtr.Zero)
					id_ctor_Lcom_skp_Tmap_TMapView_ = JNIEnv.GetMethodID (class_ref, "<init>", "(Lcom/skp/Tmap/TMapView;)V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Lcom_skp_Tmap_TMapView_, __args),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Lcom_skp_Tmap_TMapView_, __args);
			} finally {
			}
		}

		static Delegate cb_getCallback;
#pragma warning disable 0169
		static Delegate GetGetCallbackHandler ()
		{
			if (cb_getCallback == null)
				cb_getCallback = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetCallback);
			return cb_getCallback;
		}

		static IntPtr n_GetCallback (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return JNIEnv.ToLocalJniHandle (__this.Callback);
		}
#pragma warning restore 0169

		static IntPtr id_getCallback;
		public virtual unsafe global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback Callback {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='getCallback' and count(parameter)=0]"
			[Register ("getCallback", "()Lcom/skp/Tmap/DraggingAnimateThread$DraggingCallback;", "GetGetCallbackHandler")]
			get {
				if (id_getCallback == IntPtr.Zero)
					id_getCallback = JNIEnv.GetMethodID (class_ref, "getCallback", "()Lcom/skp/Tmap/DraggingAnimateThread$DraggingCallback;");
				try {

					if (((object) this).GetType () == ThresholdType)
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getCallback), JniHandleOwnership.TransferLocalRef);
					else
						return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getCallback", "()Lcom/skp/Tmap/DraggingAnimateThread$DraggingCallback;")), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static Delegate cb_isDraggingAnimating;
#pragma warning disable 0169
		static Delegate GetIsDraggingAnimatingHandler ()
		{
			if (cb_isDraggingAnimating == null)
				cb_isDraggingAnimating = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_IsDraggingAnimating);
			return cb_isDraggingAnimating;
		}

		static bool n_IsDraggingAnimating (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.IsDraggingAnimating;
		}
#pragma warning restore 0169

		static IntPtr id_isDraggingAnimating;
		public virtual unsafe bool IsDraggingAnimating {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='isDraggingAnimating' and count(parameter)=0]"
			[Register ("isDraggingAnimating", "()Z", "GetIsDraggingAnimatingHandler")]
			get {
				if (id_isDraggingAnimating == IntPtr.Zero)
					id_isDraggingAnimating = JNIEnv.GetMethodID (class_ref, "isDraggingAnimating", "()Z");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_isDraggingAnimating);
					else
						return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "isDraggingAnimating", "()Z"));
				} finally {
				}
			}
		}

		static Delegate cb_getTargetLatitudeData;
#pragma warning disable 0169
		static Delegate GetGetTargetLatitudeDataHandler ()
		{
			if (cb_getTargetLatitudeData == null)
				cb_getTargetLatitudeData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetTargetLatitudeData);
			return cb_getTargetLatitudeData;
		}

		static double n_GetTargetLatitudeData (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.TargetLatitudeData;
		}
#pragma warning restore 0169

		static IntPtr id_getTargetLatitudeData;
		public virtual unsafe double TargetLatitudeData {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='getTargetLatitudeData' and count(parameter)=0]"
			[Register ("getTargetLatitudeData", "()D", "GetGetTargetLatitudeDataHandler")]
			get {
				if (id_getTargetLatitudeData == IntPtr.Zero)
					id_getTargetLatitudeData = JNIEnv.GetMethodID (class_ref, "getTargetLatitudeData", "()D");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallDoubleMethod (((global::Java.Lang.Object) this).Handle, id_getTargetLatitudeData);
					else
						return JNIEnv.CallNonvirtualDoubleMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getTargetLatitudeData", "()D"));
				} finally {
				}
			}
		}

		static Delegate cb_getTargetLongitudeData;
#pragma warning disable 0169
		static Delegate GetGetTargetLongitudeDataHandler ()
		{
			if (cb_getTargetLongitudeData == null)
				cb_getTargetLongitudeData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, double>) n_GetTargetLongitudeData);
			return cb_getTargetLongitudeData;
		}

		static double n_GetTargetLongitudeData (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.TargetLongitudeData;
		}
#pragma warning restore 0169

		static IntPtr id_getTargetLongitudeData;
		public virtual unsafe double TargetLongitudeData {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='getTargetLongitudeData' and count(parameter)=0]"
			[Register ("getTargetLongitudeData", "()D", "GetGetTargetLongitudeDataHandler")]
			get {
				if (id_getTargetLongitudeData == IntPtr.Zero)
					id_getTargetLongitudeData = JNIEnv.GetMethodID (class_ref, "getTargetLongitudeData", "()D");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallDoubleMethod (((global::Java.Lang.Object) this).Handle, id_getTargetLongitudeData);
					else
						return JNIEnv.CallNonvirtualDoubleMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getTargetLongitudeData", "()D"));
				} finally {
				}
			}
		}

		static Delegate cb_getTargetZoomLevel;
#pragma warning disable 0169
		static Delegate GetGetTargetZoomLevelHandler ()
		{
			if (cb_getTargetZoomLevel == null)
				cb_getTargetZoomLevel = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetTargetZoomLevel);
			return cb_getTargetZoomLevel;
		}

		static int n_GetTargetZoomLevel (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			return __this.TargetZoomLevel;
		}
#pragma warning restore 0169

		static IntPtr id_getTargetZoomLevel;
		public virtual unsafe int TargetZoomLevel {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='getTargetZoomLevel' and count(parameter)=0]"
			[Register ("getTargetZoomLevel", "()I", "GetGetTargetZoomLevelHandler")]
			get {
				if (id_getTargetZoomLevel == IntPtr.Zero)
					id_getTargetZoomLevel = JNIEnv.GetMethodID (class_ref, "getTargetZoomLevel", "()I");
				try {

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getTargetZoomLevel);
					else
						return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getTargetZoomLevel", "()I"));
				} finally {
				}
			}
		}

		static Delegate cb_draggingStart_FFFFFF;
#pragma warning disable 0169
		static Delegate GetDraggingStart_FFFFFFHandler ()
		{
			if (cb_draggingStart_FFFFFF == null)
				cb_draggingStart_FFFFFF = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float, float, float, float, float, float>) n_DraggingStart_FFFFFF);
			return cb_draggingStart_FFFFFF;
		}

		static void n_DraggingStart_FFFFFF (IntPtr jnienv, IntPtr native__this, float p0, float p1, float p2, float p3, float p4, float p5)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.DraggingStart (p0, p1, p2, p3, p4, p5);
		}
#pragma warning restore 0169

		static IntPtr id_draggingStart_FFFFFF;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='draggingStart' and count(parameter)=6 and parameter[1][@type='float'] and parameter[2][@type='float'] and parameter[3][@type='float'] and parameter[4][@type='float'] and parameter[5][@type='float'] and parameter[6][@type='float']]"
		[Register ("draggingStart", "(FFFFFF)V", "GetDraggingStart_FFFFFFHandler")]
		public virtual unsafe void DraggingStart (float p0, float p1, float p2, float p3, float p4, float p5)
		{
			if (id_draggingStart_FFFFFF == IntPtr.Zero)
				id_draggingStart_FFFFFF = JNIEnv.GetMethodID (class_ref, "draggingStart", "(FFFFFF)V");
			try {
				JValue* __args = stackalloc JValue [6];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);
				__args [3] = new JValue (p3);
				__args [4] = new JValue (p4);
				__args [5] = new JValue (p5);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_draggingStart_FFFFFF, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "draggingStart", "(FFFFFF)V"), __args);
			} finally {
			}
		}

		static Delegate cb_rotateStart_F;
#pragma warning disable 0169
		static Delegate GetRotateStart_FHandler ()
		{
			if (cb_rotateStart_F == null)
				cb_rotateStart_F = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float>) n_RotateStart_F);
			return cb_rotateStart_F;
		}

		static void n_RotateStart_F (IntPtr jnienv, IntPtr native__this, float p0)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.RotateStart (p0);
		}
#pragma warning restore 0169

		static IntPtr id_rotateStart_F;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='rotateStart' and count(parameter)=1 and parameter[1][@type='float']]"
		[Register ("rotateStart", "(F)V", "GetRotateStart_FHandler")]
		public virtual unsafe void RotateStart (float p0)
		{
			if (id_rotateStart_F == IntPtr.Zero)
				id_rotateStart_F = JNIEnv.GetMethodID (class_ref, "rotateStart", "(F)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_rotateStart_F, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "rotateStart", "(F)V"), __args);
			} finally {
			}
		}

		static Delegate cb_run;
#pragma warning disable 0169
		static Delegate GetRunHandler ()
		{
			if (cb_run == null)
				cb_run = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_Run);
			return cb_run;
		}

		static void n_Run (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.Run ();
		}
#pragma warning restore 0169

		static IntPtr id_run;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='run' and count(parameter)=0]"
		[Register ("run", "()V", "GetRunHandler")]
		public virtual unsafe void Run ()
		{
			if (id_run == IntPtr.Zero)
				id_run = JNIEnv.GetMethodID (class_ref, "run", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_run);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "run", "()V"));
			} finally {
			}
		}

		static Delegate cb_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_;
#pragma warning disable 0169
		static Delegate GetSetDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_Handler ()
		{
			if (cb_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_ == null)
				cb_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, IntPtr>) n_SetDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_);
			return cb_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_;
		}

		static void n_SetDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_ (IntPtr jnienv, IntPtr native__this, IntPtr native_p0)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback p0 = (global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback)global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback> (native_p0, JniHandleOwnership.DoNotTransfer);
			__this.SetDraggingCallback (p0);
		}
#pragma warning restore 0169

		static IntPtr id_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='setDraggingCallback' and count(parameter)=1 and parameter[1][@type='com.skp.Tmap.DraggingAnimateThread.DraggingCallback']]"
		[Register ("setDraggingCallback", "(Lcom/skp/Tmap/DraggingAnimateThread$DraggingCallback;)V", "GetSetDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_Handler")]
		public virtual unsafe void SetDraggingCallback (global::Com.Skp.Tmap.DraggingAnimateThread.IDraggingCallback p0)
		{
			if (id_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_ == IntPtr.Zero)
				id_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_ = JNIEnv.GetMethodID (class_ref, "setDraggingCallback", "(Lcom/skp/Tmap/DraggingAnimateThread$DraggingCallback;)V");
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (p0);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setDraggingCallback_Lcom_skp_Tmap_DraggingAnimateThread_DraggingCallback_, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setDraggingCallback", "(Lcom/skp/Tmap/DraggingAnimateThread$DraggingCallback;)V"), __args);
			} finally {
			}
		}

		static Delegate cb_startDraggingMoving_DDDDIIIFZ;
#pragma warning disable 0169
		static Delegate GetStartDraggingMoving_DDDDIIIFZHandler ()
		{
			if (cb_startDraggingMoving_DDDDIIIFZ == null)
				cb_startDraggingMoving_DDDDIIIFZ = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, double, double, double, double, int, int, int, float, bool>) n_StartDraggingMoving_DDDDIIIFZ);
			return cb_startDraggingMoving_DDDDIIIFZ;
		}

		static void n_StartDraggingMoving_DDDDIIIFZ (IntPtr jnienv, IntPtr native__this, double p0, double p1, double p2, double p3, int p4, int p5, int p6, float p7, bool p8)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.StartDraggingMoving (p0, p1, p2, p3, p4, p5, p6, p7, p8);
		}
#pragma warning restore 0169

		static IntPtr id_startDraggingMoving_DDDDIIIFZ;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='startDraggingMoving' and count(parameter)=9 and parameter[1][@type='double'] and parameter[2][@type='double'] and parameter[3][@type='double'] and parameter[4][@type='double'] and parameter[5][@type='int'] and parameter[6][@type='int'] and parameter[7][@type='int'] and parameter[8][@type='float'] and parameter[9][@type='boolean']]"
		[Register ("startDraggingMoving", "(DDDDIIIFZ)V", "GetStartDraggingMoving_DDDDIIIFZHandler")]
		public virtual unsafe void StartDraggingMoving (double p0, double p1, double p2, double p3, int p4, int p5, int p6, float p7, bool p8)
		{
			if (id_startDraggingMoving_DDDDIIIFZ == IntPtr.Zero)
				id_startDraggingMoving_DDDDIIIFZ = JNIEnv.GetMethodID (class_ref, "startDraggingMoving", "(DDDDIIIFZ)V");
			try {
				JValue* __args = stackalloc JValue [9];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);
				__args [2] = new JValue (p2);
				__args [3] = new JValue (p3);
				__args [4] = new JValue (p4);
				__args [5] = new JValue (p5);
				__args [6] = new JValue (p6);
				__args [7] = new JValue (p7);
				__args [8] = new JValue (p8);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_startDraggingMoving_DDDDIIIFZ, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "startDraggingMoving", "(DDDDIIIFZ)V"), __args);
			} finally {
			}
		}

		static Delegate cb_startDraggingZooming_FI;
#pragma warning disable 0169
		static Delegate GetStartDraggingZooming_FIHandler ()
		{
			if (cb_startDraggingZooming_FI == null)
				cb_startDraggingZooming_FI = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, float, int>) n_StartDraggingZooming_FI);
			return cb_startDraggingZooming_FI;
		}

		static void n_StartDraggingZooming_FI (IntPtr jnienv, IntPtr native__this, float p0, int p1)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.StartDraggingZooming (p0, p1);
		}
#pragma warning restore 0169

		static IntPtr id_startDraggingZooming_FI;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='startDraggingZooming' and count(parameter)=2 and parameter[1][@type='float'] and parameter[2][@type='int']]"
		[Register ("startDraggingZooming", "(FI)V", "GetStartDraggingZooming_FIHandler")]
		public virtual unsafe void StartDraggingZooming (float p0, int p1)
		{
			if (id_startDraggingZooming_FI == IntPtr.Zero)
				id_startDraggingZooming_FI = JNIEnv.GetMethodID (class_ref, "startDraggingZooming", "(FI)V");
			try {
				JValue* __args = stackalloc JValue [2];
				__args [0] = new JValue (p0);
				__args [1] = new JValue (p1);

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_startDraggingZooming_FI, __args);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "startDraggingZooming", "(FI)V"), __args);
			} finally {
			}
		}

		static Delegate cb_stopDraggingAnimating;
#pragma warning disable 0169
		static Delegate GetStopDraggingAnimatingHandler ()
		{
			if (cb_stopDraggingAnimating == null)
				cb_stopDraggingAnimating = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_StopDraggingAnimating);
			return cb_stopDraggingAnimating;
		}

		static void n_StopDraggingAnimating (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.StopDraggingAnimating ();
		}
#pragma warning restore 0169

		static IntPtr id_stopDraggingAnimating;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='stopDraggingAnimating' and count(parameter)=0]"
		[Register ("stopDraggingAnimating", "()V", "GetStopDraggingAnimatingHandler")]
		public virtual unsafe void StopDraggingAnimating ()
		{
			if (id_stopDraggingAnimating == IntPtr.Zero)
				id_stopDraggingAnimating = JNIEnv.GetMethodID (class_ref, "stopDraggingAnimating", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_stopDraggingAnimating);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "stopDraggingAnimating", "()V"));
			} finally {
			}
		}

		static Delegate cb_stopDraggingAnimatingSync;
#pragma warning disable 0169
		static Delegate GetStopDraggingAnimatingSyncHandler ()
		{
			if (cb_stopDraggingAnimatingSync == null)
				cb_stopDraggingAnimatingSync = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr>) n_StopDraggingAnimatingSync);
			return cb_stopDraggingAnimatingSync;
		}

		static void n_StopDraggingAnimatingSync (IntPtr jnienv, IntPtr native__this)
		{
			global::Com.Skp.Tmap.DraggingAnimateThread __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.DraggingAnimateThread> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
			__this.StopDraggingAnimatingSync ();
		}
#pragma warning restore 0169

		static IntPtr id_stopDraggingAnimatingSync;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='DraggingAnimateThread']/method[@name='stopDraggingAnimatingSync' and count(parameter)=0]"
		[Register ("stopDraggingAnimatingSync", "()V", "GetStopDraggingAnimatingSyncHandler")]
		public virtual unsafe void StopDraggingAnimatingSync ()
		{
			if (id_stopDraggingAnimatingSync == IntPtr.Zero)
				id_stopDraggingAnimatingSync = JNIEnv.GetMethodID (class_ref, "stopDraggingAnimatingSync", "()V");
			try {

				if (((object) this).GetType () == ThresholdType)
					JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_stopDraggingAnimatingSync);
				else
					JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "stopDraggingAnimatingSync", "()V"));
			} finally {
			}
		}

	}
}
