using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Com.Skp.Tmap {

	// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']"
	[global::Android.Runtime.Register ("com/skp/Tmap/TileSourceManager", DoNotGenerateAcw=true)]
	public partial class TileSourceManager : global::Java.Lang.Object {

		// Metadata.xml XPath class reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']"
		[global::Android.Runtime.Register ("com/skp/Tmap/TileSourceManager$TileOriginTemplate", DoNotGenerateAcw=true)]
		public partial class TileOriginTemplate : global::Java.Lang.Object, global::Com.Skp.Tmap.ITileOrigin {


			static IntPtr mExt_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/field[@name='mExt']"
			[Register ("mExt")]
			protected string MExt {
				get {
					if (mExt_jfieldId == IntPtr.Zero)
						mExt_jfieldId = JNIEnv.GetFieldID (class_ref, "mExt", "Ljava/lang/String;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, mExt_jfieldId);
					return JNIEnv.GetString (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (mExt_jfieldId == IntPtr.Zero)
						mExt_jfieldId = JNIEnv.GetFieldID (class_ref, "mExt", "Ljava/lang/String;");
					IntPtr native_value = JNIEnv.NewString (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mExt_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr mMapUtils_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/field[@name='mMapUtils']"
			[Register ("mMapUtils")]
			protected global::Com.Skp.Tmap.MapUtils MMapUtils {
				get {
					if (mMapUtils_jfieldId == IntPtr.Zero)
						mMapUtils_jfieldId = JNIEnv.GetFieldID (class_ref, "mMapUtils", "Lcom/skp/Tmap/MapUtils;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, mMapUtils_jfieldId);
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapUtils> (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (mMapUtils_jfieldId == IntPtr.Zero)
						mMapUtils_jfieldId = JNIEnv.GetFieldID (class_ref, "mMapUtils", "Lcom/skp/Tmap/MapUtils;");
					IntPtr native_value = JNIEnv.ToLocalJniHandle (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mMapUtils_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr mTileSize_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/field[@name='mTileSize']"
			[Register ("mTileSize")]
			protected int MTileSize {
				get {
					if (mTileSize_jfieldId == IntPtr.Zero)
						mTileSize_jfieldId = JNIEnv.GetFieldID (class_ref, "mTileSize", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, mTileSize_jfieldId);
				}
				set {
					if (mTileSize_jfieldId == IntPtr.Zero)
						mTileSize_jfieldId = JNIEnv.GetFieldID (class_ref, "mTileSize", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mTileSize_jfieldId, value);
					} finally {
					}
				}
			}

			static IntPtr mUrlToLoad_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/field[@name='mUrlToLoad']"
			[Register ("mUrlToLoad")]
			protected string MUrlToLoad {
				get {
					if (mUrlToLoad_jfieldId == IntPtr.Zero)
						mUrlToLoad_jfieldId = JNIEnv.GetFieldID (class_ref, "mUrlToLoad", "Ljava/lang/String;");
					IntPtr __ret = JNIEnv.GetObjectField (((global::Java.Lang.Object) this).Handle, mUrlToLoad_jfieldId);
					return JNIEnv.GetString (__ret, JniHandleOwnership.TransferLocalRef);
				}
				set {
					if (mUrlToLoad_jfieldId == IntPtr.Zero)
						mUrlToLoad_jfieldId = JNIEnv.GetFieldID (class_ref, "mUrlToLoad", "Ljava/lang/String;");
					IntPtr native_value = JNIEnv.NewString (value);
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mUrlToLoad_jfieldId, native_value);
					} finally {
						JNIEnv.DeleteLocalRef (native_value);
					}
				}
			}

			static IntPtr mVIndexOrder_jfieldId;

			// Metadata.xml XPath field reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/field[@name='mVIndexOrder']"
			[Register ("mVIndexOrder")]
			protected int MVIndexOrder {
				get {
					if (mVIndexOrder_jfieldId == IntPtr.Zero)
						mVIndexOrder_jfieldId = JNIEnv.GetFieldID (class_ref, "mVIndexOrder", "I");
					return JNIEnv.GetIntField (((global::Java.Lang.Object) this).Handle, mVIndexOrder_jfieldId);
				}
				set {
					if (mVIndexOrder_jfieldId == IntPtr.Zero)
						mVIndexOrder_jfieldId = JNIEnv.GetFieldID (class_ref, "mVIndexOrder", "I");
					try {
						JNIEnv.SetField (((global::Java.Lang.Object) this).Handle, mVIndexOrder_jfieldId, value);
					} finally {
					}
				}
			}
			internal static new IntPtr java_class_handle;
			internal static new IntPtr class_ref {
				get {
					return JNIEnv.FindClass ("com/skp/Tmap/TileSourceManager$TileOriginTemplate", ref java_class_handle);
				}
			}

			protected override IntPtr ThresholdClass {
				get { return class_ref; }
			}

			protected override global::System.Type ThresholdType {
				get { return typeof (TileOriginTemplate); }
			}

			protected TileOriginTemplate (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

			static IntPtr id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIII;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/constructor[@name='TileSourceManager.TileOriginTemplate' and count(parameter)=8 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='int'] and parameter[5][@type='int'] and parameter[6][@type='int'] and parameter[7][@type='int'] and parameter[8][@type='int']]"
			[Register (".ctor", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIII)V", "")]
			public unsafe TileOriginTemplate (string p0, string p1, string p2, int p3, int p4, int p5, int p6, int p7)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p0 = JNIEnv.NewString (p0);
				IntPtr native_p1 = JNIEnv.NewString (p1);
				IntPtr native_p2 = JNIEnv.NewString (p2);
				try {
					JValue* __args = stackalloc JValue [8];
					__args [0] = new JValue (native_p0);
					__args [1] = new JValue (native_p1);
					__args [2] = new JValue (native_p2);
					__args [3] = new JValue (p3);
					__args [4] = new JValue (p4);
					__args [5] = new JValue (p5);
					__args [6] = new JValue (p6);
					__args [7] = new JValue (p7);
					if (((object) this).GetType () != typeof (TileOriginTemplate)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIII)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIII)V", __args);
						return;
					}

					if (id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIII == IntPtr.Zero)
						id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIII = JNIEnv.GetMethodID (class_ref, "<init>", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIII)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIII, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIII, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p0);
					JNIEnv.DeleteLocalRef (native_p1);
					JNIEnv.DeleteLocalRef (native_p2);
				}
			}

			static IntPtr id_ctor_Ljava_lang_String_Ljava_lang_String_;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/constructor[@name='TileSourceManager.TileOriginTemplate' and count(parameter)=2 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String']]"
			[Register (".ctor", "(Ljava/lang/String;Ljava/lang/String;)V", "")]
			public unsafe TileOriginTemplate (string p0, string p1)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p0 = JNIEnv.NewString (p0);
				IntPtr native_p1 = JNIEnv.NewString (p1);
				try {
					JValue* __args = stackalloc JValue [2];
					__args [0] = new JValue (native_p0);
					__args [1] = new JValue (native_p1);
					if (((object) this).GetType () != typeof (TileOriginTemplate)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Ljava/lang/String;Ljava/lang/String;)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Ljava/lang/String;Ljava/lang/String;)V", __args);
						return;
					}

					if (id_ctor_Ljava_lang_String_Ljava_lang_String_ == IntPtr.Zero)
						id_ctor_Ljava_lang_String_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "<init>", "(Ljava/lang/String;Ljava/lang/String;)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Ljava_lang_String_Ljava_lang_String_, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Ljava_lang_String_Ljava_lang_String_, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p0);
					JNIEnv.DeleteLocalRef (native_p1);
				}
			}

			static IntPtr id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIIIIZ;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/constructor[@name='TileSourceManager.TileOriginTemplate' and count(parameter)=10 and parameter[1][@type='java.lang.String'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String'] and parameter[4][@type='int'] and parameter[5][@type='int'] and parameter[6][@type='int'] and parameter[7][@type='int'] and parameter[8][@type='int'] and parameter[9][@type='int'] and parameter[10][@type='boolean']]"
			[Register (".ctor", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIIIIZ)V", "")]
			public unsafe TileOriginTemplate (string p0, string p1, string p2, int p3, int p4, int p5, int p6, int p7, int p8, bool p9)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p0 = JNIEnv.NewString (p0);
				IntPtr native_p1 = JNIEnv.NewString (p1);
				IntPtr native_p2 = JNIEnv.NewString (p2);
				try {
					JValue* __args = stackalloc JValue [10];
					__args [0] = new JValue (native_p0);
					__args [1] = new JValue (native_p1);
					__args [2] = new JValue (native_p2);
					__args [3] = new JValue (p3);
					__args [4] = new JValue (p4);
					__args [5] = new JValue (p5);
					__args [6] = new JValue (p6);
					__args [7] = new JValue (p7);
					__args [8] = new JValue (p8);
					__args [9] = new JValue (p9);
					if (((object) this).GetType () != typeof (TileOriginTemplate)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIIIIZ)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIIIIZ)V", __args);
						return;
					}

					if (id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIIIIZ == IntPtr.Zero)
						id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIIIIZ = JNIEnv.GetMethodID (class_ref, "<init>", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIIIIZ)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIIIIZ, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Ljava_lang_String_Ljava_lang_String_Ljava_lang_String_IIIIIIZ, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p0);
					JNIEnv.DeleteLocalRef (native_p1);
					JNIEnv.DeleteLocalRef (native_p2);
				}
			}

			static IntPtr id_ctor_Ljava_io_File_Ljava_lang_String_Ljava_lang_String_;
			// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/constructor[@name='TileSourceManager.TileOriginTemplate' and count(parameter)=3 and parameter[1][@type='java.io.File'] and parameter[2][@type='java.lang.String'] and parameter[3][@type='java.lang.String']]"
			[Register (".ctor", "(Ljava/io/File;Ljava/lang/String;Ljava/lang/String;)V", "")]
			public unsafe TileOriginTemplate (global::Java.IO.File p0, string p1, string p2)
				: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
			{
				if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
					return;

				IntPtr native_p1 = JNIEnv.NewString (p1);
				IntPtr native_p2 = JNIEnv.NewString (p2);
				try {
					JValue* __args = stackalloc JValue [3];
					__args [0] = new JValue (p0);
					__args [1] = new JValue (native_p1);
					__args [2] = new JValue (native_p2);
					if (((object) this).GetType () != typeof (TileOriginTemplate)) {
						SetHandle (
								global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "(Ljava/io/File;Ljava/lang/String;Ljava/lang/String;)V", __args),
								JniHandleOwnership.TransferLocalRef);
						global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "(Ljava/io/File;Ljava/lang/String;Ljava/lang/String;)V", __args);
						return;
					}

					if (id_ctor_Ljava_io_File_Ljava_lang_String_Ljava_lang_String_ == IntPtr.Zero)
						id_ctor_Ljava_io_File_Ljava_lang_String_Ljava_lang_String_ = JNIEnv.GetMethodID (class_ref, "<init>", "(Ljava/io/File;Ljava/lang/String;Ljava/lang/String;)V");
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor_Ljava_io_File_Ljava_lang_String_Ljava_lang_String_, __args),
							JniHandleOwnership.TransferLocalRef);
					JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor_Ljava_io_File_Ljava_lang_String_Ljava_lang_String_, __args);
				} finally {
					JNIEnv.DeleteLocalRef (native_p1);
					JNIEnv.DeleteLocalRef (native_p2);
				}
			}

			static Delegate cb_getAverageSize;
#pragma warning disable 0169
			static Delegate GetGetAverageSizeHandler ()
			{
				if (cb_getAverageSize == null)
					cb_getAverageSize = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetAverageSize);
				return cb_getAverageSize;
			}

			static int n_GetAverageSize (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.AverageSize;
			}
#pragma warning restore 0169

			static IntPtr id_getAverageSize;
			public virtual unsafe int AverageSize {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getAverageSize' and count(parameter)=0]"
				[Register ("getAverageSize", "()I", "GetGetAverageSizeHandler")]
				get {
					if (id_getAverageSize == IntPtr.Zero)
						id_getAverageSize = JNIEnv.GetMethodID (class_ref, "getAverageSize", "()I");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getAverageSize);
						else
							return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getAverageSize", "()I"));
					} finally {
					}
				}
			}

			static Delegate cb_getBaseMapEnable;
#pragma warning disable 0169
			static Delegate GetGetBaseMapEnableHandler ()
			{
				if (cb_getBaseMapEnable == null)
					cb_getBaseMapEnable = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_GetBaseMapEnable);
				return cb_getBaseMapEnable;
			}

			static bool n_GetBaseMapEnable (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.BaseMapEnable;
			}
#pragma warning restore 0169

			static IntPtr id_getBaseMapEnable;
			public virtual unsafe bool BaseMapEnable {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getBaseMapEnable' and count(parameter)=0]"
				[Register ("getBaseMapEnable", "()Z", "GetGetBaseMapEnableHandler")]
				get {
					if (id_getBaseMapEnable == IntPtr.Zero)
						id_getBaseMapEnable = JNIEnv.GetMethodID (class_ref, "getBaseMapEnable", "()Z");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_getBaseMapEnable);
						else
							return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getBaseMapEnable", "()Z"));
					} finally {
					}
				}
			}

			static Delegate cb_getBitDensityData;
#pragma warning disable 0169
			static Delegate GetGetBitDensityDataHandler ()
			{
				if (cb_getBitDensityData == null)
					cb_getBitDensityData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetBitDensityData);
				return cb_getBitDensityData;
			}

			static int n_GetBitDensityData (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.BitDensityData;
			}
#pragma warning restore 0169

			static IntPtr id_getBitDensityData;
			public virtual unsafe int BitDensityData {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getBitDensityData' and count(parameter)=0]"
				[Register ("getBitDensityData", "()I", "GetGetBitDensityDataHandler")]
				get {
					if (id_getBitDensityData == IntPtr.Zero)
						id_getBitDensityData = JNIEnv.GetMethodID (class_ref, "getBitDensityData", "()I");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getBitDensityData);
						else
							return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getBitDensityData", "()I"));
					} finally {
					}
				}
			}

			static Delegate cb_getFileName;
#pragma warning disable 0169
			static Delegate GetGetFileNameHandler ()
			{
				if (cb_getFileName == null)
					cb_getFileName = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetFileName);
				return cb_getFileName;
			}

			static IntPtr n_GetFileName (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return JNIEnv.NewString (__this.FileName);
			}
#pragma warning restore 0169

			static IntPtr id_getFileName;
			public virtual unsafe string FileName {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getFileName' and count(parameter)=0]"
				[Register ("getFileName", "()Ljava/lang/String;", "GetGetFileNameHandler")]
				get {
					if (id_getFileName == IntPtr.Zero)
						id_getFileName = JNIEnv.GetMethodID (class_ref, "getFileName", "()Ljava/lang/String;");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getFileName), JniHandleOwnership.TransferLocalRef);
						else
							return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getFileName", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
					} finally {
					}
				}
			}

			static Delegate cb_isTileDownLoad;
#pragma warning disable 0169
			static Delegate GetIsTileDownLoadHandler ()
			{
				if (cb_isTileDownLoad == null)
					cb_isTileDownLoad = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, bool>) n_IsTileDownLoad);
				return cb_isTileDownLoad;
			}

			static bool n_IsTileDownLoad (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.IsTileDownLoad;
			}
#pragma warning restore 0169

			static IntPtr id_isTileDownLoad;
			public virtual unsafe bool IsTileDownLoad {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='isTileDownLoad' and count(parameter)=0]"
				[Register ("isTileDownLoad", "()Z", "GetIsTileDownLoadHandler")]
				get {
					if (id_isTileDownLoad == IntPtr.Zero)
						id_isTileDownLoad = JNIEnv.GetMethodID (class_ref, "isTileDownLoad", "()Z");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallBooleanMethod (((global::Java.Lang.Object) this).Handle, id_isTileDownLoad);
						else
							return JNIEnv.CallNonvirtualBooleanMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "isTileDownLoad", "()Z"));
					} finally {
					}
				}
			}

			static Delegate cb_getMapUtils;
#pragma warning disable 0169
			static Delegate GetGetMapUtilsHandler ()
			{
				if (cb_getMapUtils == null)
					cb_getMapUtils = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetMapUtils);
				return cb_getMapUtils;
			}

			static IntPtr n_GetMapUtils (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return JNIEnv.ToLocalJniHandle (__this.MapUtils);
			}
#pragma warning restore 0169

			static IntPtr id_getMapUtils;
			public virtual unsafe global::Com.Skp.Tmap.MapUtils MapUtils {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getMapUtils' and count(parameter)=0]"
				[Register ("getMapUtils", "()Lcom/skp/Tmap/MapUtils;", "GetGetMapUtilsHandler")]
				get {
					if (id_getMapUtils == IntPtr.Zero)
						id_getMapUtils = JNIEnv.GetMethodID (class_ref, "getMapUtils", "()Lcom/skp/Tmap/MapUtils;");
					try {

						if (((object) this).GetType () == ThresholdType)
							return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapUtils> (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getMapUtils), JniHandleOwnership.TransferLocalRef);
						else
							return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.MapUtils> (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getMapUtils", "()Lcom/skp/Tmap/MapUtils;")), JniHandleOwnership.TransferLocalRef);
					} finally {
					}
				}
			}

			static Delegate cb_getMaximumZoom;
#pragma warning disable 0169
			static Delegate GetGetMaximumZoomHandler ()
			{
				if (cb_getMaximumZoom == null)
					cb_getMaximumZoom = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetMaximumZoom);
				return cb_getMaximumZoom;
			}

			static int n_GetMaximumZoom (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.MaximumZoom;
			}
#pragma warning restore 0169

			static IntPtr id_getMaximumZoom;
			public virtual unsafe int MaximumZoom {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getMaximumZoom' and count(parameter)=0]"
				[Register ("getMaximumZoom", "()I", "GetGetMaximumZoomHandler")]
				get {
					if (id_getMaximumZoom == IntPtr.Zero)
						id_getMaximumZoom = JNIEnv.GetMethodID (class_ref, "getMaximumZoom", "()I");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getMaximumZoom);
						else
							return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getMaximumZoom", "()I"));
					} finally {
					}
				}
			}

			static Delegate cb_getMinimumZoom;
#pragma warning disable 0169
			static Delegate GetGetMinimumZoomHandler ()
			{
				if (cb_getMinimumZoom == null)
					cb_getMinimumZoom = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetMinimumZoom);
				return cb_getMinimumZoom;
			}

			static int n_GetMinimumZoom (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.MinimumZoom;
			}
#pragma warning restore 0169

			static Delegate cb_setMinimumZoom_I;
#pragma warning disable 0169
			static Delegate GetSetMinimumZoom_IHandler ()
			{
				if (cb_setMinimumZoom_I == null)
					cb_setMinimumZoom_I = JNINativeWrapper.CreateDelegate ((Action<IntPtr, IntPtr, int>) n_SetMinimumZoom_I);
				return cb_setMinimumZoom_I;
			}

			static void n_SetMinimumZoom_I (IntPtr jnienv, IntPtr native__this, int p0)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				__this.MinimumZoom = p0;
			}
#pragma warning restore 0169

			static IntPtr id_getMinimumZoom;
			static IntPtr id_setMinimumZoom_I;
			public virtual unsafe int MinimumZoom {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getMinimumZoom' and count(parameter)=0]"
				[Register ("getMinimumZoom", "()I", "GetGetMinimumZoomHandler")]
				get {
					if (id_getMinimumZoom == IntPtr.Zero)
						id_getMinimumZoom = JNIEnv.GetMethodID (class_ref, "getMinimumZoom", "()I");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getMinimumZoom);
						else
							return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getMinimumZoom", "()I"));
					} finally {
					}
				}
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='setMinimumZoom' and count(parameter)=1 and parameter[1][@type='int']]"
				[Register ("setMinimumZoom", "(I)V", "GetSetMinimumZoom_IHandler")]
				set {
					if (id_setMinimumZoom_I == IntPtr.Zero)
						id_setMinimumZoom_I = JNIEnv.GetMethodID (class_ref, "setMinimumZoom", "(I)V");
					try {
						JValue* __args = stackalloc JValue [1];
						__args [0] = new JValue (value);

						if (((object) this).GetType () == ThresholdType)
							JNIEnv.CallVoidMethod (((global::Java.Lang.Object) this).Handle, id_setMinimumZoom_I, __args);
						else
							JNIEnv.CallNonvirtualVoidMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "setMinimumZoom", "(I)V"), __args);
					} finally {
					}
				}
			}

			static Delegate cb_getTileFormatData;
#pragma warning disable 0169
			static Delegate GetGetTileFormatDataHandler ()
			{
				if (cb_getTileFormatData == null)
					cb_getTileFormatData = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetTileFormatData);
				return cb_getTileFormatData;
			}

			static IntPtr n_GetTileFormatData (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return JNIEnv.NewString (__this.TileFormatData);
			}
#pragma warning restore 0169

			static IntPtr id_getTileFormatData;
			public virtual unsafe string TileFormatData {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getTileFormatData' and count(parameter)=0]"
				[Register ("getTileFormatData", "()Ljava/lang/String;", "GetGetTileFormatDataHandler")]
				get {
					if (id_getTileFormatData == IntPtr.Zero)
						id_getTileFormatData = JNIEnv.GetMethodID (class_ref, "getTileFormatData", "()Ljava/lang/String;");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getTileFormatData), JniHandleOwnership.TransferLocalRef);
						else
							return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getTileFormatData", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
					} finally {
					}
				}
			}

			static Delegate cb_getTileSizeValue;
#pragma warning disable 0169
			static Delegate GetGetTileSizeValueHandler ()
			{
				if (cb_getTileSizeValue == null)
					cb_getTileSizeValue = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetTileSizeValue);
				return cb_getTileSizeValue;
			}

			static int n_GetTileSizeValue (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.TileSizeValue;
			}
#pragma warning restore 0169

			static IntPtr id_getTileSizeValue;
			public virtual unsafe int TileSizeValue {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getTileSizeValue' and count(parameter)=0]"
				[Register ("getTileSizeValue", "()I", "GetGetTileSizeValueHandler")]
				get {
					if (id_getTileSizeValue == IntPtr.Zero)
						id_getTileSizeValue = JNIEnv.GetMethodID (class_ref, "getTileSizeValue", "()I");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getTileSizeValue);
						else
							return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getTileSizeValue", "()I"));
					} finally {
					}
				}
			}

			static Delegate cb_getUrlTemplate;
#pragma warning disable 0169
			static Delegate GetGetUrlTemplateHandler ()
			{
				if (cb_getUrlTemplate == null)
					cb_getUrlTemplate = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, IntPtr>) n_GetUrlTemplate);
				return cb_getUrlTemplate;
			}

			static IntPtr n_GetUrlTemplate (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return JNIEnv.NewString (__this.UrlTemplate);
			}
#pragma warning restore 0169

			static IntPtr id_getUrlTemplate;
			public virtual unsafe string UrlTemplate {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getUrlTemplate' and count(parameter)=0]"
				[Register ("getUrlTemplate", "()Ljava/lang/String;", "GetGetUrlTemplateHandler")]
				get {
					if (id_getUrlTemplate == IntPtr.Zero)
						id_getUrlTemplate = JNIEnv.GetMethodID (class_ref, "getUrlTemplate", "()Ljava/lang/String;");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getUrlTemplate), JniHandleOwnership.TransferLocalRef);
						else
							return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getUrlTemplate", "()Ljava/lang/String;")), JniHandleOwnership.TransferLocalRef);
					} finally {
					}
				}
			}

			static Delegate cb_getVIndexOrder;
#pragma warning disable 0169
			static Delegate GetGetVIndexOrderHandler ()
			{
				if (cb_getVIndexOrder == null)
					cb_getVIndexOrder = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int>) n_GetVIndexOrder);
				return cb_getVIndexOrder;
			}

			static int n_GetVIndexOrder (IntPtr jnienv, IntPtr native__this)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return __this.VIndexOrder;
			}
#pragma warning restore 0169

			static IntPtr id_getVIndexOrder;
			public virtual unsafe int VIndexOrder {
				// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getVIndexOrder' and count(parameter)=0]"
				[Register ("getVIndexOrder", "()I", "GetGetVIndexOrderHandler")]
				get {
					if (id_getVIndexOrder == IntPtr.Zero)
						id_getVIndexOrder = JNIEnv.GetMethodID (class_ref, "getVIndexOrder", "()I");
					try {

						if (((object) this).GetType () == ThresholdType)
							return JNIEnv.CallIntMethod (((global::Java.Lang.Object) this).Handle, id_getVIndexOrder);
						else
							return JNIEnv.CallNonvirtualIntMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getVIndexOrder", "()I"));
					} finally {
					}
				}
			}

			static Delegate cb_getUrlLoadData_III;
#pragma warning disable 0169
			static Delegate GetGetUrlLoadData_IIIHandler ()
			{
				if (cb_getUrlLoadData_III == null)
					cb_getUrlLoadData_III = JNINativeWrapper.CreateDelegate ((Func<IntPtr, IntPtr, int, int, int, IntPtr>) n_GetUrlLoadData_III);
				return cb_getUrlLoadData_III;
			}

			static IntPtr n_GetUrlLoadData_III (IntPtr jnienv, IntPtr native__this, int p0, int p1, int p2)
			{
				global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate __this = global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (jnienv, native__this, JniHandleOwnership.DoNotTransfer);
				return JNIEnv.NewString (__this.GetUrlLoadData (p0, p1, p2));
			}
#pragma warning restore 0169

			static IntPtr id_getUrlLoadData_III;
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager.TileOriginTemplate']/method[@name='getUrlLoadData' and count(parameter)=3 and parameter[1][@type='int'] and parameter[2][@type='int'] and parameter[3][@type='int']]"
			[Register ("getUrlLoadData", "(III)Ljava/lang/String;", "GetGetUrlLoadData_IIIHandler")]
			public virtual unsafe string GetUrlLoadData (int p0, int p1, int p2)
			{
				if (id_getUrlLoadData_III == IntPtr.Zero)
					id_getUrlLoadData_III = JNIEnv.GetMethodID (class_ref, "getUrlLoadData", "(III)Ljava/lang/String;");
				try {
					JValue* __args = stackalloc JValue [3];
					__args [0] = new JValue (p0);
					__args [1] = new JValue (p1);
					__args [2] = new JValue (p2);

					if (((object) this).GetType () == ThresholdType)
						return JNIEnv.GetString (JNIEnv.CallObjectMethod (((global::Java.Lang.Object) this).Handle, id_getUrlLoadData_III, __args), JniHandleOwnership.TransferLocalRef);
					else
						return JNIEnv.GetString (JNIEnv.CallNonvirtualObjectMethod (((global::Java.Lang.Object) this).Handle, ThresholdClass, JNIEnv.GetMethodID (ThresholdClass, "getUrlLoadData", "(III)Ljava/lang/String;"), __args), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}

		}

		internal static new IntPtr java_class_handle;
		internal static new IntPtr class_ref {
			get {
				return JNIEnv.FindClass ("com/skp/Tmap/TileSourceManager", ref java_class_handle);
			}
		}

		protected override IntPtr ThresholdClass {
			get { return class_ref; }
		}

		protected override global::System.Type ThresholdType {
			get { return typeof (TileSourceManager); }
		}

		protected TileSourceManager (IntPtr javaReference, JniHandleOwnership transfer) : base (javaReference, transfer) {}

		static IntPtr id_ctor;
		// Metadata.xml XPath constructor reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/constructor[@name='TileSourceManager' and count(parameter)=0]"
		[Register (".ctor", "()V", "")]
		public unsafe TileSourceManager ()
			: base (IntPtr.Zero, JniHandleOwnership.DoNotTransfer)
		{
			if (((global::Java.Lang.Object) this).Handle != IntPtr.Zero)
				return;

			try {
				if (((object) this).GetType () != typeof (TileSourceManager)) {
					SetHandle (
							global::Android.Runtime.JNIEnv.StartCreateInstance (((object) this).GetType (), "()V"),
							JniHandleOwnership.TransferLocalRef);
					global::Android.Runtime.JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, "()V");
					return;
				}

				if (id_ctor == IntPtr.Zero)
					id_ctor = JNIEnv.GetMethodID (class_ref, "<init>", "()V");
				SetHandle (
						global::Android.Runtime.JNIEnv.StartCreateInstance (class_ref, id_ctor),
						JniHandleOwnership.TransferLocalRef);
				JNIEnv.FinishCreateInstance (((global::Java.Lang.Object) this).Handle, class_ref, id_ctor);
			} finally {
			}
		}

		static IntPtr id_getCNTileSource;
		public static unsafe global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate CNTileSource {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/method[@name='getCNTileSource' and count(parameter)=0]"
			[Register ("getCNTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;", "GetGetCNTileSourceHandler")]
			get {
				if (id_getCNTileSource == IntPtr.Zero)
					id_getCNTileSource = JNIEnv.GetStaticMethodID (class_ref, "getCNTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;");
				try {
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (JNIEnv.CallStaticObjectMethod  (class_ref, id_getCNTileSource), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static IntPtr id_getCONTileSource;
		public static unsafe global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate CONTileSource {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/method[@name='getCONTileSource' and count(parameter)=0]"
			[Register ("getCONTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;", "GetGetCONTileSourceHandler")]
			get {
				if (id_getCONTileSource == IntPtr.Zero)
					id_getCONTileSource = JNIEnv.GetStaticMethodID (class_ref, "getCONTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;");
				try {
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (JNIEnv.CallStaticObjectMethod  (class_ref, id_getCONTileSource), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static IntPtr id_getENGTileSource;
		public static unsafe global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate ENGTileSource {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/method[@name='getENGTileSource' and count(parameter)=0]"
			[Register ("getENGTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;", "GetGetENGTileSourceHandler")]
			get {
				if (id_getENGTileSource == IntPtr.Zero)
					id_getENGTileSource = JNIEnv.GetStaticMethodID (class_ref, "getENGTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;");
				try {
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (JNIEnv.CallStaticObjectMethod  (class_ref, id_getENGTileSource), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static IntPtr id_getHDTileSource;
		public static unsafe global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate HDTileSource {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/method[@name='getHDTileSource' and count(parameter)=0]"
			[Register ("getHDTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;", "GetGetHDTileSourceHandler")]
			get {
				if (id_getHDTileSource == IntPtr.Zero)
					id_getHDTileSource = JNIEnv.GetStaticMethodID (class_ref, "getHDTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;");
				try {
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (JNIEnv.CallStaticObjectMethod  (class_ref, id_getHDTileSource), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static IntPtr id_getNomalTileSource;
		public static unsafe global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate NomalTileSource {
			// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/method[@name='getNomalTileSource' and count(parameter)=0]"
			[Register ("getNomalTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;", "GetGetNomalTileSourceHandler")]
			get {
				if (id_getNomalTileSource == IntPtr.Zero)
					id_getNomalTileSource = JNIEnv.GetStaticMethodID (class_ref, "getNomalTileSource", "()Lcom/skp/Tmap/TileSourceManager$TileOriginTemplate;");
				try {
					return global::Java.Lang.Object.GetObject<global::Com.Skp.Tmap.TileSourceManager.TileOriginTemplate> (JNIEnv.CallStaticObjectMethod  (class_ref, id_getNomalTileSource), JniHandleOwnership.TransferLocalRef);
				} finally {
				}
			}
		}

		static IntPtr id_setBaseUrl_Ljava_lang_String_;
		// Metadata.xml XPath method reference: path="/api/package[@name='com.skp.Tmap']/class[@name='TileSourceManager']/method[@name='setBaseUrl' and count(parameter)=1 and parameter[1][@type='java.lang.String']]"
		[Register ("setBaseUrl", "(Ljava/lang/String;)V", "")]
		public static unsafe void SetBaseUrl (string p0)
		{
			if (id_setBaseUrl_Ljava_lang_String_ == IntPtr.Zero)
				id_setBaseUrl_Ljava_lang_String_ = JNIEnv.GetStaticMethodID (class_ref, "setBaseUrl", "(Ljava/lang/String;)V");
			IntPtr native_p0 = JNIEnv.NewString (p0);
			try {
				JValue* __args = stackalloc JValue [1];
				__args [0] = new JValue (native_p0);
				JNIEnv.CallStaticVoidMethod  (class_ref, id_setBaseUrl_Ljava_lang_String_, __args);
			} finally {
				JNIEnv.DeleteLocalRef (native_p0);
			}
		}

	}
}
